#include <std.h>
//old #include <sys/types.h>
//old #include <sys/wait.h>
//old #include <signal.h>

#include <func/messages.h>

#include <apt-pkg/orderlist.h>

#include "pkgmgrctrl.h"

//old pkgMgrCtrl::pkgMgrCtrl(int _sigfd, pkgDPkgPM &_PM) : PM(_PM), signalfd(_sigfd)
pkgMgrCtrl::pkgMgrCtrl(int _sigfd, pkgDepCache *Cache) : pkgDPkgPM(Cache), signalfd(_sigfd)
{
//old	pipe(in);
//old	pipe(out);
}

pkgMgrCtrl::~pkgMgrCtrl() 
{}
/*old
void pkgMgrCtrl::run()
{
	signal(SIGCHLD, sa_reaper);

	if (fork() == 0)
	{
		dup2(in[0], STDIN_FILENO);
		dup2(out[1], STDOUT_FILENO);
		close(STDERR_FILENO); // Hmm... 

//old		pkgPackageManager::OrderResult Res = PM.DoInstall();
		OrderResult Res = DoInstall();

//old		if (Res == pkgPackageManager::Failed || _error->PendingError() == true)
		if (Res == Failed || _error->PendingError() == true)
		{
			string s, q;
			while (_error->PendingError() == true)
			{	
				_error->PopMessage(q);
				s += "  * ";
				s += q;
				s += "\n";
			}
			TextMessage(signalfd, MsgId_PkgMgr_Warning, "\nPackage manager (dpkg) failed: \n\n%s", s.c_str());
	
		}
//old		else if (Res == pkgPackageManager::Completed)
		else if (Res == Completed)
			TextMessage(signalfd, MsgId_PkgMgr_Warning, "\nPackage manager (dpkg) succeeded.\n");

		MessageSend(signalfd, MsgId_PkgMgr_Stop, 0, 0);
	
		exit(0);
	}

	block();
}
*/

/*old
void pkgMgrCtrl::block()
{
	fd_set Rset;
	int highfd;
	char buf[BUFSIZ];
	long unsigned int len;
	MsgId mt;

	if (signalfd > out[0])
		highfd = signalfd;
	else
		highfd = out[0];
		
	while (1) {
		FD_ZERO(&Rset);
		FD_SET(signalfd, &Rset);
		FD_SET(out[0], &Rset);
		if (select(highfd + 1, &Rset, NULL, NULL, NULL) > 0) {
			if (FD_ISSET(signalfd, &Rset)) {
				MessageReceive(signalfd, mt, buf, len);
				if (mt == MsgId_PkgMgr_Input) {
					INFO(INFO_VERBOSE, "PKGMGR INPUT len = %d\n", len);
					write(in[1], buf, len);
				} else if (mt == MsgId_PkgMgr_Stop) {
					INFO(INFO_DEBUG, "Main thread told us that the package install is complete -- I obey\n");
					// Woohoo, package manager is done !!!! 
					// Mr sulu, get us out of here, MAXIMUM Warp! 
					break;
				}
			}
			else if (FD_ISSET(out[0], &Rset)) {
				len = read(out[0], buf, BUFSIZ);
				MessageSend(signalfd, MsgId_PkgMgr_Output, buf, len);
				INFO(INFO_VERBOSE, "PKGMGR OUTPUT len = %d\n", len);
			}
		}
	}
}
*/

/*old
void pkgMgrCtrl::sa_reaper(int sig)
{
	int status;
	// Wait for the child to go away
	wait(&status);
}
*/


pkgPackageManager::OrderResult pkgMgrCtrl::OrderInstall()
{
   if (CreateOrderList() == false)
      return Failed;

   Reset();
   
   if (Debug == true)
      clog << _("Begining to order") << endl;

   if (pkgPackageManager::List->OrderUnpack(FileNames) == false)
   {
      _error->Error(_("Internal ordering error"));
      return Failed;
   }
   
   if (Debug == true)
      clog << _("Done ordering") << endl;

   bool DoneSomething = false;
   
   int ID = 1;
   struct MsgItemDesc Data;
   
   for (pkgOrderList::iterator I = pkgPackageManager::List->begin(); I != pkgPackageManager::List->end(); I++, ID++)
   {
      PkgIterator Pkg(Cache,*I);

	  Data.FileSize = 1;
	  Data.ID = ID;
	  strncpy(Data.URI,         "", 200);
	  strncpy(Data.Description, "", 200);
	  strncpy(Data.ShortDesc,   "", 200);
//   	  MessageSend (signalfd, MsgId_Action_Start, &Data, sizeof(Data));
	  
      if (pkgPackageManager::List->IsNow(Pkg) == false)
      {
	 if (Debug == true)
	    clog << _("Skipping already done ") << Pkg.Name() << endl;
	 continue;
      }
      
      if (pkgPackageManager::List->IsMissing(Pkg) == true)
      {
	 if (Debug == true)
	    clog << _("Sequence completed at ") << Pkg.Name() << endl;
	 if (DoneSomething == false)
	 {
	    _error->Error(_("Internal Error, ordering was unable to handle the media swap"));
	    return Failed;
	 }	 
	 return Incomplete;
      }
      
      // Sanity check
      if (Cache[Pkg].Keep() == true && 
	  Pkg.State() == pkgCache::PkgIterator::NeedsNothing &&
	  (Cache[Pkg].iFlags & pkgDepCache::ReInstall) != pkgDepCache::ReInstall)
      {
	 _error->Error(_("Internal Error, trying to manipulate a kept package"));
	 return Failed;
      }
      
      // Perform a delete or an install
      if (Cache[Pkg].Delete() == true)
      {
	 if (SmartRemove(Pkg) == false)
	    return Failed;
      }
      else
	 if (SmartUnPack(Pkg) == false)
	    return Failed;
      DoneSomething = true;

//   	  MessageSend (signalfd, MsgId_Action_Complete, &Data, sizeof(Data));
   }
   
   // Final run through the configure phase
   if (ConfigureAll() == false)
      return Failed;

   // Sanity check
   for (pkgOrderList::iterator I = pkgPackageManager::List->begin(); I != pkgPackageManager::List->end(); I++)
   {
      if (pkgPackageManager::List->IsFlag(*I,pkgOrderList::Configured) == false)
      {
	 _error->Error(_("Internal error, packages left unconfigured. %s"),
		       PkgIterator(Cache,*I).Name());
	 return Failed;
      }
   }   
	 
   return Completed;
}

