/* $Id: answers.cc,v 1.4 2001/02/25 17:01:24 tausq Exp $ */
#ifdef USE_DEBCONF
#include "answers.h"
#include "util.h"

#include <stdio.h>

Answer::Answer(const char *_tag, const char *_value)
{
	tag = cppstrdup(_tag);
	value = cppstrdup(_value);
	next = 0;
}

Answer::~Answer()
{
	delete[] tag;
	delete[] value;
}

void Answer::print()
{
	printf(_("\tTag: %s\n"), tag);
	printf(_("\tValue: %s\n)", value ? value : _("(none)"));
}

AnswerList::AnswerList()
{
	answers = 0;
}

AnswerList::~AnswerList()
{
	Clear();
}

void AnswerList::Add(Answer *a)
{
	if (answers == 0)
		answers = a;
	else
	{
		Answer *c = answers;
		while (c->next != 0) c = c->next;
		c->next = a;
	}
}

void AnswerList::Clear()
{
	Answer *c = answers;
	while (c)
	{
		Answer *tmp = c;
		c = c->next;
		delete tmp;
	}
	answers = 0;
}
#endif
