/* $Id: backend.h,v 1.6 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _backend_H
#define _backend_H

#define DEBCONFIPCDIR		"/var/lib/debconf"
#define PRECONFIGURESCRIPT	"/usr/sbin/dpkg-preconfigure"
#define FRONTENDPARAMS		"--frontend=Passthrough"

class DebConfItf;

class DebConfBackend {
	DebConfItf &itf;
	int svr, client;

	struct Command {
		char *command;
		void (DebConfBackend::*fn)(char *params);
	};
	static Command Commands[];

	char buf[1024];
	char *bufptr;
	char socketfile[1024];
	unsigned int bufavail;

	bool status;
	bool connected;
	bool sawget;

	void SendToClient(char *fmt, ...);

	void DoCapb(char *);
	void DoInput(char *);
	void DoData(char *);
	void DoGo(char *);
	void DoGet(char *);
	void DoSet(char *);
	void DoTitle(char *);
	void DoStop(char *);

public:
	void Dispatch(const char *line);

	int Input(int fd);
	int GetServerFd() { return svr; }
	int GetClientFd() { return client; }

	bool operator!() { return !status; }

	DebConfBackend(DebConfItf &);
	~DebConfBackend();
};

bool DebConfPreconfigure(const char *deb);
#endif
