/* $Id: questions.h,v 1.3 2000/11/17 14:56:21 ltd Exp $ */
#ifndef __QUESTIONS_H__
#define __QUESTIONS_H__

struct Question {
	enum QuestionType {  
		QT_BOOLEAN,
		QT_NOTE,
		QT_STRING,
		QT_PASSWORD,
		QT_TEXT,
		QT_SELECT,
		QT_MULTISELECT
	};

	char *tag;
	QuestionType type;
	char *defaultval;
	char *desc;
	char *ext_desc;
	char *choices;
	
	Question *next;

	Question(const char *_tag);
	~Question();

	void SetType(const char *_type);
	void print();
};

class QuestionList {
	Question *questions;

public:
	Question *Add(const char *_tag);
	Question *Find(const char *_tag);
	void Clear();

	Question *Head() const { return questions; }

	QuestionList();
	~QuestionList();
};

#endif
