/* $Id: apt.cc,v 1.15 2001/05/15 08:32:58 ltd Exp $ */
#include <std.h>
#include <interface/edeityui.h>
#include <list/screens.h>
//old #include <sys/wait.h>
#include "apt.h"

edeitypkgcache *Cache = NULL;

edeitypkgcache::edeitypkgcache() : pkgCacheFile()
{
	Construct();
}

edeitypkgcache::~edeitypkgcache()
{
	Destruct();
}

void edeitypkgcache::Construct()
{
	OpProgress *progress = CaptUI->CreateProgressBar();
	
	// Read the sources list
	pkgSourceList List;
	List.ReadMainList();

	// Parse (if necessary) the package files
	pkgMakeStatusCache(List, *progress, NULL, true);

	progress->Done();

	bool WithLock;
	if (getuid() == 0)
		WithLock = true;
	else
		WithLock = false;

	Open(*progress, WithLock);

	// If there are errors we certainly need to know about them
	if (_error->PendingError() == true)
	{
		string Text;
		while (_error->PopMessage(Text) == true)
		{
			CaptUI->ShowDialog("Error", (char *)Text.c_str());
			if (CURRENTSCR != 0)
				CURRENTSCR->Redraw();
		}
		edeity_clean_exit();
		exit(-1);
	}

	Recs = new pkgRecords(*DCache);
	Fix = new pkgProblemResolver(DCache);

	delete progress;

	State.Read(*this);
}

void edeitypkgcache::Destruct()
{
	State.Write(*this);

	delete Recs;
	delete Fix;
}

void edeitypkgcache::Reinit()
{
	INFO(INFO_DEBUG, _("Apt Cache Reinit - Mark 1\n"));
	Destruct();
	Construct();
	INFO(INFO_DEBUG, _("Apt Cache Reinit - Mark 2\n"));
	for (Screen *s = CaptUI->scrlst.Head(); s != NULL; s = s->next)
	{
		s->Packages->reinitialize();
		s->InvalidateIterators();
		s->BoundsReset();
	}
	INFO(INFO_DEBUG, _("Apt Cache Reinit - Mark 3\n"));
}

