/* $Id: config.cc,v 1.21 2001/05/14 15:07:02 ltd Exp $ */
//old #include <stdio.h>
#include <fstream>
#include <vector>
//old #include <string.h>
#include <std.h>
#include <parsers/strutl.h>
#include <interface/edeityui.h>
#include "config.h"

using namespace std;

Config _Conf;

Config::param Config::valid_params[] =
{
	{ "edeity.fix_broken_packages",		_TRUE,		false },
	{ "edeity.sorting",			"3/4/1/2",	false },
	{ "edeity.columns",			"0/1/2/3/4/5",	false },
	{ "edeity.tree.headers.show",		_TRUE,		false },
	{ "edeity.tree.headers.expansion",	"0",		false },
	{ "edeity.tree.verbosity",		"high",		false },
	{ "edeity.acquire.embedded",		_FALSE,		false },
	{ "edeity.acquire.captris",		_FALSE,		false },
	{ "edeity.acquire.captris.score",	"0",		false },
	{ "edeity.description.show",		_FALSE,		false },
	{ "edeity.search.expand_matched_item_parents",	_TRUE,	false },
	{ "edeity.search.new_search_discards_old_items",	_TRUE,	false },
	{ "edeity.curses.color.default",		"white/black",	false },
	{ "edeity.curses.color.cursor",		"%reverse",	false },
	{ "edeity.curses.color.depends",	"%bold,black/cyan",	false },
	{ "edeity.curses.color.tree",	"%bold,green/black",	false },
	{ "edeity.curses.color.header",	"%bold,white/black",	false },
	{ "edeity.curses.color.curstate.kept",	"white/black",	false },
	{ "edeity.curses.color.curstate.installed", "%bold,white/black",	false },
	{ "edeity.curses.color.curstate.upgraded",	"green/black",	false },
	{ "edeity.curses.color.newstate.install", "%bold,yellow/black",	false },
	{ "edeity.curses.color.newstate.upgrade", "%bold,cyan/black",	false },
	{ "edeity.curses.color.newstate.remove",	"red/black",	false },
	{ "edeity.curses.color.newstate.purge",	"%bold,red/black",	false },
	{ "edeity.curses.color.matched_by_search", "black/red",	false },
	{ "edeity.curses.color.pkgmgr", "white/black",	false },
	{ "edeity.gtk.color.cursor",		"00000 00000 00000",	false }, // black
	{ "edeity.gtk.color.curstate.kept",	"65280 65280 65280",	false }, // white
	{ "edeity.gtk.color.curstate.upgraded",	"19968 60928 37888",	false }, // light sea green
	{ "edeity.gtk.color.curstate.not_upgraded", "00000 65280 00000",	false }, // strong green1
	{ "edeity.gtk.color.newstate.install",	"65280 60416 35584",	false }, // light yellow
	{ "edeity.gtk.color.newstate.upgrade",	"34560 52736 64000",	false }, // light sky blue
	{ "edeity.gtk.color.newstate.remove",	"65280 25344 18176",	false }, // light red
	{ "edeity.gtk.color.newstate.purge",	"65280 00000 00000",	false }, // strong red1
	{ "edeity.gtk.font.packages",		"-b&h-lucida-medium-r-normal-*-*-100-*-*-p-*-iso8859-1", false },
	{ "edeity.gtk.font.description",		"-b&h-lucidatypewriter-medium-r-normal-sans-10-*-100-100-m-*-iso8859-1", false },
	{ "edeity.gtk.tree.columnoffset.1", "0.20", false },
	{ "edeity.gtk.tree.columnoffset.2", "0.27", false },
	{ "edeity.gtk.tree.columnoffset.3", "0.34", false },
	{ "edeity.gtk.tree.columnoffset.4", "0.44", false },
	{ "edeity.gtk.tree.columnoffset.5", "0.54", false },
	{ "edeity.gtk.window.main.xsize",		"800", false },
	{ "edeity.gtk.window.main.ysize",		"600", false },
	{ "edeity.gtk.window.filterselect.xsize",		"400", false },
	{ "edeity.gtk.window.filterselect.ysize",		"300", false },
	{ NULL,	NULL,	false }
};

bool Config::Write(void)
{
	string filename;
	
	filename += getenv("HOME");
	filename += "/";
	filename += ".edeityrc";

	ofstream CCHandle(filename.c_str());

	if (!CCHandle.is_open())
		return false;

	for (struct param *p=valid_params; p->param_name != NULL; p++)
	{
		CCHandle << p->param_name << "=" << p->param_value << endl;
	}

	return true;
}

bool Config::Init(void)
{
	string filename;
	
	filename += getenv("HOME");
	filename += "/";
	filename += ".edeityrc";

	ifstream CCHandle(filename.c_str());

	if (!CCHandle.is_open())
		return false;

	string buffer;

	char buf[BUFSIZ], *x;

	while (1)
	{
		CCHandle.getline(buf, BUFSIZ-1, '\n');

		if (CCHandle.eof() == true)
			break;

		if ((x=strchr(buf, '\n'))) 
			*x=0;

		for(x=buf; *x != '=' && *x != 0; x++);

		if (*x == 0)
		{
			printf(_("initconfig() parse error: %s (must be name=value pair)\n"), buf);
			continue;
		}

		*x = 0;

		x++;

		if (*x == 0)
		{
			printf(_("initconfig() parse error: %s (must be name=value pair)\n"), buf);
			continue;
		}

		if (IsValid(buf) == false)
		{
			printf(_("initconfig(): invalid option: %s (do not edit the config yourself)\n"), buf);
			continue;
		}

		Set(buf, x);
	}

	return true;
}

char *Config::Get(char *name)
{
	for (struct param *p=valid_params; p->param_name != NULL; p++)
	{
		if (strcmp(name, p->param_name) == 0)
			return p->param_value;
	}

	if (CaptUI)
		delete CaptUI;

	fprintf(stderr, _("Config Item '%s' Referenced (But not defined)\n"), name);

	exit(-10);

	return NULL;
}

bool Config::Set(char *name, char *val)
{
	for (struct param *p=valid_params; p->param_name != NULL; p++)
	{
		if (strcmp(name, p->param_name) == 0)
		{
			if (p->override == true)
				free(p->param_value);
			else
				p->override = true;
			p->param_value = strdup(val);
			return true;
		}
	}

	return false;
}

bool Config::IsValid(char *name)
{
	for (struct param *p=valid_params; p->param_name != NULL; p++)
	{
		if (strcmp(name, p->param_name) == 0)
			return true;
	}

	return false;
}

bool Config::GetSplit(char *name, char *div, vector<string> & ret)
{
	char *val = Get(name);

	if (val == NULL)
		return false;

	ret.resize(0);

	for (char *p = sane_strtok(name, div); p != NULL; p = sane_strtok(NULL, div))
	{
		ret.resize(ret.size()+1);
		ret[ret.size()-1] = p;
	}

	return true;
}


