/* $Id: config.h,v 1.8 2001/03/24 08:08:32 ltd Exp $ */
#ifndef _config_h
#define _config_h

#define _TRUE  "1"
#define _FALSE "0"

#include <string>
#include <vector>

class Config
{
	struct param
	{
		char *param_name;
		char *param_value;
		bool override;
	};

	static param valid_params[];

public:
	class Iterator;
	friend class Iterator;
	
	bool Init();
	bool Write();

	bool Set(char *, char *);
	bool IsValid(char *);

	char *Get(char *);
	int GetInt(char *key) { char *val = Get(key); assert(val != NULL); return atoi(val); };
	double GetFloat(char *key) { char *val = Get(key); assert(val != NULL); return strtod(val, NULL); };
	bool GetBool(char *key) { char *val = Get(key); assert(val != NULL); return strcmp(Get(key), _TRUE) == 0; };
	bool GetSplit(char *, char *, vector<string> &);
};

class Config::Iterator
{
	struct param *me;

public:
	inline operator struct param & () { return *me; };
	inline struct param * operator -> () { return me; };
	
	void operator ++(int) { me++; };
	inline void operator ++() { operator ++(0); };

	bool valid() { return me->param_name != NULL; };

	Iterator(Config &c) { me = c.valid_params; };
};

extern Config _Conf;

#endif 
