
#ifndef keys_H
#define keys_H

class EDeityUI;
class Screen;
class KeyHandler
{
	public:
		struct List
		{
			typedef void (Screen::* scrfunc_t)(void);
			
			int key;
			void (*handlefunc)(Screen *);
			scrfunc_t scrfunc;
			char *KeyName;
			char *KeyDesc;
		};
		
		enum ListType {
			DefaultKeys,
			RestrictedKeys,
			N_Keys};
		
	private:
		Screen &screen;
		List *klptr;

	public:
		List *ListStart() { return klptr; };
		
		virtual bool DispatchKey(int);

//old		KeyHandler(Screen &scr, List *bindings) : screen(scr), klptr(bindings) {};
		KeyHandler(Screen &scr, enum ListType);
		virtual ~KeyHandler();
};

namespace DefaultKeys
{
//old	extern KeyHandler::List Bindings[];

	void screen_create_new(Screen *);
	void iterate_version(Screen *);
	void viewmode_toggle(Screen *);
	void dscroll_left(Screen *);
	void dscroll_right(Screen *);
	void search(Screen *);
	void descwin_toggle(Screen *);
	void depview_toggle(Screen *);
	void depend_toggle(Screen *);
	void reread_cache(Screen *);
	void update_lists(Screen *);
	void all_upgrade(Screen *);
	void dist_upgrade(Screen *);
	void pkg_remove(Screen *);
	void pkg_purge(Screen *);
	void pkg_reinstall(Screen *);
	void pkg_install(Screen *);
	void pkg_hold(Screen *);
	void clear_matched(Screen *);
	void complete_pending(Screen *);
	void quit(Screen *);
	void reset_markers(Screen *);
	void changed_packages(Screen *);
	void filter_add_single(Screen *);
	void filter_revoke_all(Screen *);
	void filter_display_all(Screen *);
	void filter_change_view(Screen *);
};

namespace RestrictedKeys
{
//old	extern KeyHandler::List Bindings[];
	
	void abort(Screen *);
	void complete(Screen *);
};

#endif
