/* $Id: messages.cc,v 1.4 2001/02/25 17:01:24 tausq Exp $ */
#include <std.h>
#include <func/messages.h>
//old #include <stdio.h>
#include <stdarg.h>

#include <interface/edeityui.h>

int MessageSend(int fd, MsgId type, const void *data, unsigned long len)
{
	if (fd < 0) return 0;
	if (write(fd, &type, sizeof(type)) != sizeof(type))
		return -1;
	if (write(fd, &len, sizeof(len)) != sizeof(len))
		return -1;
	if (len > 0 && write(fd, data, len) != signed(len))
		return -1;
		
	return 0;
}

int MessageReceive(int fd, MsgId &type, void *data, unsigned long &len)
{
	unsigned long maxlen = len;
	if (fd < 0) return 0;
	if (read(fd, &type, sizeof(type)) != sizeof(type))
		return -1;
	if (read(fd, &len, sizeof(len)) != sizeof(len))
		return -1;
	if (maxlen > 0 && len > maxlen) return -1;
	if (len > 0 && read(fd, data, len) != signed(len))
		return -1;

	return 0;
}

void TextMessage(int fd, MsgId type, const char *fmt, ...)
{
	va_list va;
	char buf[2000];

	va_start(va, fmt);
	vsnprintf(buf, sizeof(buf), fmt, va);
	va_end(va);

	MessageSend(fd, type, buf, strlen(buf));
}
