#ifndef _message_H
#define _message_H

//old #include <unistd.h>

enum MsgId 
{
	MsgId_Info = 1,
	MsgId_Error,

	MsgId_MediaChange,
	MsgId_MediaChange_Complete, // Main -> Acquire

	MsgId_Site_Hit,

	MsgId_Update,              // Inform main thread of our intention
	MsgId_Update_Item,         // for each worker set
	MsgId_Update_Total,        // total percentage information and data rate

	MsgId_Download_Start,
	MsgId_Download_Complete,
	MsgId_Download_Failed,

	MsgId_Acquire_Start,
	MsgId_Acquire_Stop,
	MsgId_Acquire_Fatal,
	MsgId_Acquire_Warning,
	MsgId_Acquire_Info,
	MsgId_Acquire_Shutdown, // After acquire has destructed

	MsgId_PkgMgr_Start,	// before dpkg is called // give things some time to happen
//old	MsgId_PkgMgr_Ready,	// Main -> Acquire to signal readiness 
	MsgId_PkgMgr_Stop, // after dpkg is called
	MsgId_PkgMgr_Warning, // Messages sent from the pm control -> ui
	MsgId_PkgMgr_Failed,
//old	MsgId_PkgMgr_Input, // Input data sent from UI -> pm control
//old	MsgId_PkgMgr_Output // Output data sent from pm control -> UI

	MsgId_Action_Start,
	MsgId_Action_Complete,
	MsgId_Action_Failed
};

struct MsgItemDesc
{
	unsigned long ID;
	char URI[200];
	char Description[200];
	char ShortDesc[200];
	unsigned long FileSize;
};

struct MsgItemFailed
{
	struct MsgItemDesc Itm;
	unsigned long Status;
	char ErrorText[200];
};

struct MsgDownloadItem
{
	unsigned long ID;
	char Status[100];
	char ShortDesc[100];
	unsigned long PartialSize;
	unsigned long FileSize;
	double Percent;
};

struct MsgDownloadTotal
{
	double CurrentBytes;
	double TotalBytes;
	unsigned long CurrentItems;
	unsigned long TotalItems;
	double Percent;
	double CurrentCPS;
	unsigned long ETA;
};

struct MsgMediaChange
{
	char Title[100];
	char Drive[100];
};

int MessageSend(int fd, MsgId type, const void *data, unsigned long len);
int MessageReceive(int fd, MsgId &type, void *data, unsigned long &len);
void TextMessage(int fd, MsgId type, const char *fmt, ...);

#endif

