
#include <std.h>
#include <func/apt.h>
#include "statecache.h"
#include <fstream>

using namespace std;

bool CaptStateCache::Write(edeitypkgcache & Cache)
{
	string filename;
	
	filename += getenv("HOME");
	filename += "/";
	filename += STATEFILE;

	ofstream Handle(filename.c_str());

	if (!Handle.is_open())
		return false;

	for (pkgCache::PkgIterator I = Cache->PkgBegin(); I.end() != true; I++)
	{
		if ((*Cache)[I].Install() == true)
			Handle << I.Name() << _(" install ") << I.VersionList().VerStr() << endl;
		else if ((*Cache)[I].Delete() == true && ((*Cache)[I].iFlags & pkgDepCache::Purge))
			Handle << I.Name() << _(" purge ") << I.VersionList().VerStr() << endl;
		else if ((*Cache)[I].Delete() == true)
			Handle << I.Name() << _(" delete ") << I.VersionList().VerStr() << endl;
	}

	return true;
}

bool CaptStateCache::Read(edeitypkgcache & Cache)
{
	string filename;
	
	filename += getenv("HOME");
	filename += "/";
	filename += STATEFILE;

	ifstream Handle(filename.c_str());

	if (!Handle.is_open())
		return false;

	string buffer;

	char buf[256], *x, *y;

	while (1)
	{
		Handle.getline(buf, 255, '\n');

		char *P;
		if ((P = strrchr(buf, '\n')))
			*P=0;

		if (Handle.eof() == true)
			break;

		for(x=buf; *x != ' ' && *x != 0; x++);

		if (*x == 0)
		{
			cerr << _("Capt state cache parser: no space seperation: '") << buf << "'\n";
			continue;
		}

		*x++ = 0;

		if (*x == 0)
		{
			cerr << _("Capt state cache parser: no data after space: '") << buf << " '\n";
			continue;
		}

		for(y=x; *y != ' ' && *y != 0; y++);

		if (*y == 0)
		{
			cerr << _("Capt state cache parser: no space seperation: '") << buf << "\n";
			continue;
		}

		*y++ = 0;

		if (*y == 0)
		{
			cerr << _("Capt state cache parser: no data after second space: '") << x << " '\n";
			continue;
		}

		pkgCache::PkgIterator I = Cache->FindPkg(buf);

		if (I.end() == true)
		{
			cerr << _("Capt state error: package '") << buf << _("' does not exist\n");
			continue;
		}

		pkgCache::VerIterator V;

		for (V = I.VersionList(); V.end() == false; V++)
			if (strcmp(V.VerStr(), y) == 0)
			{
				Cache->SetCandidateVersion(V);
				break;
			}

		if (V.end() == true)
		{
			cerr << _("Capt state error: version '") << y << _("' of package '") << buf << _("' does not exist\n");
			continue;
		}

		if (strcmp(x, _("install")) == 0)
			Cache->MarkInstall(I, false);
		else if (strcmp(x, _("delete")) == 0)
			Cache->MarkDelete(I, false);
		else if (strcmp(x, _("purge")) == 0)
			Cache->MarkDelete(I, true);
		else
			cerr << _("Capt state error: unknown state: '") << x << "'\n";

	}

	return true;
}
