/* $Id: tree.cc,v 1.7 2001/05/14 06:57:32 ltd Exp $ */
#include <cstdio>
#include <std.h>
#include <func/apt.h>
#include <list/pkgtree.h>
#include <list/screens.h>
#include <interface/edeityui.h>
#include "tree.h"

void depend_tree_expand(PackageTree::Item * Master, PackageTree &tree)
{
	PackageTree::Item * mal;

	pkgCache::DepIterator D;
//old	pkgCache::VerIterator V = Master->Version();

	(int) Master->State |= PackageTree::Item::Expanded;
	
//	for (D = V.DependsList(); D.end() == false; D++)
	for (D = tree.DepType() == PackageTree::NormDep ? Master->Depend() : Master->RevDepend(); !D.end(); D++)
	{
//old		mal = tree.add(&Master->child, Master);
		mal = tree.add(&Master->child, Master, NULL, NULL);

		if (strcmp(Master->TargetPkg.Name(), D.TargetPkg().Name()) == 0)
			(int) mal->State |= PackageTree::Item::Expanded;

		switch (tree.DepType())
		{
			case PackageTree::NormDep:
				mal->TargetPkg = D.TargetPkg();
				mal->Extra = new pkgCache::DepIterator(D);
				mal->Type = PackageTree::Item::Dep;
			break;
			
			case PackageTree::RevDep:
				mal->TargetPkg = D.ParentPkg();
				mal->Extra = new pkgCache::DepIterator(D.ParentPkg().RevDependsList());
				mal->Type = PackageTree::Item::RevDep;
			break;
			
			default:
			break;
		}		
		mal->increment = Master->increment + 1;
	}
}

void depend_tree_destruct(PackageTree::Item *x, PackageTree &tree)
{
	(int) x->State &= ~PackageTree::Item::Expanded;

	if (x->child)
		tree.FreeTree(x->child);
}
