/* $Id: cmd.h,v 1.3 2001/06/25 08:17:15 ltd Exp $ */
#ifndef _misc_H
#define _misc_H

#define bitcheck(x, y)        (x & y)
#define bitset(x, y)          (x |= y)
#define bitclear(x, y)        (x &= ~y)

#define CLP_NOEFF 0
#define CLP_EXIT  1

#include <regex.h>

class cmdLineParser
{
	enum cmdEnum { 
		cmdNone, cmdUpgrade, 
		cmdDistUpgrade, cmdUpdate, 
		cmdInstall, cmdReinstall, 
		cmdRemove, cmdPurge, 
		cmdKeep, cmdGo, cmdHelp };

private:
	bool UICreated;
	int _argc;
	char **_argv;

	/* Command Execution */
	bool Prepare(cmdEnum, string);
	void DoCommand(cmdEnum, pkgCache::PkgIterator &);
	
	/* Commands */
	void Upgrade();
	void DistUpgrade();
	void Update();
	void Run();

	/* Human Resources :) */
	void DisplayVersion();
	void DisplayHelp(char *);
	void InvalidOpt(char *, int);

	/* Convenience */
	void CreateUI();

public:
	int Parse();

	cmdLineParser(int argc, char **argv);
	~cmdLineParser();
};

#include "../func/keys.h"

int search_string(const char *, char *, unsigned long, regex_t *);

#endif /* _misc_H */
