/* $Id: acquire-ui.h,v 1.5 2001/05/23 22:41:12 ltd Exp $ */
#ifndef _curses_acquireUI_H
#define _curses_acquireUI_H

#define Subwin_X(x) (x)
#define Subwin_Y(y) (y-1)

#define FUI_COLOR_BACK         COLOR_BLUE
#define FUI_COLOR_BORDER       COLOR_YELLOW
#define FUI_COLOR_DEFAULT      COLOR_WHITE

#include <interface/acquireui.h>
#include <interface/curses/cursesui.h>

#include "captris.h"

class UniqueWindow;

class CursesUI::AcquireUI : public EDeityUI::AcquireUI
{
protected:
	friend class Captris;

	CursesUI & ui;

	bool windowsActive;
	bool wasAborted;

	int itemized_len_y, itemized_len_x, itemized_pos_y, itemized_pos_x;
	int output_len_y, output_len_x, output_pos_y, output_pos_x;
	int total_len_y, total_len_x, total_pos_y, total_pos_x;
	int extra_len_y, extra_len_x, extra_pos_y, extra_pos_x;
	
	UniqueWindow *output, *itemized, *total, *extra;

	Captris *Game;

	/* private methods */
	void CalibrateWindows();
	void DestroyWindows();
	void CleanUp();

	void PrintOutputF(char *, ...);

	void StartCaptris();
	void StopCaptris();
	void ViewInstall();
	void ViewRemove();

	// EDeityUI::AcquireUI hooks
	
	void DispatchKey(int key);

	void Startup();
	void Shutdown();
	void Refresh();

	void Message(const char *);

	void Start();
	void Stop();
	void IMSHit(const MsgItemDesc *M);
	void Fetch(const MsgItemDesc *M);
	void Done(const MsgItemDesc *M);
	void Fail(const MsgItemFailed *M);
	void MediaChange(const MsgMediaChange *M);

	void Update(const vector<MsgDownloadItem> *ItemList, const MsgDownloadTotal *Total);

public:
	AcquireUI(CursesUI &);
	~AcquireUI();
};

#endif
