/* $Id: colors.h,v 1.14 2001/05/14 15:07:02 ltd Exp $ */
#ifndef _curses_color_H
#define _curses_color_H

#include <ncurses.h>

#ifndef COLOR_PAIRS
#define COLOR_BLACK    0
#define COLOR_RED      1
#define COLOR_GREEN    2
#define COLOR_YELLOW   3
#define COLOR_BLUE     4
#define COLOR_MAGENTA  5
#define COLOR_CYAN     6
#define COLOR_WHITE    7
#endif

/*
 * Practical applcation color definitions
 */

#define EDEITY_COLOR_DEFAULT           COLOR_WHITE
#define EDEITY_COLOR_BACK              COLOR_BLACK
#define EDEITY_COLOR_DIVIDER_BACK      COLOR_BLACK

#define EDEITY_COLOR_DIVIDER_STATE     COLOR_WHITE
#define EDEITY_COLOR_DIVIDER_SECTION   COLOR_WHITE
#define EDEITY_COLOR_DIVIDER_PRIORITY  COLOR_WHITE
#define EDEITY_COLOR_DIVIDER_CUSTOM    COLOR_WHITE

#define EDEITY_COLOR_TOP_FG            COLOR_WHITE
#define EDEITY_COLOR_TOP_BG            COLOR_BLACK
#define EDEITY_COLOR_STAT_FG           COLOR_WHITE
#define EDEITY_COLOR_STAT_BG           COLOR_BLUE
#define EDEITY_COLOR_DESC_FG           COLOR_WHITE
#define EDEITY_COLOR_DESC_BG           COLOR_BLACK
#define EDEITY_COLOR_DTOP_FG           COLOR_WHITE
#define EDEITY_COLOR_DTOP_BG           COLOR_BLUE
#define EDEITY_COLOR_ACQPRG_BG_LEFT    COLOR_RED
#define EDEITY_COLOR_ACQPRG_TXT_LEFT   COLOR_WHITE
#define EDEITY_COLOR_ACQPRG_BG_RIGHT   COLOR_WHITE
#define EDEITY_COLOR_ACQPRG_TXT_RIGHT  COLOR_BLACK

#define EDEITY_COLOR_TREE_STEM         COLOR_GREEN
#define EDEITY_COLOR_TREE_NODE_FG      COLOR_WHITE
#define EDEITY_COLOR_TREE_NODE_BG      COLOR_BLACK

#define DLGPAIR                      _clrsys.regpair(COLOR_WHITE, COLOR_BLUE)

/* Config color attributes */

#define EDEITY_ATTR_DEFAULT           ("edeity.curses.color.default")
#define EDEITY_ATTR_HEADER            ("edeity.curses.color.header")
#define EDEITY_ATTR_DEPENDS           ("edeity.curses.color.depends")
#define EDEITY_ATTR_TREE              ("edeity.curses.color.tree")

#define EDEITY_ATTR_CURSOR            ("edeity.curses.color.cursor")
#define EDEITY_ATTR_AVAILABLE         ("edeity.curses.color.curstate.kept")
#define EDEITY_ATTR_INSTALLED         ("edeity.curses.color.curstate.installed")
#define EDEITY_ATTR_UPGRADED          ("edeity.curses.color.curstate.upgraded")
#define EDEITY_ATTR_INSTALL_MARK      ("edeity.curses.color.newstate.install")
#define EDEITY_ATTR_UPGRADE_MARK      ("edeity.curses.color.newstate.upgrade")
#define EDEITY_ATTR_REMOVE_MARK       ("edeity.curses.color.newstate.remove")
#define EDEITY_ATTR_PURGE_MARK        ("edeity.curses.color.newstate.purge")
#define EDEITY_ATTR_SEARCH_MATCH      ("edeity.curses.color.matched_by_search")
#define EDEITY_ATTR_PMGR              ("edeity.curses.color.pkgmgr")


#define MAX_PAIRS 256
#define ATTR_HASH_SIZE 100

class colour_system {
public:
	struct attribute {
		char *name;
		int attr;
	};
	struct c_pair {
		unsigned char fg, bg;
		int pair;
		c_pair(unsigned char f, unsigned char b, int _pair) : fg(f), bg(b), pair(_pair) {};
		c_pair() {};
	};
	struct attr_map_node {
		char *name;
		c_pair *curs_pair;
		int curs_attr;
		struct attr_map_node *next;
	};
private:
	int hash_size;
	c_pair *Pairs[MAX_PAIRS];
	attr_map_node **AttrMap;
	int PairCount;
public:
	attr_map_node *ParseConfigAttrib(const char *confitem);
	void attr_map_add(char *, attr_map_node *);
	void attr_map_bucket_add(attr_map_node **, attr_map_node *);
	int attr_map_hasher(char *);
	int regpair(int fg, int bg);
	c_pair *__regpair(int fg, int bg);
	//c_pair find_pair(int pairno);
	int operator [](char *attr_name);
	colour_system();
	~colour_system();
};

#endif
