/* $Id: cursesmnu.cc,v 1.9 2001/03/24 08:08:32 ltd Exp $ */
//old #include <std.h>
#include <list/screens.h>
#include <list/sorting.h>
#include "colors.h"
#include <func/keys.h>
#include "cursesui.h"
#include "cursesmnu.h"

#define _ALG ((COLS)/6)

//old #define FN_KEY(type, func, desc) \
//old	{ ::Screen::type, ::func, NULL, desc }
#define DEF_KEY(type, func, desc) \
	{ ::Screen::type, DefaultKeys::func, NULL, desc }
#define SCR_KEY(type, func, desc) \
	{ ::Screen::type, NULL, &Screen::func, desc }


CursesUI::MenuDrop::menu_item_list CursesUI::MenuDrop::mi[] =
{

//old	FN_KEY(M_Filters, filter_add_single, _("Add new filter")),
	DEF_KEY(M_Filters, filter_add_single, _("Add new filter")),
//old	FN_KEY(M_Filters, filter_revoke_all, _("Remove active filters")),
	DEF_KEY(M_Filters, filter_revoke_all, _("Remove active filters")),
//old	FN_KEY(M_Filters, filter_display_all, _("Display filter list")),
	DEF_KEY(M_Filters, filter_display_all, _("Display filter list")),
//old	FN_KEY(M_Filters, filter_change_view, _("Reverse filter polarity")),
	DEF_KEY(M_Filters, filter_change_view, _("Reverse filter polarity")),

	DEF_KEY(M_Modifiers, pkg_install, _("(Un)Mark pkg for install/upgrade")),
	DEF_KEY(M_Modifiers, pkg_remove, _("(Un)Mark pkg for remove")),
	DEF_KEY(M_Modifiers, pkg_purge, _("(Un)Mark pkg for purge")),
	DEF_KEY(M_Modifiers, all_upgrade, _("Perform a global package upgrade")),
	DEF_KEY(M_Modifiers, dist_upgrade, _("Perform a debian distribution upgrade")),

	SCR_KEY(M_Functions, HelpDialog, _("Display key bindings" )),
	DEF_KEY(M_Functions, complete_pending, _("Complete pending install/removals")),
	DEF_KEY(M_Functions, update_lists, _("Update available package lists")),
	DEF_KEY(M_Functions, reread_cache, _("Reinitialize the apt cache")),
	SCR_KEY(M_Functions, SortSelectMethod, _("Set tree sorting method(s)")),
	DEF_KEY(M_Functions, search, _("Search through the package list")),
	DEF_KEY(M_Functions, reset_markers, _("Reset items marked by search")),
	SCR_KEY(M_Functions, SeekNextMatched, _("Move to next search match")),
	DEF_KEY(M_Functions, quit, _("Quit program")),

	DEF_KEY(M_Toggles, depend_toggle, _("Package Dependencies")),
	DEF_KEY(M_Toggles, descwin_toggle, _("Description Window")),
	DEF_KEY(M_Toggles, viewmode_toggle, _("Verbosity of Tree View")),

	SCR_KEY(M_Movement, ArrowDown, _("Move to the next package")),
	SCR_KEY(M_Movement, ArrowUp, _("Move to the previous package")),
	SCR_KEY(M_Movement, SeekStart, _("Move to the start of the list")),
	SCR_KEY(M_Movement, SeekEnd, _("Move to the end of the list")),
	SCR_KEY(M_Movement, PageDown, _("Move down one screen length")),
	SCR_KEY(M_Movement, PageUp, _("Move up one screen length")),
	SCR_KEY(M_Movement, ArrowLeft, _("Scroll description left (Verbose only)")),
	SCR_KEY(M_Movement, ArrowRight, _("Scroll description right (Verbose only)")),
	SCR_KEY(M_Movement, ScrollDescUp, _("Scroll package description UP")),
	SCR_KEY(M_Movement, ScrollDescDown, _("Scroll package description DOWN")),
	SCR_KEY(M_Movement, DividerPrev, _("Move to the PREVIOUS package divider")),
	SCR_KEY(M_Movement, DividerNext, _("Move to the NEXT package divider")),
	{ (::Screen::Menu) -1,    NULL, NULL, NULL }
};

CursesUI::MenuDrop::MenuDrop(Menu M, Screen &scr) : CursesUI::Dialog(scr)
{
	Current = M;

	geometry(-1, -1, 1, _ALG * M);
	if (M == ::Screen::M_Sorting)
		sorting();
	else
		import_menu_items(M);
	initialize();
	Window->ChangeColor(CursesUI::_clrsys->regpair(COLOR_BLUE, COLOR_BLUE)|A_BOLD, CursesUI::_clrsys->regpair(COLOR_GREEN, COLOR_BLUE)|A_BOLD);
	drawall();
	Window->Refresh();
	select();
}

void CursesUI::MenuDrop::move_toward(Menu M)
{
	Current = M;

	deinitialize();
	geometry(-1, -1, 1, _ALG * M);
	clear_menu_items();
	if (M == ::Screen::M_Sorting)
		sorting();
	else
		import_menu_items(M);
	screen.RefreshCurrent();
	initialize();
	Window->ChangeColor(CursesUI::_clrsys->regpair(COLOR_BLUE, COLOR_BLUE)|A_BOLD, CursesUI::_clrsys->regpair(COLOR_GREEN, COLOR_BLUE)|A_BOLD);
	drawall();
	Window->Refresh();
}

void CursesUI::MenuDrop::clear_menu_items()
{
	free_memory();
}

bool CursesUI::MenuDrop::external_key_handler(int key)
{
	if (key == KEY_RIGHT)
	{
		switch (Current)
		{
			case ::Screen::M_Functions:
				move_toward(::Screen::M_Movement);
				break;
			case ::Screen::M_Movement:
				move_toward(::Screen::M_Toggles);
				break;
			case ::Screen::M_Toggles:
				move_toward(::Screen::M_Modifiers);
				break;
			case ::Screen::M_Modifiers:
				move_toward(::Screen::M_Filters);
				break;
			case ::Screen::M_Filters:
				move_toward(::Screen::M_Sorting);
				break;
			case ::Screen::M_Sorting:
				move_toward(::Screen::M_Functions);
				break;
		}
	}
	else if (key == KEY_LEFT)
	{
		switch (Current)
		{
			case ::Screen::M_Functions:
				move_toward(::Screen::M_Sorting);
				break;
			case ::Screen::M_Movement:
				move_toward(::Screen::M_Functions);
				break;
			case ::Screen::M_Toggles:
				move_toward(::Screen::M_Movement);
				break;
			case ::Screen::M_Modifiers:
				move_toward(::Screen::M_Toggles);
				break;
			case ::Screen::M_Filters:
				move_toward(::Screen::M_Modifiers);
				break;
			case ::Screen::M_Sorting:
				move_toward(::Screen::M_Filters);
				break;
		}
	} 
	else if (key == '\n')
	{
		if (Selection()->handler != NULL)
		{
			(*Selection()->handler)(key);
			return false;
		}
	}
	else if (key == ' ')
		if (Selection()->handler != NULL)
		{
			(*Selection()->handler)(key);
			clear_menu_items();
			sorting();
			screen.RefreshCurrent();
			complete_redraw();
		}

	return true;
}

void CursesUI::MenuDrop::import_menu_items(Menu M)
{
	// TODO: fix this....
	for (menu_item_list *P = mi; P->caption != NULL; P++)
		if (M == P->menu) {
			if (P->binding)
				addline(P->caption, P->binding);
			else if (P->uifunc)
				addline(P->caption,  P->uifunc);
		}
}

void CursesUI::MenuDrop::sort_toggle_section(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Section);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Section);
		screen->Packages->Sorting->Push(SortOrderList::Section, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}
			
void CursesUI::MenuDrop::sort_toggle_priority(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Priority);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Priority);
		screen->Packages->Sorting->Push(SortOrderList::Priority, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sort_toggle_state(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Status);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Status);
		screen->Packages->Sorting->Push(SortOrderList::Status, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sort_toggle_pkgname(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::PkgName);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::PkgName);
		screen->Packages->Sorting->Push(SortOrderList::PkgName, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sort_toggle_size(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Size);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Size);
		screen->Packages->Sorting->Push(SortOrderList::Size, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sort_toggle_instsize(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Instsize);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Instsize);
		screen->Packages->Sorting->Push(SortOrderList::Instsize, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sort_toggle_suite(::Screen *screen)
{
	SortOrderList::SortIterator S = screen->Packages->Sorting->ListFind(SortOrderList::Suite);
	if (S.end() == true)
//old	screen->Packages->Sorting->Push(SortOrderList::Suite);
		screen->Packages->Sorting->Push(SortOrderList::Suite, false);
	else
		screen->Packages->Sorting->remove(S);

	screen->Packages->reinitialize();
	screen->BoundsReset();
	screen->RedrawTree();
}

void CursesUI::MenuDrop::sorting(void)
{
	if (screen.Packages->Sorting->Exists(SortOrderList::Section))
		addline(_("[$3#X$!] Section"), &sort_toggle_section);
	else
		addline(_("[ ] Section"), &sort_toggle_section);

	if (screen.Packages->Sorting->Exists(SortOrderList::Priority))
		addline(_("[$3#X$!] Priority"), &sort_toggle_priority);
	else
		addline(_("[ ] Priority"), &sort_toggle_priority);

	if (screen.Packages->Sorting->Exists(SortOrderList::Status))
		addline(_("[$3#X$!] State"), &sort_toggle_state);
	else
		addline(_("[ ] State"), &sort_toggle_state);

	if (screen.Packages->Sorting->Exists(SortOrderList::PkgName))
		addline(_("[$3#X$!] Pkg Name"), &sort_toggle_pkgname);
	else
		addline(_("[ ] Pkg Name"), &sort_toggle_pkgname);

	if (screen.Packages->Sorting->Exists(SortOrderList::Size))
		addline(_("[$3#X$!] Arch Size"), &sort_toggle_size);
	else
		addline(_("[ ] Arch Size"), &sort_toggle_size);

	if (screen.Packages->Sorting->Exists(SortOrderList::Instsize))
		addline(_("[$3#X$!] Inst Size"), &sort_toggle_instsize);
	else
		addline(_("[ ] Inst Size"), &sort_toggle_instsize);

	if (screen.Packages->Sorting->Exists(SortOrderList::Suite))
		addline(_("[$3#X$!] Suite"), &sort_toggle_suite);
	else
		addline(_("[ ] Suite"), &sort_toggle_suite);
}

#ifdef HAVE_LIBGPM
int CursesUI::MenuDrop::gpm_handler(Gpm_Event *event)
{
	if (Gpm_StrictSingle(event->type))
	{
		for (unsigned I = bound_start; I < bound_end; I++)
		{
			unsigned K = I - bound_start;
	
			if (((sy + 2 + K) == event->y) &&
				(sx + 2 <= event->x && event->x <= sx + lx - 1))
			{
				cursor = I;
				drawall();
			}
		}
	}
	else if (Gpm_StrictDouble(event->type))
	{
		for (unsigned I = bound_start; I < bound_end; I++)
		{
			unsigned K = I - bound_start;
	
			if (((sy + 2 + K) == event->y) &&
				(sx + 2 <= event->x && event->x <= sx + lx - 1))
					return -1;
		}
		return -2;
	}
	
	return 0;
}
#endif
