/* $Id: cursesmnu.h,v 1.4 2001/03/24 08:08:32 ltd Exp $ */
#ifndef _menu_H
#define _menu_H

#ifdef HAVE_LIBGPM
#include <gpm.h>
#endif

#include <list/screens.h>

#include "cursesdlg.h"

class CursesUI::MenuDrop : public CursesUI::Dialog
{
	typedef ::Screen::Menu Menu;

	public:
		Menu Current;

		struct menu_item_list
		{ 
			typedef void (::Screen::* uifunc_t)(void);

			Menu menu;
			void (*binding)(::Screen *);
			uifunc_t uifunc;
			const char *caption;
		};

	private:
		static menu_item_list mi[];

		void move_toward(Menu);
		void clear_menu_items();
		void import_menu_items(Menu);
		void sorting();

		static void sort_toggle_section(::Screen *);
		static void sort_toggle_priority(::Screen *);
		static void sort_toggle_state(::Screen *);
		static void sort_toggle_pkgname(::Screen *);
		static void sort_toggle_size(::Screen *);
		static void sort_toggle_instsize(::Screen *);
		static void sort_toggle_suite(::Screen *);

	public:
		virtual bool external_key_handler(int key);
#ifdef HAVE_LIBGPM
		virtual int gpm_handler(Gpm_Event *event);
#endif

		MenuDrop(Menu, Screen &);
};

#endif /* _menu_H */
