/* $Id: init_status.cc,v 1.6 2001/02/26 01:36:18 tausq Exp $ */
//old #include <std.h>
#include <interface/edeityui.h>
#include "colors.h"
#include "init_status.h"

CursesUI::InitStatus::InitStatus(Configuration & Config): NoUpdate(false), NoDisplay(false)
{
	if (Config.FindI("quiet", 0) >= 1)
		NoUpdate = true;
	if (Config.FindI("quiet", 0) >= 2)
		NoDisplay = true;

	InitWindows();
};


CursesUI::InitStatus::~InitStatus()
{
	Done();
	EndWindows();
}

void CursesUI::InitStatus::Done()
{
	if (NoUpdate == false)
		if (_error->PendingError() == true)
			CaptUI->ShowDialog(_("Error"), (char *)Op.c_str());
}

void CursesUI::InitStatus::Update()
{
	if (CheckChange() == false)
		return;

	// No percent spinner
	if (NoUpdate == true)
		return;

	// Print the spinner
	
	float pbarlen = (Percent / 100) * (COLS / 1.7);

	werase(wInitProgress);

	wattrset(wInitProgress, _clrsys->regpair(COLOR_GREEN, COLOR_BLUE)|A_BOLD);
	mvwprintw(wInitProgress, 0, ((int)(COLS/1.7)-Op.length())/2, (char *)Op.c_str());
	wattrset(wInitProgress, _clrsys->regpair(COLOR_YELLOW, COLOR_BLUE)|A_BOLD);
	mvwprintw(wInitProgress, 1, ((int)(COLS/1.7)-SubOp.length())/2, (char *)SubOp.c_str());

	wattrset(wInitProgress, _clrsys->regpair(COLOR_BLACK, COLOR_WHITE));

	for(int I = 0; I < (COLS / 1.7); I++)
		mvwaddch(wInitProgress, 2, I, ' ');	

	wattrset(wInitProgress, _clrsys->regpair(COLOR_WHITE, COLOR_RED));

	for(int I = 0; I < pbarlen; I++)
		mvwaddch(wInitProgress, 2, I, ' ');

	wrefresh(wInitProgress);
}

void CursesUI::InitStatus::InitWindows()
{
	int y_len = 3;                       // One line total
	int y_start = (LINES - y_len) / 2;   // Centered
	int x_len = (int)(COLS / 1.7);                // Full length of screen
	int x_start = (COLS - x_len) / 2;    // Centered

	noecho();
	cbreak();
	wInitProgress = newwin(y_len, x_len, y_start, x_start);
	scrollok(wInitProgress,false);
	wattrset(wInitProgress, _clrsys->regpair(COLOR_GREEN, COLOR_BLUE)|A_BOLD);
	wbkgd(wInitProgress,    _clrsys->regpair(COLOR_GREEN, COLOR_BLUE)|A_BOLD);
	wrefresh(wInitProgress);

	curs_set(0);
}	

void CursesUI::InitStatus::EndWindows()
{
	delwin(wInitProgress);
	refresh();
}
