/* $Id: screen.h,v 1.8 2001/05/02 14:21:51 ltd Exp $ */
#ifndef _cursesscreen_H
#define _cursesscreen_H

#include "cursesui.h"

class CursesUI::Screen : public ::Screen
{
	friend class CursesUI;
	friend class CursesUI::Dialog;

private:
	CursesUI &ui;

	void PaintTop(void);
	void PaintDescriptionTop(void);

	bool descVisible;

public:
	Screen(::Screen::ScrInit, ::Screen::ScrFunc, CursesUI &);
	void BoundsReset();
	void ActivateMenu(Menu);

	void ClearMain();
	void RedrawRow(int, PackageTree::Item *);
	void RedrawTree();
	void Redraw();
	void RefreshCurrent();
	void Update();
	void UpdateDescription(void);

	void RedrawLine();
	void ScrollUp();
	void ScrollDown();
	void SeekNextMatched();
	void DescWindowShow();
	void DescWindowHide();
	void DescShuffle(int factorial);
	bool IsDescWindowShown() { return descVisible; }
	void ScrollDescUp();
	void ScrollDescDown();
	void DividerNext();
	void DividerPrev();

	void UpdateStatus(void);

	void SearchEntry(char **, unsigned long *);
	void FilterSelect(char **, unsigned long *);
	int SearchPrompt(unsigned long, char *);
	void SearchHelp();

	void SortSelectMethod();
	
	void HelpDialog();
};

#endif // _cursesscreen_H


