/* $Id: wrappers.cc,v 1.6 2001/03/24 08:08:32 ltd Exp $ */
//old #include <std.h>
#include "colors.h"
#include <interface/edeityui.h>
#include "cursesui.h"
#include "wrappers.h"

UniqueWindow::UniqueWindow(int length_y, int length_x, int displacement_y, int displacement_x)
{
	Length_Y = length_y;
	Length_X = length_x;
	Displacement_Y = displacement_y;
	Displacement_X = displacement_x;

	CreateWindows();
	ChangeColor(-1, -1);
	keypad(Body, true);
}

UniqueWindow::~UniqueWindow()
{
	delwin(Body);
	delwin(Title);
}

void UniqueWindow::CreateWindows()
{
	Title  = newwin(Length_Y, Length_X, Displacement_Y, Displacement_X);
	Body   = derwin(Title, Length_Y - 2, Length_X - 2, 1, 1);

	wborder(Title, 0, 0, 0, 0, 0, 0, 0, 0);

	Extra_Y = 2;
	Extra_X = 2;

	myassert(Body != 0 && Title != 0, _("Window creation failed"));
}

//old void UniqueWindow::ChangeColor(int Title_Pair = -1, int Body_Pair = -1)
void UniqueWindow::ChangeColor(int Title_Pair, int Body_Pair)
{
	if (Body_Pair == -1) {
		wbkgd(Body, CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE));
		wattrset(Body, CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
	}
	else {
		wbkgd(Body, Body_Pair);
		wattrset(Body, Body_Pair);
	}

	if (Title_Pair == -1) {
		wbkgd(Title, CursesUI::_clrsys->regpair(COLOR_BLUE, COLOR_BLUE)|A_BOLD);
		wattrset(Title, CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
	}
	else {
		wbkgd(Title, Title_Pair);
		wattrset(Title, Title_Pair);
	}

	wrefresh(Body);
	wrefresh(Title);
}

void UniqueWindow::ChangeTitle(string titlestr)
{
	wattrset(Title, CursesUI::_clrsys->regpair(COLOR_WHITE, COLOR_BLUE)|A_BOLD);
	mvwprintw(Title, 0, (Length_X - titlestr.length()) / 2, "%s", (char *)titlestr.c_str());
	wrefresh(Title);
}
