// $Id: deityui.h,v 1.17 2001/05/14 15:07:02 ltd Exp $
#ifndef _edeityui_H
#define _edeityui_H

#include <list/screens.h>
#include <func/messages.h>

#ifdef USE_DEBCONF
class DebConfBackend;
class DebConfItf;
#endif
class pkgAcquireBackend;

class EDeityUI
{
public:
	class Dialog;
	class AcquireUI;
	class pkgMgrInt;

	int signalfd;

	AcquireUI *AcqItf;
#ifdef USE_DEBCONF
	DebConfBackend *DCBackend;
	DebConfItf *DCUI;
#endif
	ScreenList scrlst;

	static int LoadUIModules();
	static EDeityUI *CreateInterface(const char *, int &argc, char **&argv);

	virtual int Run() { return 0; };
	virtual int Passthrough(int fd);   // Passthrough -- only select for fetcher events

	virtual void Startup() { };         // Really boot up the UI :>
	virtual void Shutdown() { };        // Really shut down the UI
	virtual void Restart() { };

	virtual void ShowAcquireProgress() {};
	virtual void HideAcquireProgress() {};
	virtual void UpdateAcquireProgress(const MsgDownloadTotal *Total) {};

	// Before and after Dpkg running
	virtual void PrepareForInstall() = 0;
	virtual void RecoverFromInstall() = 0;

	// Independent way to draw the screen / tree data
	// Needed because the way each UI does this is independent
	virtual void DrawTrees() = 0;
	virtual void DrawScreens() = 0;

	// Humm... some UIs will need to call this for complete_pending
	virtual void Modal(Screen *) { };

	virtual void WaitForFetch(pkgAcquireBackend *, int fd) {};
	virtual bool ProcessMsg(int fd);
#ifdef USE_DEBCONF
	virtual void WaitForDebConf(int fd) {};
	virtual bool ProcessDebConfMessage(int fd);
#endif

//	virtual void TextEntry(char *, char **) { };
	virtual unsigned char ShowDialog(char *, char *, ...) { return 0; };
//old	virtual bool FilterSelect(char **, Filter::Target *) = 0;
//	virtual bool FilterSelect(char **, unsigned long *) = 0;

	virtual Screen *CreateScreen(Screen::ScrInit, Screen::ScrFunc) = 0;
	virtual OpProgress *CreateProgressBar() = 0;
	virtual pkgMgrInt *CreatePMI() = 0;

	virtual void CreateAcquireUI() = 0;

#ifdef USE_DEBCONF
	virtual void CreateDebConfGUI() { DCUI = 0; }

	virtual void StartDebConf();
	virtual void StopDebConf();
#endif

	EDeityUI() 
	{ 
		AcqItf = 0; 
		signalfd = -1;
#ifdef USE_DEBCONF
		DCUI = 0; 
		DCBackend = 0;
#endif
	}
	virtual ~EDeityUI() {};
};

#endif // _edeityui_H
