/* $Id: acquire-ui.cc,v 1.10 2001/03/10 14:55:44 ltd Exp $ */
//old #include <std.h>
//old #include <stdio.h>

#include "acquire-ui.h"

static GtkItemFactoryEntry menu_items[] = {
	// caption	accel	func	action	type
	{ _("/File"),	0,	0,	0,	0 },
	{ _("/Games"),	0,	0,	0,	0 },
	{ _("/Help"),	0,	0,	0,	"<LastBranch>" }
};

GtkUI::AcquireUI::AcquireUI()
{
	verboseDownload = true;
	window = 0;
	ItemMapCount = 50;
	ItemMap = new AcquireItem *[ItemMapCount];
	memset(ItemMap, 0, sizeof(AcquireItem *) * ItemMapCount);
//old	readytoinstall = true;
}

GtkUI::AcquireUI::~AcquireUI()
{
	if (window != 0)
		gtk_widget_destroy(window);
	delete [] ItemMap;
}

void GtkUI::AcquireUI::CheckSize(unsigned int i)
{
	if (i >= ItemMapCount)
	{
		AcquireItem **tmp = new AcquireItem *[i*2];
		memset(tmp, 0, sizeof(AcquireItem *) * i * 2);
		memcpy(tmp, ItemMap, sizeof(AcquireItem *) * ItemMapCount);
		delete [] ItemMap;
		ItemMapCount = i * 2;
		ItemMap = tmp;
	}
}

void GtkUI::AcquireUI::SetVerboseDownload(bool b)
{
/*
	if (b && !verboseDownload)
	{
		verboseDownload = true;
		CreateWindow();
	}
	else if (!b && verboseDownload)
	{
		verboseDownload = false;
		CloseWindow();
	}	
*/
}

//old gboolean GtkUI::AcquireUI::signalCloseEvent(GtkWidget *dialog, gpointer data)
gboolean GtkUI::AcquireUI::signalCloseEvent(GtkWidget *dialog, GdkEvent *event, gpointer data)
{
  GtkUI::AcquireUI *This = (GtkUI::AcquireUI*)data;
	//This->wasAborted = true;

	return(TRUE);
}

void GtkUI::AcquireUI::CreateWindow()
{
	if (window != 0) return;

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), _("Acquire Window"));
	gtk_window_set_default_size(GTK_WINDOW(window), 628, 250);
	gtk_window_set_policy(GTK_WINDOW(window), TRUE, TRUE, FALSE);
	gtk_window_set_modal(GTK_WINDOW(window), TRUE);
//old	gtk_signal_connect(GTK_OBJECT(window), "delete_event", GTK_SIGNAL_FUNC(signalCloseEvent), this);
	g_signal_connect(G_OBJECT(window), "delete-event", G_CALLBACK(signalCloseEvent), gpointer(this));

	GtkWidget *acqMainVBox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(window), acqMainVBox);

	// The menu
/*	GtkAccelGroup *accel_group = gtk_accel_group_new();
	GtkItemFactory *itemfac = gtk_item_factory_new(GTK_TYPE_MENU_BAR, "<main>", accel_group);
	gtk_item_factory_create_items(itemfac, sizeof(menu_items)/sizeof(menu_items[0]), menu_items, NULL);
	gtk_window_add_accel_group(GTK_WINDOW(window), accel_group);

	GtkWidget *acqMenuBar = gtk_item_factory_get_widget(itemfac, "<main>");
	gtk_box_pack_start(GTK_BOX(acqMainVBox), acqMenuBar, FALSE, FALSE, 0);
*/
	// The transfer list

	GtkWidget *acqTransferListScroller = gtk_scrolled_window_new(NULL, NULL);
	gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(acqTransferListScroller), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	gtk_box_pack_start(GTK_BOX(acqMainVBox), acqTransferListScroller, TRUE, TRUE, 0);

	acqTransferList = gtk_list_new();
	gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(acqTransferListScroller), acqTransferList);

	// The progress bar and its frame

	GtkWidget *acqTotalProgressFrame = gtk_frame_new(_("Total Acquired"));
	gtk_box_pack_start(GTK_BOX(acqMainVBox), acqTotalProgressFrame, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(acqTotalProgressFrame), 4);
	
	GtkWidget *acqButtonHBox = gtk_hbox_new (FALSE, 0);
	gtk_box_pack_start (GTK_BOX(acqMainVBox), acqButtonHBox, FALSE, FALSE, 0);
	gtk_container_set_border_width (GTK_CONTAINER(acqButtonHBox), 4);
	
	ButtonOK = gtk_button_new_with_label (_("OK"));
	gtk_widget_set_sensitive (ButtonOK, FALSE);
	gtk_box_pack_start (GTK_BOX(acqButtonHBox), ButtonOK, TRUE, FALSE, 0);
	
	GtkWidget *acqTotalProgressVBox = gtk_vbox_new(FALSE, 0);
	gtk_container_add(GTK_CONTAINER(acqTotalProgressFrame), acqTotalProgressVBox);
	gtk_container_set_border_width(GTK_CONTAINER(acqTotalProgressVBox), 4);

	acqTotalProgressBar = gtk_progress_bar_new();
	gtk_box_pack_start(GTK_BOX(acqTotalProgressVBox), acqTotalProgressBar, TRUE, TRUE, 0);
	gtk_progress_set_show_text(GTK_PROGRESS(acqTotalProgressBar), TRUE);

	gtk_widget_show_all(window);
}

void GtkUI::AcquireUI::CloseWindow()
{
	if (window == 0) return;

	gtk_widget_destroy(window);
	window = 0;
}

void GtkUI::AcquireUI::DispatchKey(int key)
{
}

void GtkUI::AcquireUI::Startup()
{
	if (window == 0)
		CreateWindow();
}

void GtkUI::AcquireUI::Shutdown()
{
	if (window != 0)
	{
		gtk_widget_destroy(window);
		window = 0;
	}
}

void GtkUI::AcquireUI::Refresh()
{
}

void GtkUI::AcquireUI::Start()
{
}

void GtkUI::AcquireUI::Stop()
{
}

void GtkUI::AcquireUI::IMSHit(const MsgItemDesc *M)
{
	// ID, URI, Description, ShortDesc, FileSize
	fprintf(stderr, _("IMSHIT\n"));
}

void GtkUI::AcquireUI::Fetch(const MsgItemDesc *M)
{
	// ID, URI, Description, ShortDesc, FileSize
	CheckSize(M->ID);
	GtkWidget *list_item = gtk_list_item_new();
	GtkWidget *hbox = gtk_hbox_new(TRUE, 0);
	GtkWidget *pbar = gtk_progress_bar_new();
	gtk_progress_set_show_text(GTK_PROGRESS(pbar), TRUE);
	gtk_box_pack_start(GTK_BOX(hbox), pbar, TRUE, TRUE, 0);
	gtk_widget_show(pbar);
	gtk_container_add(GTK_CONTAINER(list_item), hbox);
	gtk_widget_show(hbox);
	gtk_container_add(GTK_CONTAINER(acqTransferList), list_item);
	gtk_widget_show(list_item);

	ItemMap[M->ID] = new AcquireItem(M->ShortDesc, M->URI, pbar);

	fprintf(stderr, _("Start download ID %ld: %s - %s\n"), M->ID, M->Description, M->ShortDesc);
}

void GtkUI::AcquireUI::Done(const MsgItemDesc *M)
{
	// ID, URI, Description, ShortDesc, FileSize
	fprintf(stderr, _("End download ID %ld: %s - %s\n"), M->ID, M->Description, M->ShortDesc);

	ASSERT(M->ID < ItemMapCount);
	AcquireItem *item = ItemMap[M->ID];
	ASSERT(item != 0);

	char buf[256];
/*old	sprintf(buf, "%s @ 100 %%%%", item->Package.c_str());
	gtk_progress_set_format_string(GTK_PROGRESS(item->pbar), buf);
*/	sprintf(buf, _("%s @ 100 \%"), item->Package.c_str());
	gtk_progress_bar_set_text(GTK_PROGRESS_BAR(item->pbar), buf);
	gtk_progress_bar_update(GTK_PROGRESS_BAR(item->pbar), 1.0);
}

void GtkUI::AcquireUI::Fail(const MsgItemFailed *M)
{
	// Itm: ID, URI, Description, ShortDesc, FileSize
	// Status, ErrorText
	//g_print("%s: %s\n", M->Status, M->ErrorText);
}

void GtkUI::AcquireUI::MediaChange(const MsgMediaChange *M)
{
	// Title, Drive
}

void GtkUI::AcquireUI::Update(const vector<MsgDownloadItem> *ItemList, 
	const MsgDownloadTotal *Total)
 {
	// ID, Status, ShortDesc, PartialSize, FileSize, Percent, DestFile
	// CurrentBytes, TotalBytes, CurrentItems, TotalItems, Percent
	//    CurrentCPS, ETA
	//g_print("update\n");
	double percent = 0;
	vector<MsgDownloadItem>::const_iterator I;
	char buf[256];

	for (I = ItemList->begin(); I != ItemList->end(); I++)
	{
		ASSERT(I->ID < ItemMapCount);
		AcquireItem *item = ItemMap[I->ID];

		if (item == 0)
		{
			/* Is doing something other than downloading  -- print Indicators[K].Status */
			fprintf(stderr, _("Update ID = %ld Status = %s\n"), I->ID, I->Status);
			//snprintf(buf, sizeof(buf), "%s", I->Status);
			//gtk_progress_set_format_string(GTK_PROGRESS(acqTotalProgressBar), buf);
		}
		else
		{
			if (I->FileSize > 0)
			{
				percent = double(I->PartialSize) / double(I->FileSize);

				gtk_progress_bar_update(GTK_PROGRESS_BAR(item->pbar), percent);

//old				snprintf(buf, sizeof(buf), "%s @ %%p %%%% (%s/%s)", I->ShortDesc, SizeToStr(I->PartialSize).c_str(), SizeToStr(I->FileSize).c_str());
				snprintf(buf, sizeof(buf), _("%s @ %%%% (%s/%s)"), I->ShortDesc, SizeToStr(I->PartialSize).c_str(), SizeToStr(I->FileSize).c_str());
//old				gtk_progress_set_format_string(GTK_PROGRESS(item->pbar), buf);
				gtk_progress_bar_set_text(GTK_PROGRESS_BAR(item->pbar), buf);
			}
		}
	}

	// Draw the total progress bar

	gtk_progress_bar_update(GTK_PROGRESS_BAR(acqTotalProgressBar), Total->Percent);
}


#if 0
void GtkUI::AcquireUI::ViewInstall()
{
	int pkgcount = 0;
	string tmp = "  ";

	for (pkgCache::PkgIterator I = (*Cache)->PkgBegin(); I.end() == false; I++)
	{
		if ((*Cache)[I].Install() == true)
		{
			tmp += I.Name();
			tmp += " ";
			pkgcount++;
		}
	}

	if (pkgcount > 0)
		CaptUI->ShowDialog(_("Install"), (char *) tmp.c_str());

}

void GtkUI::AcquireUI::ViewRemove()
{
	int pkgcount = 0;
	string tmp = "  ";

	for (pkgCache::PkgIterator I = (*Cache)->PkgBegin(); I.end() == false; I++)
	{
		if ((*Cache)[I].Delete() == true)
		{
			tmp += I.Name();
			tmp += " ";
			pkgcount++;
		}
	}

	if (pkgcount > 0)
		CaptUI->ShowDialog(_("Delete"), (char *) tmp.c_str());

}

void GtkUI::AcquireUI::Error(char *fmt, ...)
{
	va_list va;
	char buf[512];

	va_start(va, fmt);
	vsnprintf(buf, 511, fmt, va);
	va_end(va);

	CaptUI->ShowDialog(_("Fatal Error"), "\n %s \n", buf);

	NoCacheInit = true;
}


/* Prompt for a media swap */
bool GtkUI::AcquireUI::MediaChange(string Media, string Drive)
{
	PrintOutputF(_("Media Change: Please insert the disc labeled '%s' in the drive '%s' and press enter"),
		Media.c_str(), Drive.c_str());
	
	char C = 0;
	while (C != '\n' && C != '\r')
		read(STDIN_FILENO, &C, 1);

	Update = true;
	return true;
}
#endif
