/* $Id: acquire-ui.h,v 1.4 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _gtkui_acquireui_H
#define _gtkui_acquireui_H

#include <func/messages.h>
#include <interface/acquireui.h>
#include <interface/gtk/gtkui.h>

class GtkUI::AcquireUI : public EDeityUI::AcquireUI
{
protected:
	struct AcquireItem {
		string Package;
		string URI;
		GtkWidget *pbar;

		AcquireItem(const string &p, const string &u, GtkWidget *bar)
			: Package(p), URI(u), pbar(bar) {};
	};

	AcquireItem **ItemMap;
	unsigned int ItemMapCount;
//old	bool readytoinstall;
	
	GtkWidget *window;
	GtkWidget *acqTransferList;
	GtkWidget *acqTotalProgressBar;
	GtkWidget *ButtonOK;
	bool verboseDownload;

	void CheckSize(unsigned int i);
	void CreateWindow();
	void CloseWindow();
	
//old	static gboolean signalCloseEvent(GtkWidget *dialog, gpointer data);
	static gboolean signalCloseEvent(GtkWidget *dialog, GdkEvent *, gpointer data);
	
public:
	void SetVerboseDownload(bool b);
	
	void DispatchKey(int key);
	void Startup();
	void Shutdown();
	void Refresh();
	void Start();
	void Stop();
	void IMSHit(const MsgItemDesc *M);
	void Fetch(const MsgItemDesc *M);
	void Done(const MsgItemDesc *M);
	void Fail(const MsgItemFailed *M);
	void MediaChange(const MsgMediaChange *M);

	void Update(const vector<MsgDownloadItem> *ItemList, 
		const MsgDownloadTotal *Total);

//old	bool ReadyToInstall() { return readytoinstall; }

	AcquireUI();
	~AcquireUI();
};

#endif
