/* $Id: debconfgui.h,v 1.4 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _gtk_debconfgui_H
#define _gtk_debconfgui_H

#include <debconf/itf.h>
#include <gtk/gtk.h>

#include "gtkui.h"

class GtkUI::DebConfGUI : public ::DebConfItf {
	GtkWidget *window;
	GtkWidget *body;
	GtkWidget *help;

	GtkWidget *btnOK;
	GtkWidget *btnGoBack;
	GtkWidget *btnHelp;

	GSList *answerwidgets;

	bool displayed;
	bool goback;
	static void OnBtnOKClicked(GtkButton *btn, gpointer data);
	static void OnBtnGoBackClicked(GtkButton *btn, gpointer data);
	static void OnBtnHelpClicked(GtkButton *btn, gpointer data);
	static gboolean PaintHelp(GtkWidget *, GdkEventCrossing *, gboolean);

	static gboolean Input(GIOChannel *, GIOCondition, gpointer);
	
	void ClearArea();
	void PaintBoolean(Question *);
	void PaintNote(Question *);
	void PaintString(Question *);
	void PaintPassword(Question *);
	void PaintText(Question *);
	void PaintSelect(Question *);
	void PaintMultiselect(Question *);

public:
	virtual int AskQuestions();
	virtual void SetTitle(char *);
	virtual void SetCapbBackup(bool);
	virtual void ClientConnected(int fd);

	virtual void Startup();
	virtual void Shutdown();

	DebConfGUI();
	virtual ~DebConfGUI();
};

#endif
