/* $Id: gtkui.cc,v 1.19 2001/06/22 14:59:17 ltd Exp $ */
//old #include <std.h>
//old #include <iostream>
//old #include <cstdarg>
#include <cstdio>
#include <gtk/gtk.h>
#ifdef USE_DEBCONF
#include <debconf/backend.h>
#endif
#include <func/messages.h>
#include <parsers/strutl.h>
#include "util.h"
#include "gtkui.h"
#include "progress.h"
#include "screen.h"
#include "acquire-ui.h"
#include "filteredit.h"
#ifdef USE_DEBCONF
#include "debconfgui.h"
#endif
#include "pmi.h"

using namespace GtkUtil;

GtkUI::GtkUI()
{
	fetcher = 0;
	int argc = 2;
	char **argv = new (char *)[2];
	argv[0] = new char[10];
	strcpy(argv[0], "edeity-gtk");
	argv[1] = new char[20];
	strcpy(argv[1], "--g-fatal-warnings");
	gtk_init(&argc, &argv);
}

GtkUI::~GtkUI() 
{
}

int GtkUI::Run()
{
	gtk_main();

	return 0;
}

void GtkUI::CreateKeyInterface(GtkWidget *widget)
{
	gtk_widget_set_events(widget, GDK_KEY_PRESS_MASK);
//old	gtk_signal_connect(GTK_OBJECT(widget), "key_press_event", GTK_SIGNAL_FUNC(signalKeyPress), this);
//new	g_signal_connect(G_OBJECT(widget), "key_press_event", G_CALLBACK(signalKeyPress), gpointer(this));
}

gint GtkUI::signalKeyPress(GtkWidget *widget, GdkEventKey *event, gpointer data)
{
	// Need to fix this !
//	CURRENTSCR->kdriver->DispatchKey(event->keyval);
	return 0;
}


void GtkUI::Startup() {}

void GtkUI::Shutdown() 
{
	gtk_main_quit();
}

void GtkUI::Modal(::Screen *S)
{
	/*	
	GtkUI::Screen *scr = (GtkUI::Screen *) S;
	scr->Show(true);
	*/

	//gtk_main();
}

void GtkUI::TextEntry(char *prompt, char **retbuf) 
{
	if (retbuf == NULL) return;
	**retbuf = 0;

	GtkWidget *dlg = gtk_dialog_new();
	GtkWidget *hbox = gtk_hbox_new(FALSE, 10);
	gtk_container_set_border_width(GTK_CONTAINER(hbox), 30);
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->vbox), hbox, FALSE, FALSE, 0);

	gtk_box_pack_start(GTK_BOX(hbox), gtk_label_new(prompt), FALSE, FALSE, 10);

	GtkWidget *text = gtk_entry_new();
	gtk_box_pack_end(GTK_BOX(hbox), text, FALSE, TRUE, 10);

	gtk_container_set_border_width(GTK_CONTAINER(GTK_DIALOG(dlg)->action_area), 10);
	GtkWidget *btnOK = gtk_button_new_with_label(_("OK"));
	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(dlg)->action_area), btnOK, FALSE, TRUE, 0);

//old	gtk_object_set_data(GTK_OBJECT(btnOK), "dialog", dlg);
	g_object_set_data(G_OBJECT(btnOK), "dialog", dlg);

/*old	gtk_signal_connect(GTK_OBJECT(btnOK), "clicked",
		GTK_SIGNAL_FUNC(Destroy), (gpointer)this);
*/	g_signal_connect(G_OBJECT(btnOK), "clicked",
			 G_CALLBACK(Destroy), (gpointer)this);


	gtk_widget_show_all(dlg);
	gtk_main();

	// when the user clicks ok.....

	sprintf(*retbuf, gtk_entry_get_text(GTK_ENTRY(text)));
	gtk_widget_destroy(dlg);
}

//old gint GtkUI::DeleteEvent(GdkEvent *event, gpointer data)
gboolean GtkUI::DeleteEvent(GtkWidget *widget, GdkEvent *event, gpointer data)
{ 
	return(FALSE);
}

void GtkUI::WidgetDestroyEvent(GdkEvent *event, gpointer data)
{
	gtk_widget_destroy((GtkWidget *) data);
}

void GtkUI::Destroy()
{
	gtk_main_quit(); 
}

unsigned char GtkUI::ShowDialog(char *title, char *format, ...) 
{ 
	GtkWidget *button, *label;
	GtkWidget *dialog = gtk_dialog_new();
	gtk_window_set_title(GTK_WINDOW(dialog), title);

//old	g_signal_connect(GTK_OBJECT(dialog), "delete_event", GTK_SIGNAL_FUNC(DeleteEvent), NULL);
//old	g_signal_connect(GTK_OBJECT(dialog), "destroy", GTK_SIGNAL_FUNC(Destroy), NULL);
	g_signal_connect(G_OBJECT(dialog), "delete-event", G_CALLBACK(DeleteEvent), NULL);
	g_signal_connect(G_OBJECT(dialog), "destroy", G_CALLBACK(Destroy), NULL);

//	g_container_set_border_width(GTK_CONTAINER(GTK_BOX(GTK_DIALOG(dialog)->vbox)), 5);
	gtk_container_set_border_width(GTK_CONTAINER(GTK_BOX(GTK_DIALOG(dialog)->vbox)), 5);

	button = gtk_button_new_with_label(_("OK"));
//old	g_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(WidgetDestroyEvent), dialog);
	g_signal_connect(G_OBJECT(button), "clicked", G_CALLBACK(WidgetDestroyEvent), dialog);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->action_area), button, TRUE, TRUE, 0);

	char buf[1024];

	va_list va;

	va_start(va, format);
	vsnprintf(buf, 1024, format, va);
	va_end(va);
	
	label = gtk_label_new (buf);
	gtk_box_pack_start (GTK_BOX (GTK_DIALOG (dialog)->vbox), label, TRUE, TRUE, 0);

	gtk_widget_show_all(dialog);

	gtk_main();

	return 0; 
}

gboolean GtkUI::_ProcessMsg(GIOChannel *src, GIOCondition cond, gpointer data)
{
	GtkUI *This = (GtkUI *)data;
	int fd = g_io_channel_unix_get_fd(src);
	return This->ProcessMsg(fd);
}

void GtkUI::WaitForFetch(pkgAcquireBackend *fetcher, int fd)
{
	signalfd = fd;
	this->fetcher = fetcher;
	GIOChannel *c = g_io_channel_unix_new(fd);
	g_io_add_watch(c, G_IO_IN, _ProcessMsg, this);
}

::Screen *GtkUI::CreateScreen(::Screen::ScrInit mode, ::Screen::ScrFunc func)
{
	return new GtkUI::Screen(mode, func, *this);
}

OpProgress *GtkUI::CreateProgressBar()
{
	return new ProgressBar;
}

void GtkUI::CreateAcquireUI()
{
	AcqItf = new GtkUI::AcquireUI();
}

EDeityUI::pkgMgrInt *GtkUI::CreatePMI()
{
	return new GtkUI::pkgMgrInt;
}

/*
bool GtkUI::FilterSelect(char **buf, Filter::Target *target)
{
	FilterEditor ed(*this);
	if (ed.Run())
	{
		ed.GetFilter(*buf, *target);
		INFO(INFO_DEBUG, _("Filter is \"%s\"\n"), *buf);
		return true;
	}
	else
		return false;
}
*/
void GtkUI::DrawTrees()
{
	for (::Screen *sc = scrlst.Head(); sc != NULL; sc = sc->next)
		sc->RedrawTree();
}

void GtkUI::DrawScreens()
{
	for (::Screen *sc = scrlst.Head(); sc != NULL; sc = sc->next)
		sc->Redraw();
}

// Creator function
extern "C" {
	EDeityUI *CreateInterface() { return new GtkUI; }
};

