/* $Id: pkgtreewidget.cc,v 1.13 2001/05/15 10:11:07 ltd Exp $ */
#include <std.h>
#include <func/apt.h>
#include <func/config.h>
#include <func/pkgchecks.h>
#include <func/tree.h>
#include <interface/format_strings.h>
#include <list/sections.h>
#include "screen.h"
#include "pkgtreewidget.h"
//old #include "util.h"
#include "pixmaps/package.xpm"
#include "pixmaps/divider.xpm"
#include "pixmaps/depends.xpm"
#include "pixmaps/conflicts.xpm"
#include "pixmaps/replaces.xpm"
#include "pixmaps/recommends.xpm"
#include "pixmaps/suggests.xpm"
/*old
#include "pixmaps/tree.xpm"
#include "pixmaps/tree_minus.xpm"
#include "pixmaps/tree_plus.xpm"
#include "pixmaps/tree_minus_term.xpm"
#include "pixmaps/tree_plus_term.xpm"
#include "pixmaps/tree_term.xpm"
*/
#include <gdk-pixbuf/gdk-pixbuf.h>
/*
#define HOVERINTERVAL	2000   // ms

#define GTKUI_PKG_ICON_SIZE 16
#define GTKUI_TREE_ICON_SIZE 20
#define GTKUI_PKG_INDENT 11 
#define GETGC(gc, state) 				\
	switch (state) {				\
		case Normal: gc = normal_gc; break;	\
		case Selected: gc = selected_gc; break;	\
		case Prelight: gc = prelight_gc; break;	\
		case Matched: gc = matched_gc; break;	\
		default: // bad!!! // 
		NOTREACHED("Unknown state"); break;	\
	}

using namespace GtkUtil;

gchar *GtkUI::PkgTreeWidget::titles[] = { "Package", "Is", "Will", "Avl. Vers", "Ins. Vers", "Description" };

GdkPixmap *GtkUI::PkgTreeWidget::package_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::divider_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::depends_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::conflicts_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::replaces_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::recommends_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::suggests_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::expanded_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::contracted_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::expanded_term_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::contracted_term_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::tree_nochild_term_pixmap[4];
GdkPixmap *GtkUI::PkgTreeWidget::tree_nochild_pixmap[4];
#define GETPIXMAP(pixmap, state) (state == Normal ? pixmap[0] : (state == Selected ? pixmap[1] : (state == Prelight ? pixmap[2] : pixmap[3])))
*/
GtkUI::PkgTreeWidget::PkgTreeWidget(GtkUI::Screen & _screen)
	: screen(_screen), /* old normal_gc(0), prelight_gc(0), selected_gc(0), matched_gc(0), bpixmap(0), adjustment(0), vspacing(20),*/ redrawqueued(false)//old, resizingcolumn(-1)
{
	screen._prelight = NULL;
	colchange = false;
	rescanpath = NULL;
	screen.descwinshown = false;

	GtkTreeSelection *select;

	N_Col = screen.Packages->Columns->TotalLength();
	GType *types = new GType [N_Col + 3];
	
	for (int i = 1; i <= N_Col; i++) types[i] = G_TYPE_STRING;
	
	Item_Col = N_Col + 1;
	Color_Col = N_Col + 2;
	
	types[Icon_Col] = GDK_TYPE_PIXBUF;
	types[Item_Col] = G_TYPE_POINTER;
	types[Color_Col] = GDK_TYPE_COLOR;
	
	treestore = gtk_tree_store_newv (N_Col + 3, types);
	delete types;

	tree = gtk_tree_view_new_with_model (GTK_TREE_MODEL (treestore));
	
	gtk_widget_set_events(tree, GDK_BUTTON_PRESS_MASK | 
				    GDK_POINTER_MOTION_MASK | 
				    GDK_LEAVE_NOTIFY_MASK);

			      
	g_signal_connect(G_OBJECT(tree), "button_press_event",
					 G_CALLBACK(ButtonPress),
					 gpointer(this));
			 
/*	g_signal_connect(G_OBJECT(tree), "motion_notify_event",
			 G_CALLBACK(MotionNotify), gpointer(this));
			 
	g_signal_connect(G_OBJECT(tree), "leave_notify_event",
			 G_CALLBACK(LeaveNotify), gpointer(this));
*/

			 
	g_signal_connect (G_OBJECT (tree), "row-expanded",
			  G_CALLBACK (RowExpanded),
			  gpointer (this));
	g_signal_connect (G_OBJECT (tree), "row-collapsed",
			  G_CALLBACK (RowCollapsed),
			  gpointer (this));
	g_signal_connect (G_OBJECT (tree), "row-activated",
			  G_CALLBACK (RowActivated),
			  gpointer (this));
	g_signal_connect (G_OBJECT (tree), "columns-changed",
                	  G_CALLBACK (ColumnsChanged),
                	  gpointer (this));
	
	gtk_tree_view_columns_autosize (GTK_TREE_VIEW (tree));
	
	gtk_tree_view_set_column_drag_function (GTK_TREE_VIEW (tree), DragColumn, gpointer (this), NULL);
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);
	
	g_signal_connect (G_OBJECT (select), "changed",
                	  G_CALLBACK (RowChanged),
                	  gpointer (this));
					  

	SetupCs();
	AlignCols();
	QueueRedraw();
	
	screen.descwinshown = true;
	
	/* these can't be created in the static constructor because they need 
	 * a window context. kinda stupid.... */
/*old
	GdkColor *color, cursor, prelight, normal, matched;

	normal.red     = 0xffff;
	normal.green   = 0xffff;
	normal.blue    = 0xffff;
	cursor.red     = 0;
	cursor.green   = 0;
	cursor.blue    = 0;
	prelight.red   = 0xe500;
	prelight.green = 0xe500;
	prelight.blue  = 0xe500;
	matched.red   = 0xff00;
	matched.green = 0xdd00;
	matched.blue  = 0xff00;

	for (int i = 0; i < 4; i++)
	{
		if (i == 0) color = &normal;
		else if (i == 1) color = &cursor;
		else if (i == 2) color = &prelight;
		else color = &matched;

		package_pixmap[i]    = PixmapFromXPM((char **) package_xpm, color);
		divider_pixmap[i]    = PixmapFromXPM((char **) divider_xpm, color);
		depends_pixmap[i]    = PixmapFromXPM((char **) depends_xpm, color);
		conflicts_pixmap[i]  = PixmapFromXPM((char **) conflicts_xpm, color);
		replaces_pixmap[i]   = PixmapFromXPM((char **) replaces_xpm, color);
		recommends_pixmap[i] = PixmapFromXPM((char **) recommends_xpm, color);
		suggests_pixmap[i]   = PixmapFromXPM((char **) suggests_xpm, color);
		expanded_pixmap[i]   = PixmapFromXPM((char **) tree_minus_xpm, color);
		contracted_pixmap[i] = PixmapFromXPM((char **) tree_plus_xpm, color);
		expanded_term_pixmap[i]   = PixmapFromXPM((char **) tree_minus_term_xpm, color);
		contracted_term_pixmap[i] = PixmapFromXPM((char **) tree_plus_term_xpm, color);
		tree_nochild_pixmap[i] = PixmapFromXPM((char **) tree_xpm, color);
		tree_nochild_term_pixmap[i] = PixmapFromXPM((char **) tree_term_xpm, color);
	}
*/
	/* Set up a font for the tree */
/*old
	if ((treefont = gdk_font_load(_Conf.Get("edeity.gtk.font.packages"))) == NULL) {
		fprintf(stderr, "Cannot load pkgtree font: %s, trying fixed..\n", _Conf.Get("edeity.gtk.font.packages"));
		if ((treefont = gdk_font_load("fixed")) == NULL) {
			fprintf(stderr, "Unable to load font fixed, exiting..\n");
			exit(0);
		}
	}
	vspacing = 20;		// should not be hardcoded?

	// This gets overridden in the resize event below
	memset(columnoffsets, 0, sizeof(columnoffsets));

	SetupGCs();
*/
	/* Create the owner-draw tree widget */
/*old	theTree = gtk_drawing_area_new();

	GTK_WIDGET_SET_FLAGS(theTree, GTK_CAN_FOCUS);

	// Capture the events we want
	gtk_widget_set_events(theTree, GDK_EXPOSURE_MASK
			      | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK |
			      GDK_KEY_PRESS_MASK | GDK_POINTER_MOTION_MASK |
			      GDK_POINTER_MOTION_HINT_MASK | GDK_LEAVE_NOTIFY_MASK);

	gtk_signal_connect(GTK_OBJECT(theTree), "realize", GTK_SIGNAL_FUNC(Realize), this);
	gtk_signal_connect(GTK_OBJECT(theTree), "configure-event", GTK_SIGNAL_FUNC(Resize),
			   this);
	gtk_signal_connect(GTK_OBJECT(theTree), "expose-event", GTK_SIGNAL_FUNC(Expose), this);
	gtk_signal_connect(GTK_OBJECT(theTree), "button_press_event",
			   GTK_SIGNAL_FUNC(ButtonPress), this);
	gtk_signal_connect(GTK_OBJECT(theTree), "button_release_event",
			   GTK_SIGNAL_FUNC(ButtonRelease), this);
	gtk_signal_connect(GTK_OBJECT(theTree), "motion_notify_event",
			   GTK_SIGNAL_FUNC(MotionNotify), this);
	gtk_signal_connect(GTK_OBJECT(theTree), "leave_notify_event",
			   GTK_SIGNAL_FUNC(LeaveNotify), this);
			   
	g_signal_connect(G_OBJECT(theTree), "realize",
			 G_CALLBACK(Realize), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "configure-event",
			 G_CALLBACK(Resize), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "expose-event",
			 G_CALLBACK(Expose), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "button_press_event",
			 G_CALLBACK(ButtonPress), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "button_release_event",
			 G_CALLBACK(ButtonRelease), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "motion_notify_event",
			 G_CALLBACK(MotionNotify), gpointer(this));
	g_signal_connect(G_OBJECT(theTree), "leave_notify_event",
			 G_CALLBACK(LeaveNotify), gpointer(this));
*/
}

GtkUI::PkgTreeWidget::~PkgTreeWidget()
{



	/* Save the values of the column offsets before we die */
/*old	char buf[10];
	snprintf(buf, 10, "%f", (float) realcoloffsets[1] / theTree->allocation.width);
	_Conf.Set("edeity.gtk.tree.columnoffset.1", buf);
	snprintf(buf, 10, "%f", (float) realcoloffsets[2] / theTree->allocation.width);
	_Conf.Set("edeity.gtk.tree.columnoffset.2", buf);
	snprintf(buf, 10, "%f", (float) realcoloffsets[3] / theTree->allocation.width);
	_Conf.Set("edeity.gtk.tree.columnoffset.3", buf);
	snprintf(buf, 10, "%f", (float) realcoloffsets[4] / theTree->allocation.width);
	_Conf.Set("edeity.gtk.tree.columnoffset.4", buf);
	snprintf(buf, 10, "%f", (float) realcoloffsets[5] / theTree->allocation.width);
	_Conf.Set("edeity.gtk.tree.columnoffset.5", buf);
*/	
}

/* static event handlers */

/*old
gint GtkUI::PkgTreeWidget::Resize(GtkWidget * widget, GdkEventConfigure * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (tree->bpixmap != 0)
	{
//old		gdk_pixmap_unref(tree->bpixmap);
		g_object_unref(G_OBJECT(tree->bpixmap));
	}

	tree->bpixmap = gdk_pixmap_new(widget->window, widget->allocation.width,
		widget->allocation.height, -1);

	// these are cumulative offsets //

	tree->columnoffsets[0] = (0 * widget->allocation.width);
	tree->realcoloffsets[0] = (0 * widget->allocation.width);

	tree->columnoffsets[1] = (int)(_Conf.GetFloat("edeity.gtk.tree.columnoffset.1") * widget->allocation.width);
	tree->realcoloffsets[1] = (_Conf.GetFloat("edeity.gtk.tree.columnoffset.1") * widget->allocation.width);

	tree->columnoffsets[2] = (int)(_Conf.GetFloat("edeity.gtk.tree.columnoffset.2") * widget->allocation.width);
	tree->realcoloffsets[2] = (_Conf.GetFloat("edeity.gtk.tree.columnoffset.2") * widget->allocation.width);
	
	tree->columnoffsets[3] = (int)(_Conf.GetFloat("edeity.gtk.tree.columnoffset.3") * widget->allocation.width);
	tree->realcoloffsets[3] = (_Conf.GetFloat("edeity.gtk.tree.columnoffset.3") * widget->allocation.width);

	tree->columnoffsets[4] = (int)(_Conf.GetFloat("edeity.gtk.tree.columnoffset.4") * widget->allocation.width);
	tree->realcoloffsets[4] = (_Conf.GetFloat("edeity.gtk.tree.columnoffset.4") * widget->allocation.width);

	tree->columnoffsets[5] = (int)(_Conf.GetFloat("edeity.gtk.tree.columnoffset.5") * widget->allocation.width);
	tree->realcoloffsets[5] = (_Conf.GetFloat("edeity.gtk.tree.columnoffset.5") * widget->allocation.width);

	tree->columnoffsets[6] = widget->allocation.width;
	tree->realcoloffsets[6] = widget->allocation.width;

	tree->screen.BoundsReset();
	tree->UpdateAdjustment();
	tree->QueueRedraw();

	return TRUE;
}
*/
/*old
gint GtkUI::PkgTreeWidget::Expose(GtkWidget * widget, GdkEventExpose * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	gdk_draw_pixmap(widget->window, widget->style->fg_gc[GTK_WIDGET_STATE(widget)],
			tree->bpixmap, event->area.x, event->area.y, event->area.x,
			event->area.y, event->area.width, event->area.height);
			
	GdkGCValues *values;			
	gdk_gc_get_values(widget->style->fg_gc[GTK_WIDGET_STATE(widget)], values);
	values->clip_mask = tree->bpixmap;
	gdk_draw_rectangle (widget->window, widget->style->fg_gc[GTK_WIDGET_STATE(widget)], FALSE,
			    event->area.x, event->area.y, event->area.width, event->area.height);
			    
	return FALSE;
}
*/
/*old
void GtkUI::PkgTreeWidget::Realize(GtkWidget * widget, gpointer data)
{
	//GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	// what should we really do here?
//old	gdk_window_set_background(widget->window, &widget->style->base[GTK_STATE_NORMAL]);
	gtk_widget_modify_bg(widget, GTK_STATE_NORMAL, &widget->style->base[GTK_STATE_NORMAL]);
}
*/
/*old
// tmp debug func
void GtkUI::PkgTreeWidget::PrintPackage(::PackageTree::Item * p)
{
	if (p->IsDivider())
	{
		string format = screen.Packages->GetHeaderDesc(p);
		g_print("%s", format.c_str());
	}
	else
	{
		g_print("%s", p->TargetPkg.Name());
	}
}
*/

gboolean GtkUI::PkgTreeWidget::ButtonPress(GtkWidget * w, GdkEventButton * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree->tree));
/*old	int oldcursor = tree->screen._cursor - tree->screen._boundstart;
	int newcursor = (int) (event->y / tree->vspacing) - 1;

	
//	   g_print("Button press event: x=%.00f,y=%.00f\n", event->x, event->y);
//	   g_print("cursor = %d, boundstart = %d\n", tree->screen._cursor, tree->screen._boundstart);
//	   g_print("oldcur = %d, newcur = %d\n", oldcursor, newcursor);
//	   g_print("Old cursor is on package: ");
//	   tree->PrintPackage(tree->screen.cs);
//	   g_print("\n");

	gdk_pointer_grab(tree->theTree->window, FALSE,
			 (GdkEventMask) (GDK_POINTER_MOTION_MASK | GDK_BUTTON_RELEASE_MASK),
			 NULL, NULL, event->time);
	if (newcursor < 0 || newcursor > (tree->screen._boundend - tree->screen._boundstart))
		return 0;	// outside of bounds 
*/

	GtkTreePath *path;

	if ((event->type == GDK_BUTTON_PRESS) && (event->button == 3) &&
	    gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW (tree->tree), 
					   gint (event->x), gint (event->y), 
					   &path, NULL, 
					   NULL, NULL))
	{    
		GtkTreeIter iter;
		::PackageTree::Item *T;
	
		gtk_tree_model_get_iter (treemodel, &iter, path);
		gtk_tree_model_get (treemodel, &iter, tree->Item_Col, &T, -1);	
		tree->screen.cs = T;
	
		switch (T->Type)
		{
		case ::PackageTree::Item::Div_State:
		case ::PackageTree::Item::Div_sState:
		case ::PackageTree::Item::Div_Sect:
		case ::PackageTree::Item::Div_Pri:
		case ::PackageTree::Item::Div_Custom:
		case ::PackageTree::Item::Div_Size:
		case ::PackageTree::Item::Div_iSize:
		case ::PackageTree::Item::Div_Suite:
		case ::PackageTree::Item::Div_fName:
		case ::PackageTree::Item::Div_Dep:
		case ::PackageTree::Item::Div_rDep:
		
			
		    if (gtk_tree_view_row_expanded (GTK_TREE_VIEW (tree->tree), path))
			{
				if (tree->screen.Packages->Sorting->Length() == gtk_tree_path_get_depth (path))
			    {
					GtkItemFactoryEntry items[] = {
						{ NULL,					NULL,	NULL,		0,	"<Title>" },
			    		{ "/sep",				NULL,	NULL,		0,	"<Separator>" },
					 	{ _("/Install"),		NULL,	GtkItemFactoryCallback(MarkSection),	0,	"<Item>" },
			    		{ _("/Keep"),			NULL,	GtkItemFactoryCallback(MarkSection),	1,	"<Item>" },
//						{ "/Purge",				NULL,	GtkItemFactoryCallback(MarkSection),	2,	"<Item>" },
				    	{ _("/Reinstall"),		NULL,	GtkItemFactoryCallback(MarkSection),	3,	"<Item>" },
//						{ "/Remove",			NULL,	GtkItemFactoryCallback(MarkRemove),		4,	"<Item>" },
						{ _("/Upgrade"),		NULL,	GtkItemFactoryCallback(MarkSection),	5,	"<Item>" },
					};
   					const gint nitems = sizeof (items) / sizeof (items[0]);

					GtkTreeIter iter;
					gchar *name, buff[64];
				
					gtk_tree_model_get_iter (treemodel, &iter, path);
					gtk_tree_model_get (treemodel, &iter, 1, &name, -1);
			
					snprintf(buff, 64, _("/All in section %s"), name);
					items[0].path = buff;
			
					GtkItemFactory *item_factory = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);				
					gtk_item_factory_create_items(item_factory, nitems, items, gpointer (tree));

					gtk_menu_popup (GTK_MENU (gtk_item_factory_get_widget(item_factory, "<main>")),
									NULL, NULL, NULL, NULL, event->button, event->time);
				}
			}
			else
			{
				GtkItemFactoryEntry items[] = {
					{ NULL,						NULL,	NULL,		0,	"<Title>" },
		    		{ "/sep",					NULL,	NULL,		0,	"<Separator>" },
				 	{ _("/Filter this"),		NULL,	GtkItemFactoryCallback(FilterSection),	0,	"<Item>" },
					{ _("/Fliter like this"),	NULL,	GtkItemFactoryCallback(FilterSection),	1,	"<Item>" },
				};
				const gint nitems = sizeof (items) / sizeof (items[0]);

				GtkTreeIter iter;
				gchar *name, buff[64];
				
				gtk_tree_model_get_iter (treemodel, &iter, path);
				gtk_tree_model_get (treemodel, &iter, 1, &name, -1);
			
				snprintf(buff, 64, _("/Filter section %s"), name);
				items[0].path = buff;
			
				GtkItemFactory *item_factory = gtk_item_factory_new (GTK_TYPE_MENU, "<main>", NULL);				
				gtk_item_factory_create_items(item_factory, nitems, items, gpointer (tree));

				gtk_menu_popup (GTK_MENU (gtk_item_factory_get_widget(item_factory, "<main>")),
								NULL, NULL, NULL, NULL, event->button, event->time);
			}
			
		    break;
		    
		default:
		    gtk_tree_selection_select_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (tree->tree)), path);    
		
		    GtkWidget * menu = tree->MakeContextMenu(T);
		    gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL, event->button, event->time);
		    return TRUE;
		}
	}
/*
	switch (event->type)
	{
	case GDK_BUTTON_PRESS:
		// highlight the package //
		if (event->button == 1)
		{
			tree->MoveCursor(newcursor - oldcursor);
//			   left mouse click-- 
//			   check to see if the user clicked in an expand/collapse box
//
//			if (fabs(tree->screen.cs->increment * GTKUI_PKG_INDENT +
//				 GTKUI_PKG_ICON_SIZE / 2 - event->x) < 5
//			    && fabs((newcursor + 1) * tree->vspacing + 5 +
//				    GTKUI_PKG_ICON_SIZE / 2 - event->y) < 5)
//				g_print("Inside the square!\n");

			tree->screen.UpdateDescription();
		}
		else if (event->button == 3)
		{		// right mouse click //
			tree->MoveCursor(newcursor - oldcursor);
			tree->screen.UpdateDescription();

			switch (tree->screen.cs->Type)
			{
			case ::PackageTree::Item::Div_State:
			case ::PackageTree::Item::Div_Sect:
			case ::PackageTree::Item::Div_Pri:
			case ::PackageTree::Item::Div_Custom:
				break;
			default:
				GtkWidget * menu = tree->MakeContextMenu(tree->screen.cs);
				gtk_menu_popup(GTK_MENU(menu), NULL, NULL, NULL, NULL,
					       event->button, event->time);
				return TRUE;
			}
		} 
		else if (event->button == 4)
		{
			tree->screen.ArrowUp();
		}
		else if (event->button == 5)
		{
			tree->screen.ArrowDown();
		}
		return TRUE;

	case GDK_2BUTTON_PRESS:
		// expand the package (?) //
		if (event->button == 1)
			tree->DependToggle();
		return TRUE;
	default:
		// nothing // ;
	};
*/
	return FALSE;
	
}

/*old
gboolean GtkUI::PkgTreeWidget::ButtonRelease(GtkWidget * w, GdkEventButton * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	//g_print("Button release event: x=%.00f,y=%.00f\n", event->x, event->y);
	gdk_pointer_ungrab(event->time);
	if (tree->resizingcolumn > 0) {
		tree->resizingcolumn = -1;
		gdk_window_set_cursor(tree->theTree->window, NULL);
		tree->QueueRedraw();
	}
	return 0;
}
*/

gboolean GtkUI::PkgTreeWidget::MotionNotify(GtkWidget * widget, GdkEventMotion * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
/*	gint x, y;
	GdkModifierType state;

	if (event->is_hint)
	{
		gdk_window_get_pointer(event->window, &x, &y, &state);
	}
	else
	{
		x = (gint) event->x;
		y = (gint) event->y;
		state = (GdkModifierType) event->state;
	}

	int cursor = y / tree->vspacing - 1;
	if (cursor > (tree->screen._boundend - tree->screen._boundstart))
	{
		// outside of bounds //
		tree->RemovePrelight();
		return 0;
	}
		
	if (cursor < 0)
	{
		// in heading row, check for column resizing
		if (state & GDK_BUTTON1_MASK)
		{
			//g_print("x = %d, y = %d, b1 = %s\n", x, y, (state & GDK_BUTTON1_MASK ? "on" : "off"));
			if (tree->resizingcolumn < 0) 
				for (int col = 1; col < GTKUI_PKGTREE_COLUMNS; col++) {
				//g_print("x = %d, column[%d] = %d\n", x, col, tree->columnoffsets[col]);
					// give a bit of room
					if (abs(x - tree->columnoffsets[col]) < 3) {
						tree->resizingcolumn = col;
						GdkCursor *cursor = gdk_cursor_new(GDK_SB_H_DOUBLE_ARROW);
						gdk_window_set_cursor(tree->theTree->window, cursor);
//old						gdk_cursor_destroy(cursor);
						gdk_cursor_unref(cursor);
						break;
					}
				}
			tree->ColumnResize(x);
		}
		return 0;
	}
	if (tree->resizingcolumn > 0)
		tree->ColumnResize(x);

	
	 // --That whole MoveCursor thing is eeeevil.		//
	 // <captain>  The borg have adapted!   </captain>	//
	 

	if (cursor != tree->screen._prelight)
		tree->DoPrelight(cursor);
	return 0;
*/	
	GtkTreePath *current;
	
	if (gtk_tree_view_get_path_at_pos (GTK_TREE_VIEW (tree->tree), 
				           gint (event->x), 
					   gint (event->y),
				           &current,
				           NULL,
				           NULL,
				           NULL))
	{				   
	    if (!tree->screen._prelight)
	    {
		tree->screen._prelight = current;
		tree->DoPrelight(current);
	    }
	    else			   
		if (gtk_tree_path_compare (tree->screen._prelight, current) != 0)
		{
		    tree->RemovePrelight ();
		    tree->DoPrelight(current);
		    tree->screen._prelight = current;
		}
	}
		
	return FALSE;
}


gboolean GtkUI::PkgTreeWidget::LeaveNotify(GtkWidget * w, GdkEventCrossing * event, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	tree->RemovePrelight();
	return 0;
}

gboolean GtkUI::PkgTreeWidget::DragColumn(GtkTreeView *tree_view, GtkTreeViewColumn *column, GtkTreeViewColumn *prev_column, GtkTreeViewColumn *next_column, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	ColOrderList::Node *node = (ColOrderList::Node *) g_object_get_data(G_OBJECT(next_column), "method");
		
	if (!node) return FALSE;
	
	if ((node->thiscolumn == ColOrderList::PkgName) || 
		(node->thiscolumn == ColOrderList::Is) || 
		(node->thiscolumn == ColOrderList::Will))
		return FALSE;
		
	tree->colchange = true;
			
	return TRUE;
}

void GtkUI::PkgTreeWidget::ColumnsChanged (GtkTreeView *tree_view, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	int ncolumn = tree->screen.Packages->Columns->Length();

	if (!tree->colchange) return;
	tree->colchange = false;
	
	ColOrderList *orderlist = new ColOrderList;
	ColOrderList::Node *node;
	GtkTreeViewColumn *column;
	
	orderlist->Flush();
	for (int i = 1; i <= ncolumn; i++)
	{
		column = gtk_tree_view_get_column (tree_view, i);
		node = (ColOrderList::Node *) g_object_get_data(G_OBJECT(column), "method");
		orderlist->Push (node->thiscolumn);
		g_object_set_data(G_OBJECT(column), "method", gpointer (orderlist->ListFind(node->thiscolumn)));
	}

	delete 	tree->screen.Packages->Columns;
	tree->screen.Packages->Columns = orderlist;
}


/*old	
void GtkUI::PkgTreeWidget::ColumnResize(gint x)
{
	if (resizingcolumn <= 0) return;

	int offset = x - columnoffsets[resizingcolumn];
	
	// check if we are resizing past the previous or next column
	if ((offset > 0 && x > columnoffsets[resizingcolumn+1]) ||
	    (offset < 0 && x < columnoffsets[resizingcolumn-1]))
		return;
		
	for (int j = resizingcolumn; j < GTKUI_PKGTREE_COLUMNS; j++)
	{
		columnoffsets[j] += offset;
		realcoloffsets[j] += offset;
	}
	QueueRedraw();
}
*/

void GtkUI::PkgTreeWidget::FilterSection(gpointer data, guint filter, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	GtkTreeIter iter;
	GtkTreePath *path;
	GtkTreeModel *model;
	GtkTreeSelection *select = gtk_tree_view_get_selection (GTK_TREE_VIEW (tree->tree));
	
	int depth;
	char *text;
	unsigned long target;

	PackageTree::Item *T;
	SortOrderList::method_t method;


	if (!gtk_tree_selection_get_selected (select, &model, &iter)) return;

	gtk_tree_model_get (model, &iter, tree->Item_Col, &T, -1);	

	path = gtk_tree_model_get_path (model, &iter);
	depth = gtk_tree_path_get_depth (path);

	for (SortOrderList::SortIterator I = tree->screen.Packages->Sorting->ListBegin(); I.seq() <= depth; I++)
		method = I.method();
		
	switch (method) {
	case SortOrderList::Priority:
		tree->screen.Packages->Filters->Push (T->Priority(), (Cmp_Or | Cmp_Cont | Pkg_Priority));
	break;
	}

	
	tree->rescanpath = strdup ("0");
	tree->screen.Packages->apply_filters();
	tree->screen.BoundsReset();
	tree->screen.Redraw();
}

void GtkUI::PkgTreeWidget::MarkSection(gpointer data, guint markto, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	::PackageTree::Item *T = tree->screen.cs;
	T = T->child;
	
	do{
	    tree->screen.cs = T;
	    switch (markto)
	    {
		case 0:
		    tree->MarkInstall(data, 0, NULL);
		break;
		case 1:
		    tree->MarkKeep(data, 0, NULL);
		break;
		case 2:
		    tree->MarkPurge(data, 0, NULL);
		break;
		case 3:
		    tree->MarkReinstall(data, 0, NULL);
		break;
		case 4:
		    tree->MarkRemove(data, 0, NULL);
		break;
		case 5:
		    tree->MarkUpgrade(data, 0, NULL);
		break;
	    }
	    T = T->next;
	} while (T);
	
	tree->screen.cs = tree->screen.cs->parent;
}

void GtkUI::PkgTreeWidget::MarkKeep(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	pkgCache::PkgIterator p = tree->screen.cs->TargetPkg;

	(*Cache)->MarkKeep(p);
	(*Cache)->SetReInstall(p, false);

	tree->MarkAll(tree, NULL);	
	tree->screen.UpdateStatus();
	/* Should only redraw this package */
//old	tree->QueueRedraw();
}

void GtkUI::PkgTreeWidget::MarkInstall(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	
	if (tree->screen.cs->IsDivider()) return;

	pkgCache::PkgIterator p = tree->screen.cs->TargetPkg;

	TryInstall(p);

	tree->MarkAll(tree, NULL);	
	tree->screen.UpdateStatus();
	/* TODO: Because installing one package can trigger others to change state. 
	   However, perhaps an algorithm to check the deps of the package and then
		 look for them on the screen and redraw those items which have changed.
		 This may be wise considering redraws are slow in gtk -- Pat */
//old	tree->QueueRedraw();
}

void GtkUI::PkgTreeWidget::MarkUpgrade(gpointer data, guint callback_action, GtkWidget * item)
{
	MarkInstall(data, callback_action, item);
}

void GtkUI::PkgTreeWidget::MarkReinstall(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (tree->screen.cs->IsDivider()) return;

	pkgCache::PkgIterator p = tree->screen.cs->TargetPkg;

	TryInstall(p, true);

	tree->MarkAll(tree, NULL);	
	tree->screen.UpdateStatus();
	/* Should only redraw this package */
//old	tree->QueueRedraw();
}

void GtkUI::PkgTreeWidget::MarkRemove(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (tree->screen.cs->IsDivider()) return;
	
	pkgCache::PkgIterator p = tree->screen.cs->TargetPkg;

	TryRemove(p);

	tree->MarkAll(tree, NULL);	
	tree->screen.UpdateStatus();
	// probably should only redraw this one item 
//old	tree->QueueRedraw();
}

void GtkUI::PkgTreeWidget::MarkPurge(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (tree->screen.cs->IsDivider()) return;
	
	pkgCache::PkgIterator p = tree->screen.cs->TargetPkg;

	TryRemove(p, true);

	tree->MarkAll(tree, NULL);	
	tree->screen.UpdateStatus();
	// probably should only redraw this one item 
//old	tree->QueueRedraw();
}

void GtkUI::PkgTreeWidget::MarkHold(gpointer data, guint callback_action, GtkWidget * item)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (tree->screen.cs->IsDivider()) return;

	// we don't do this yet (?)
}


void GtkUI::PkgTreeWidget::RowExpanded (GtkTreeView *view, GtkTreeIter *iter, GtkTreePath *path, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	if (tree->inscan) return;
	
	gtk_tree_selection_select_iter (gtk_tree_view_get_selection (view), iter);
	tree->rescanpath = gtk_tree_path_to_string (path);

	DefaultKeys::depend_toggle(&tree->screen);
}

void GtkUI::PkgTreeWidget::RowCollapsed (GtkTreeView *view, GtkTreeIter *iter, GtkTreePath *path, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	
	gtk_tree_selection_select_iter (gtk_tree_view_get_selection (view), iter);
	tree->rescanpath = gtk_tree_path_to_string (path);
	
	DefaultKeys::depend_toggle(&tree->screen);
}

void GtkUI::PkgTreeWidget::RowChanged (GtkTreeSelection *select, gpointer data)
{
	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;
	
	::PackageTree::Item *T;
	GtkTreeModel *model;
	GtkTreeIter iter;
	
	if (!gtk_tree_selection_get_selected (select, &model, &iter)) return;
	gtk_tree_model_get (model, &iter, tree->Item_Col, &T, -1);	
	
	tree->screen.cs = T;
	tree->screen.UpdateDescription();
}

void GtkUI::PkgTreeWidget::RowActivated (GtkTreeView *view, GtkTreePath *path, GtkTreeViewColumn *column, gpointer data)
{
//	GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;

	if (gtk_tree_view_row_expanded (view, path))
		gtk_tree_view_collapse_row (view, path);
	else
		gtk_tree_view_expand_row (view, path, FALSE);
	
}

/* ----------------------------- 
 * End of event handlers 
 * ----------------------------- */

 
void GtkUI::PkgTreeWidget::MarkAll(gpointer data, GtkTreePath *path)
{
	if (!path)
	{
	    MarkAll (data, gtk_tree_path_new_from_string ("0"));
	    return;
	}
	
        GtkUI::PkgTreeWidget * tree = (GtkUI::PkgTreeWidget *) data;


	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree->tree));
	GtkTreePath *next = gtk_tree_path_copy (path), *down = gtk_tree_path_copy (path);
	GtkTreeIter iter;
	
	if (gtk_tree_model_get_iter (treemodel, &iter, path))
	{
	    ::PackageTree::Item *T;
	    gtk_tree_model_get (treemodel, &iter, tree->Item_Col, &T, -1);
	
	    if (T)
	    if (!T->IsDivider())
	    {
	        pkgCache::PkgIterator I = T->TargetPkg;
	        gtk_tree_store_set (tree->treestore, &iter,
				    Will_Col, ((*Cache)[I].InstBroken()? _("Broken") : ((*Cache)[I].  NewInstall()? _("Install") : ((*Cache)[I].  Upgrade()?  _("Upgrade") : ((*Cache)[I].  Downgrade()?  _("Delete") : ((*Cache) [I].  Install()?  _("Install") : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? _("Purge") : _("Remove")) : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? _("Reinstall") : _("Keep"))))))),
				    -1);
	    }
	}
	
	gtk_tree_path_down (down);
	if (gtk_tree_model_get_iter (treemodel, &iter, down))
	    MarkAll (tree, down);
	gtk_tree_path_free (down);

	gtk_tree_path_next (next);
	if (gtk_tree_model_get_iter (treemodel, &iter, next))
    	    MarkAll (tree, next);
	gtk_tree_path_free (next);
}

void GtkUI::PkgTreeWidget::SeekToItem(::PackageTree::Item *T, GtkTreePath *path)
{
	if (!path)
	{
	    SeekToItem (T, gtk_tree_path_new_from_string ("0"));
	    return;
	}
	
	if (T->parent) SeekToItem(T->parent, path);
    
	for (::PackageTree::Item *Q = T; Q->prev; Q = Q->prev) gtk_tree_path_next (path);
    
	if (T->IsPackage())
	{
	    gtk_tree_view_scroll_to_cell (GTK_TREE_VIEW (tree), path, NULL, TRUE, 0.5, 0.5);
	    gtk_tree_selection_select_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (tree)), path);
	}

	gtk_tree_path_down (path);
}


void GtkUI::PkgTreeWidget::ExpandRow (::PackageTree::Item *T, GtkTreeIter *iter)
{
	GtkTreeIter iterchild;
	GtkTreeModel *treemodel;

	for (T = T->child; T; T = T->next)
		InsertRow(T, this, iter);

	treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree));
	gtk_tree_model_iter_children (treemodel, &iterchild, iter);
	gtk_tree_store_remove (GTK_TREE_STORE (treemodel), &iterchild);
}

void GtkUI::PkgTreeWidget::CollapseRow (::PackageTree::Item *T, GtkTreeIter *iter)
{
	GtkTreeIter iterchild;
	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree));

	for (; gtk_tree_model_iter_nth_child (treemodel, &iterchild, iter, 0);)
            gtk_tree_store_remove (GTK_TREE_STORE (treemodel), &iterchild);
	    
	gtk_tree_store_append (GTK_TREE_STORE (treemodel), &iterchild, iter); 
	gtk_tree_store_set (GTK_TREE_STORE (treemodel), &iterchild, Item_Col, NULL, -1);
}
 
void GtkUI::PkgTreeWidget::InsertRow(::PackageTree::Item * T, GtkUI::PkgTreeWidget *tree, GtkTreeIter *iter)
{
/*old	    if (T->IsDepend() && T->IsExpanded())
	    {
		    tree->InsertPackage(T, tree, iter);
		    return;
	    }
*/

	    switch (T->Type)
	    {
		case ::PackageTree::Item::Div_State:
		case ::PackageTree::Item::Div_sState:
		case ::PackageTree::Item::Div_Sect:
		case ::PackageTree::Item::Div_Pri:
		case ::PackageTree::Item::Div_Custom:
		case ::PackageTree::Item::Div_Size:
		case ::PackageTree::Item::Div_iSize:
		case ::PackageTree::Item::Div_Suite:
		case ::PackageTree::Item::Div_Dep:
		case ::PackageTree::Item::Div_rDep:
		    tree->InsertHeader(T, tree, iter);
		break;
		case ::PackageTree::Item::Pkg:
		case ::PackageTree::Item::Dep:
		case ::PackageTree::Item::RevDep:
		    tree->InsertPackage(T, tree, iter);
//old		case ::PackageTree::Item::Dep:
//old		    tree->InsertDepend(T, tree, iter);
		break;
		default:		/* shouldn't happen */
		    NOTREACHED(_("Unknown package type"));
		    break;
	    }
    }
 
 
void GtkUI::PkgTreeWidget::InsertHeader(::PackageTree::Item * T, GtkUI::PkgTreeWidget *tree, GtkTreeIter *iter)
{
	if (!T->child) return;
	
	GtkTreeIter iterchild, itertmp;
	
	char *name = strdup (tree->screen.Packages->GetHeaderDesc(T).c_str()), *desc = NULL;

	for (desc = name; *desc != ':' && *desc != '(' && *desc != 0; desc++);

	switch (*desc)
	{
	    case '(': 
		name[strlen (name) - 1] = 0;
		*desc = 0;
		desc++;
		desc[0] = toupper(desc[0]);
		break;
		
	    case ':':
		*desc = 0;
		desc += 2;
		desc[0] = toupper(desc[0]);
		break;
		
	    default:
		desc = name;
	}
	
	gtk_tree_store_append (tree->treestore, &iterchild, iter); 
	gtk_tree_store_set (tree->treestore, &iterchild,
			    Icon_Col, gdk_pixbuf_new_from_xpm_data((const char **) divider_xpm),
			    Name_Col, name,
			    6, desc,
			    Item_Col, T,
			    Color_Col, &normal_c,
			    -1);
	
	free (name);
			    
	if (T->child) 
	{
	    gtk_tree_store_append (tree->treestore, &itertmp, &iterchild); 
	    gtk_tree_store_set (tree->treestore, &itertmp, Item_Col, NULL, -1);
	}
}

void GtkUI::PkgTreeWidget::InsertPackage(::PackageTree::Item * T, GtkUI::PkgTreeWidget *tree, GtkTreeIter *iter)
{
	GtkTreeIter iterchild, itertmp;
	GdkPixbuf *icon = NULL;
	
	gsize bytes_read, bytes_written;
	GError *error = NULL;

	if (T->Type == PackageTree::Item::Dep || T->Type == PackageTree::Item::RevDep)
	{
		pkgCache::DepIterator * D = (pkgCache::DepIterator *) (T->Extra);
	
		if (strcmp(D->DepType(), "Depends") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)depends_xpm);
		else if (strcmp(D->DepType(), "PreDepends") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)depends_xpm);
		else if (strcmp(D->DepType(), "Recommends") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)recommends_xpm);
		else if (strcmp(D->DepType(), "Suggests") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)suggests_xpm);
		else if (strcmp(D->DepType(), "Replaces") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)replaces_xpm);
		else if (strcmp(D->DepType(), "Conflicts") == 0)
			icon = gdk_pixbuf_new_from_xpm_data((const char **)conflicts_xpm);
	}
	else
	{
		icon = gdk_pixbuf_new_from_xpm_data((const char **) package_xpm);
	}

	gtk_tree_store_append (tree->treestore, &iterchild, iter); 
	gtk_tree_store_set (tree->treestore, &iterchild,
		    Icon_Col, icon,
		    Name_Col, T->Name(),
		    Is_Col, T->Is(),
		    Will_Col, T->Will(),
		    4, T->AvlVer(),
		    5, T->InstVer(),
		    6, g_locale_to_utf8 (T->ShortDesc(), -1, &bytes_read, &bytes_written, &error),
		    7, g_locale_to_utf8 (T->LongDesc(), -1, &bytes_read, &bytes_written, &error),
			8, g_locale_to_utf8 (T->Maintainer(), -1, &bytes_read, &bytes_written, &error),
			9, T->MD5Hash(),
			10, T->Size(),
			11, T->Instsize(),
			12, T->FileName(),
			13, T->Section(),
			14, T->Priority(),
			15, T->IsDepended() ? "Yes" : "No",
			16, T->IsRevDepended() ? "Yes" : "No",
		    Item_Col, T,
		    Color_Col, &normal_c,
		    -1);
				
	if (!(T->Version().end() || 
		 (T->Depend().end() && tree->screen.Packages->DepType() == PackageTree::NormDep) || 
		 (T->RevDepend().end() && tree->screen.Packages->DepType() == PackageTree::RevDep)))
	{
	    gtk_tree_store_append (tree->treestore, &itertmp, &iterchild); 
	    gtk_tree_store_set (tree->treestore, &itertmp, Item_Col, NULL, -1);
	}
}
/*old
void GtkUI::PkgTreeWidget::InsertDepend(::PackageTree::Item * T, GtkUI::PkgTreeWidget *tree, GtkTreeIter *iter)
{
	GtkTreeIter iterchild, itertmp;
    	pkgCache::VerIterator V, InstV;
	pkgCache::PkgIterator I;
	GdkPixbuf *icon = NULL;

	gsize bytes_read, bytes_written;
	GError *error = NULL;

	pkgCache::DepIterator * D = (pkgCache::DepIterator *) (T->Extra);
	
	if (strcmp(D->DepType(), "Depends") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)depends_xpm);
	else if (strcmp(D->DepType(), "PreDepends") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)depends_xpm);
	else if (strcmp(D->DepType(), "Recommends") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)recommends_xpm);
	else if (strcmp(D->DepType(), "Suggests") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)suggests_xpm);
	else if (strcmp(D->DepType(), "Replaces") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)replaces_xpm);
	else if (strcmp(D->DepType(), "Conflicts") == 0)
		icon = gdk_pixbuf_new_from_xpm_data((const char **)conflicts_xpm);

        I = T->TargetPkg;
        V = (*Cache)[I].CandidateVerIter(*Cache);
        InstV = (*Cache)[I].InstVerIter(*Cache);
	
        gtk_tree_store_append (tree->treestore, &iterchild, iter); 
        gtk_tree_store_set (tree->treestore, &iterchild,
			    Icon_Col, icon,
			    Name_Col, T->Name(),
			    Is_Col, T->Is(),
			    Will_Col, T->Will(),
			    4, T->AvlVer(),
			    5, T->InstVer(),
			    6, g_locale_to_utf8 (T->ShortDesc(), -1, &bytes_read, &bytes_written, &error),
			    7, g_locale_to_utf8 (T->LongDesc(), -1, &bytes_read, &bytes_written, &error),
				8, g_locale_to_utf8 (T->Maintainer(), -1, &bytes_read, &bytes_written, &error),
				9, T->MD5Hash(),
				10, T->Size(),
				11, T->Instsize(),
				12, T->FileName(),
			    Item_Col, T,
			    Color_Col, &normal_c,
   			    -1);
				
        if (!(T->Version().end() || T->Version().DependsList().end()))
	{
	    gtk_tree_store_append (tree->treestore, &itertmp, &iterchild); 
	    gtk_tree_store_set (tree->treestore, &itertmp, Item_Col, NULL, -1);
	}
}
*/

//old int GtkUI::PkgTreeWidget::DoPrelight(int y_ref)
void GtkUI::PkgTreeWidget::DoPrelight(GtkTreePath *current)
{
/*old	::PackageTree::Iterator T;
	int nc;
	GdkRectangle update_rect;

	// Change state of old prelitten object
	if (!screen.pl.Invalid())
	{
		Drawline(screen.pl, screen._prelight, false);
		update_rect.x = 0;
		update_rect.y = (screen._prelight + 1) * vspacing;
		update_rect.width = theTree->allocation.width;
		update_rect.height = vspacing;
//old		gtk_widget_draw(theTree, &update_rect);
		gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, 
						    update_rect.width, update_rect.height);
	}

	if (y_ref > screen.Packages->Length())
	{
		screen.pl = (::PackageTree::Item *) 0;
		return 0;
	}

	// Figure out place of the new one
	for (T = screen.bs, nc = 0; !T.Invalid() && nc < y_ref; nc++, T++);
	// g_print("Actually doing prelight: y_ref=%d pkg=%s bs=%d, bspkg=%s\n", y_ref, P->TargetPkg.Name(), screen._boundstart, screen.boundstart->TargetPkg.Name());

	// Light it if we should be doing that
	if (T.Invalid()) return 0;
	Drawline(T, y_ref, y_ref + screen._boundstart == screen._cursor ? false : true);
	update_rect.x = 0;
	update_rect.y = (y_ref + 1) * vspacing;
	update_rect.width = theTree->allocation.width;
	update_rect.height = vspacing;
//old	gtk_widget_draw(theTree, &update_rect);
	gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, 
					    update_rect.width, update_rect.height);

	// Set up the prelight variables for next round baybe //
	screen._prelight = y_ref;
	screen.pl = T;

	return 0;
*/
	GtkTreeIter iter;
	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree));

	if (gtk_tree_model_get_iter (treemodel, &iter, current))
		gtk_tree_store_set (GTK_TREE_STORE (treemodel), &iter, Color_Col, &prelight_c, -1);
}

void GtkUI::PkgTreeWidget::RemovePrelight()
{
/*	if (screen.pl.Invalid())
		return;

	// Change state of old prelitten object
	Drawline(screen.pl, screen._prelight, false);

	// tell gtk to update the two lines we updated //
	GdkRectangle update_rect;
	update_rect.x = 0;
	update_rect.y = (screen._prelight + 1) * vspacing;
	update_rect.width = theTree->allocation.width;
	update_rect.height = vspacing;
//old	gtk_widget_draw(theTree, &update_rect);
	gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, 
					    update_rect.width, update_rect.height);

	screen.pl = (::PackageTree::Item *) 0;
	screen._prelight = -1;
*/	
	GtkTreeIter iter;
	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree));
	
	if (screen._prelight)	//normaly it doesn't need
	if (gtk_tree_model_get_iter (treemodel, &iter, screen._prelight))
	    gtk_tree_store_set (GTK_TREE_STORE (treemodel), &iter, Color_Col, &normal_c, -1);
}

void GtkUI::PkgTreeWidget::AlignCols()
{
	GtkTreeViewColumn *column;
	GtkCellRenderer *renderer;
	ColOrderList *Cols = screen.Packages->Columns;
	
	int H = 1;
	int colnum = 0;

	for (;(column = gtk_tree_view_get_column(GTK_TREE_VIEW (tree), 1)) && (colnum != 1);)
		colnum = gtk_tree_view_remove_column(GTK_TREE_VIEW (tree), column);

	if (!colnum)
	{
		renderer = gtk_cell_renderer_pixbuf_new ();
    	column = gtk_tree_view_column_new_with_attributes (_("Type"), renderer,
														   "pixbuf", Icon_Col,
//														   "cell-background-gdk", Color_Col,
							        					   NULL);
							   
		gtk_tree_view_column_set_resizable (column, TRUE);
		gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_reorderable (column, FALSE);
		
		g_object_set_data(G_OBJECT(column), "method", gpointer (NULL));
		
		gtk_tree_view_append_column (GTK_TREE_VIEW (tree), column);
	}		
	
	for (ColOrderList::ColIterator C = Cols->ListBegin(); C.end() == false; C++, H++)
	{
	    colnum = C.column();
	    renderer = gtk_cell_renderer_text_new ();
		
	    column = gtk_tree_view_column_new_with_attributes (
								   Cols->Title(ColOrderList::column_t (colnum)), renderer,
							       "text", colnum + 1,
//							       "cell-background-gdk", Color_Col,
							       NULL);
		
	    gtk_tree_view_column_set_resizable (column, TRUE);
	    gtk_tree_view_column_set_sizing (column, GTK_TREE_VIEW_COLUMN_AUTOSIZE);
		gtk_tree_view_column_set_reorderable (column, C.orderable());
		
		g_object_set_data(G_OBJECT(column), "method", gpointer (C));
		
	    gtk_tree_view_append_column (GTK_TREE_VIEW (tree), column);
	}
}

void GtkUI::PkgTreeWidget::SetupCs()
{
	normal_c.red = normal_c.green = normal_c.blue = 0xffff;
	
	prelight_c.red = 0xff00;
	prelight_c.green = 0xdd00;
	prelight_c.blue = 0xff00;

}

/*old
// Set up the GCs //
void GtkUI::PkgTreeWidget::SetupGCs()
{
	GdkColor white, black, gray, magenta;

	if (normal_gc != NULL)
		return;		// only do this once!

	normal_gc = gdk_gc_new(screen.window->window);
	selected_gc = gdk_gc_new(screen.window->window);
	prelight_gc = gdk_gc_new(screen.window->window);
	matched_gc = gdk_gc_new(screen.window->window);

	GdkColormap *cmap = gdk_colormap_get_system();
//old	gdk_color_white(cmap, &white);
	gdk_colormap_alloc_color(cmap, &white, TRUE, FALSE);

//old	gdk_color_black(cmap, &black);
	black.red = black.green = black.blue = 0x0000;
	gdk_colormap_alloc_color(cmap, &black, TRUE, FALSE);

	gray.red = gray.green = gray.blue = 0xe500;
//old	gdk_color_alloc(cmap, &gray);
	gdk_colormap_alloc_color (cmap, &gray, TRUE, FALSE);
	magenta.red = 0xff00; magenta.green = 0xdd00; magenta.blue = 0xff00;
//old	gdk_color_alloc(cmap, &magenta);
	gdk_colormap_alloc_color (cmap, &magenta, TRUE, FALSE);

	gdk_gc_set_foreground(normal_gc, &black);
	gdk_gc_set_background(normal_gc, &white);

	gdk_gc_set_foreground(selected_gc, &white);
	gdk_gc_set_background(selected_gc, &black);

	gdk_gc_set_foreground(prelight_gc, &black);
	gdk_gc_set_background(prelight_gc, &gray);

	gdk_gc_set_foreground(matched_gc, &black);
	gdk_gc_set_background(matched_gc, &magenta);
}
*/
/*
void GtkUI::PkgTreeWidget::ScrollEvent(GtkAdjustment * adj)
{
	while (adj->value > screen._cursor)
	{
		screen.cs++;
		screen._cursor++;
	}
	while (adj->value < screen._cursor)
	{
		screen.cs--;
		screen._cursor--;
	}
	screen._prelight = screen._cursor;
	screen.pl = screen.cs;

	while (screen._boundend < screen._cursor)
	{
		screen.bs++;
		screen._boundstart++;
		screen.be++;
		screen._boundend++;
	}

	while (screen._boundstart > screen._cursor)
	{
		screen.bs--;
		screen._boundstart--;
		screen.be--;
		screen._boundend--;
	}

	QueueRedraw();
}
*/
/*old
void GtkUI::PkgTreeWidget::UpdateAdjustment(void)
{
	if (adjustment == 0)
		return;

	int count = screen.Packages->Length();
	int pagesize = LinesInView();
	if (pagesize > count) pagesize = count;

	adjustment->lower = 0;	// this never really changes
	adjustment->upper = count + pagesize - 1;
	adjustment->step_increment = 1;
	adjustment->page_increment = pagesize;
	adjustment->page_size = pagesize;

	//g_print("Adjustments updated; new upperbound is %d\n", count - 1);
	gtk_adjustment_changed(adjustment);
}
*/
/*old
int GtkUI::PkgTreeWidget::LinesInView()
{
	return theTree->allocation.height / vspacing - 1;
}
*/
/*
void GtkUI::PkgTreeWidget::DrawHeading()
{
	// Draws the column headings with a nice 3-d look
	GdkColor gray, black, white;
	GdkGC *gc;
	int height = vspacing - 1;
	int width = theTree->allocation.width - 1;
	GdkColormap *cmap = gdk_colormap_get_system();
//old	gdk_color_black(cmap, &black);
	black.red = black.green = black.blue = 0x0000;
	gdk_colormap_alloc_color(cmap, &black, TRUE, FALSE);
//old	gdk_color_white(cmap, &white);
	white.red = white.green = white.blue = 0xffff;
	gdk_colormap_alloc_color(cmap, &white, TRUE, FALSE);

	gray.red = gray.green = gray.blue = 0xDDDD;
//old	gdk_color_alloc(cmap, &gray);
	gdk_colormap_alloc_color (cmap, &gray, TRUE, FALSE);

	gc = gdk_gc_new(screen.window->window);
	gdk_gc_set_line_attributes(gc, 2, GDK_LINE_SOLID, GDK_CAP_BUTT, GDK_JOIN_BEVEL);
	gdk_gc_set_foreground(gc, &gray);
	gdk_gc_set_background(gc, &white);

	gdk_draw_rectangle(bpixmap, gc, TRUE, 0, 0, width, height);

	int i = 0;
	for (; i < GTKUI_PKGTREE_COLUMNS; i++)
	{
		gdk_gc_set_foreground(gc, &white);
		// left //
		gdk_draw_line(bpixmap, gc, columnoffsets[i], 0, columnoffsets[i], height);
		// top //
		gdk_draw_line(bpixmap, gc, columnoffsets[i], 0, columnoffsets[i + 1], 0);

		gdk_gc_set_foreground(gc, &black);
		// right //
		gdk_draw_line(bpixmap, gc, columnoffsets[i + 1] - 1, 0,
			      columnoffsets[i + 1] - 1, height);
		// bottom //
		gdk_draw_line(bpixmap, gc, columnoffsets[i], height, columnoffsets[i + 1],
			      height);

//old		gdk_draw_string(bpixmap, treefont, gc, columnoffsets[i] + 3, height - 6,t itles[i]);
		gdk_draw_text(bpixmap, treefont, gc, columnoffsets[i] + 3, height - 6,
				titles[i], strlen(titles[i]));
	}

}

void GtkUI::PkgTreeWidget::BlankLine(SelectState state, gint ypos)
{
	// this seems terribly inefficient :-( I don't understand why the fill //
	// function fills with the *foreground* color and not the *background* //
	 
	GdkGC *gc = NULL;
	GdkGC *reversegc = gdk_gc_new(screen.window->window);
	GdkGCValues values;

	GETGC(gc, state);
	gdk_gc_copy(reversegc, gc);
	gdk_gc_get_values(reversegc, &values);
	gdk_gc_set_foreground(reversegc, &values.background);
	gdk_gc_set_background(reversegc, &values.foreground);

	gdk_draw_rectangle(bpixmap, reversegc, TRUE, 0, (ypos + 1) * vspacing,
			   theTree->allocation.width, vspacing);

//old	gdk_gc_unref(reversegc);
	g_object_unref(G_OBJECT(reversegc));
}

void GtkUI::PkgTreeWidget::DrawHeader(::PackageTree::Item * p, SelectState state, gint ypos)
{
	GdkGC *gc = NULL;
	GdkPixmap *ec_pixmap = NULL;
	int Inc = p->increment;

	BlankLine(state, ypos);
	GETGC(gc, state);

	if (p->child) {
		if (p->IsExpanded()) {
			if (p->next)
				ec_pixmap = GETPIXMAP(expanded_pixmap, state);
			else
				ec_pixmap = GETPIXMAP(expanded_term_pixmap, state);
		}
		else {
			if (p->next)
				ec_pixmap = GETPIXMAP(contracted_pixmap, state);
			else
				ec_pixmap = GETPIXMAP(contracted_term_pixmap, state);
		}
	} else {
		if (p->next)
			ec_pixmap = GETPIXMAP(tree_nochild_pixmap, state);
		else
			ec_pixmap = GETPIXMAP(tree_nochild_term_pixmap, state);
	}
		

	string format = screen.Packages->GetHeaderDesc(p);

	gdk_draw_pixmap(bpixmap, gc, ec_pixmap, 0, 0,
			(Inc * GTKUI_PKG_INDENT) + 5,
			(ypos + 1) * vspacing, 
			GTKUI_TREE_ICON_SIZE, GTKUI_TREE_ICON_SIZE);

	gdk_draw_pixmap(bpixmap, gc, GETPIXMAP(divider_pixmap, state), 0, 0,
			(Inc * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5,
			(ypos + 1) * vspacing + 2, 
			GTKUI_PKG_ICON_SIZE, GTKUI_PKG_ICON_SIZE);
//it must be changed			

//	gdk_draw_string(bpixmap, treefont, gc,
//			(Inc * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 3,
//			(ypos + 2) * vspacing - 6, format.c_str());
	gdk_draw_text(bpixmap, treefont, gc,
		      (Inc * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 3,
		      (ypos + 2) * vspacing - 6, format.c_str(), format.length());


	PackageTree::Item *q = p;
	int X = Inc * GTKUI_PKG_INDENT;
	while (q->parent && X > 0)
	{
		X -= GTKUI_PKG_INDENT;

		if (q->parent->next)
			gdk_draw_line(bpixmap, gc,
				 X + 7, (ypos + 1) * vspacing, // x1, y1 //
				 X + 7, ((ypos + 2) * vspacing) - 1); // x2, y2 //

		q = q->parent;
	}
}

void GtkUI::PkgTreeWidget::DrawPackage(::PackageTree::Item * p, SelectState state, gint ypos)
{
	GdkGC *gc = NULL;
	GdkPixmap *ec_pixmap = NULL;

	BlankLine(state, ypos);
	GETGC(gc, state);

	if (p->Version().end() == false) {
		if (p->Version().DependsList().end() == false) {
			if (p->IsExpanded()) {
				if (p->next)
					ec_pixmap = GETPIXMAP(expanded_pixmap, state);
				else
					ec_pixmap = GETPIXMAP(expanded_term_pixmap, state);
			}
			else {
				if (p->next)
					ec_pixmap = GETPIXMAP(contracted_pixmap, state);
				else
					ec_pixmap = GETPIXMAP(contracted_term_pixmap, state);
			}
		} else {
			if (p->next)
				ec_pixmap = GETPIXMAP(tree_nochild_pixmap, state);
			else
				ec_pixmap = GETPIXMAP(tree_nochild_term_pixmap, state);
		}
	} else {
		if (p->next)
			ec_pixmap = GETPIXMAP(tree_nochild_pixmap, state);
		else
			ec_pixmap = GETPIXMAP(tree_nochild_term_pixmap, state);
	}

	gdk_draw_pixmap(bpixmap, gc, ec_pixmap, 0, 0,
			((p->increment) * GTKUI_PKG_INDENT) + 5,
			(ypos + 1) * vspacing, 
			GTKUI_TREE_ICON_SIZE, GTKUI_TREE_ICON_SIZE);

	gdk_draw_pixmap(bpixmap, gc, GETPIXMAP(package_pixmap, state), 0, 0,
			((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5,
			(ypos + 1) * vspacing + 2, 
			GTKUI_PKG_ICON_SIZE, GTKUI_PKG_ICON_SIZE);
			
//old	gdk_draw_string(bpixmap, treefont, gc,
//			((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 5,
//			(ypos + 2) * vspacing - 6, 
//			p->TargetPkg.Name());
	gdk_draw_text(bpixmap, treefont, gc,
		      ((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 5,
		      (ypos + 2) * vspacing - 6, 
		      p->TargetPkg.Name(), strlen(p->TargetPkg.Name()));

	pkgCache::VerIterator V, InstV;
	pkgCache::PkgIterator I = p->TargetPkg;
	V = (*Cache)[I].CandidateVerIter(*Cache);
	InstV = (*Cache)[I].InstVerIter(*Cache);

//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[1] + 3, (ypos + 2) * vspacing - 6, (*Cache)[I].Status == 1 ? "Installed" : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? "Upgraded" : "Kept")); 
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[1] + 3, (ypos + 2) * vspacing - 6, 
		      (*Cache)[I].Status == 1 ? "Installed" : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? "Upgraded" : "Kept"),
		      (*Cache)[I].Status == 1 ? 9 : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? 8 : 4)); 
											     
//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[2] + 3, (ypos + 2) * vspacing - 6, ((*Cache)[I].InstBroken()? "Broken" : ((*Cache)[I].  NewInstall()? "Install" : ((*Cache)[I].  Upgrade()?  "Upgrade" : ((*Cache)[I].  Downgrade()?  "Delete" : ((*Cache) [I].  Install()?  "Install" : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? "Purge" : "Remove") : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? "Reinstall" : "Keep")))))));
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[2] + 3, (ypos + 2) * vspacing - 6, 
		      ((*Cache)[I].InstBroken()? "Broken" : ((*Cache)[I].  NewInstall()? "Install" : ((*Cache)[I].  Upgrade()?  "Upgrade" : ((*Cache)[I].  Downgrade()?  "Delete" : ((*Cache) [I].  Install()?  "Install" : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? "Purge" : "Remove") : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? "Reinstall" : "Keep")))))),
		      ((*Cache)[I].InstBroken()? 6 : ((*Cache)[I].  NewInstall()? 7 : ((*Cache)[I].  Upgrade()?  7 : ((*Cache)[I].  Downgrade()?  6 : ((*Cache) [I].  Install()?  7 : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? 5 : 6) : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? 9 : 4)))))));

	if (V.end() == false)
//old		gdk_draw_string(bpixmap, treefont, gc, columnoffsets[3] + 3, (ypos + 2) * vspacing - 6, V.VerStr());
		gdk_draw_text(bpixmap, treefont, gc, columnoffsets[3] + 3, (ypos + 2) * vspacing - 6, V.VerStr(), strlen(V.VerStr()));

	if (InstV.end() == false)
//old		gdk_draw_string(bpixmap, treefont, gc, columnoffsets[4] + 3, (ypos + 2) * vspacing - 6, InstV.VerStr());
		gdk_draw_text(bpixmap, treefont, gc, columnoffsets[4] + 3, (ypos + 2) * vspacing - 6, InstV.VerStr(), strlen(InstV.VerStr()));

	if (V.end() == false)
//old		gdk_draw_string(bpixmap, treefont, gc, columnoffsets[5] + 3, (ypos + 2) * vspacing - 6, Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str());
		gdk_draw_text(bpixmap, treefont, gc, columnoffsets[5] + 3, (ypos + 2) * vspacing - 6, Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str(), Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().length());

	PackageTree::Item *q = p;
	int X = p->increment * GTKUI_PKG_INDENT;
	while (q->parent && X > 0)
	{
		X -= GTKUI_PKG_INDENT;

		if (q->parent->next)
			gdk_draw_line(bpixmap, gc,
				 X + 7, (ypos + 1) * vspacing, // x1, y1 //
				 X + 7, ((ypos + 2) * vspacing) - 1); // x2, y2 //

		q = q->parent;
	}
}

void GtkUI::PkgTreeWidget::DrawDepend(::PackageTree::Item * p, SelectState state, gint ypos)
{
	GdkGC *gc = NULL;
	GdkPixmap *ec_pixmap = NULL;
	GdkPixmap *icon = GETPIXMAP(package_pixmap, state);

	BlankLine(state, ypos);
	GETGC(gc, state);

	if (p->Version().end() == false) {
		if (p->Version().DependsList().end() == false) {
			if (p->IsExpanded()) {
				if (p->next)
					ec_pixmap = GETPIXMAP(expanded_pixmap, state);
				else
					ec_pixmap = GETPIXMAP(expanded_term_pixmap, state);
			}
			else {
				if (p->next)
					ec_pixmap = GETPIXMAP(contracted_pixmap, state);
				else
					ec_pixmap = GETPIXMAP(contracted_term_pixmap, state);
			}
		} else {
			if (p->next)
				ec_pixmap = GETPIXMAP(tree_nochild_pixmap, state);
			else
				ec_pixmap = GETPIXMAP(tree_nochild_term_pixmap, state);
		}
	} else {
		if (p->next)
			ec_pixmap = GETPIXMAP(tree_nochild_pixmap, state);
		else
			ec_pixmap = GETPIXMAP(tree_nochild_term_pixmap, state);
	}

	pkgCache::DepIterator * D = (pkgCache::DepIterator *) (p->Extra);
	if (strcmp(D->DepType(), "Depends") == 0)
		icon = GETPIXMAP(depends_pixmap, state);
	else if (strcmp(D->DepType(), "Pre-Depends") == 0)
		icon = GETPIXMAP(depends_pixmap, state);
	else if (strcmp(D->DepType(), "Recommends") == 0)
		icon = GETPIXMAP(recommends_pixmap, state);
	else if (strcmp(D->DepType(), "Suggests") == 0)
		icon = GETPIXMAP(suggests_pixmap, state);
	else if (strcmp(D->DepType(), "Replaces") == 0)
		icon = GETPIXMAP(replaces_pixmap, state);
	else if (strcmp(D->DepType(), "Conflicts") == 0)
		icon = GETPIXMAP(conflicts_pixmap, state);
//it must be changed
	gdk_draw_pixmap(bpixmap, gc, ec_pixmap, 0, 0,
			((p->increment) * GTKUI_PKG_INDENT) + 5, 
			(ypos + 1) * vspacing, 
			GTKUI_TREE_ICON_SIZE, GTKUI_TREE_ICON_SIZE);

	gdk_draw_pixmap(bpixmap, gc, icon, 0, 0,
			((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5,
			(ypos + 1) * vspacing + 2, 
			GTKUI_PKG_ICON_SIZE, GTKUI_PKG_ICON_SIZE);
			
//	gdk_draw_string(bpixmap, treefont, gc,
//			((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 5,
//			(ypos + 2) * vspacing - 6, 
//			p->TargetPkg.Name());
	gdk_draw_text(bpixmap, treefont, gc,
		      ((p->increment) * GTKUI_PKG_INDENT) + 5 + GTKUI_TREE_ICON_SIZE + 5 + GTKUI_PKG_ICON_SIZE + 5,
		      (ypos + 2) * vspacing - 6, 
		      p->TargetPkg.Name(), strlen(p->TargetPkg.Name()));

	pkgCache::VerIterator V, InstV;
	pkgCache::PkgIterator I = p->TargetPkg;
	V = (*Cache)[I].CandidateVerIter(*Cache);
	InstV = (*Cache)[I].InstVerIter(*Cache);

//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[1] + 3, (ypos + 2) * vspacing - 6, (*Cache)[I].Status == 1 ? "Installed" : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? "Upgraded" : "Kept")); 
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[1] + 3, (ypos + 2) * vspacing - 6,
		      (*Cache)[I].Status == 1 ? "Installed" : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? "Upgraded" : "Kept"),
		      (*Cache)[I].Status == 1 ? 9 : ((InstV.end() == false || (*Cache)[I].Delete() == true) && (*Cache)[I].NewInstall() == false ? 8 : 4)); 

//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[2] + 3, (ypos + 2) * vspacing - 6, ((*Cache)[I].InstBroken()? "Broken" : ((*Cache)[I].  NewInstall()? "Install" : ((*Cache)[I].  Upgrade()?  "Upgrade" : ((*Cache)[I].  Downgrade()?  "Delete" : ((*Cache) [I].  Install()?  "Install" : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? "Purge" : "Remove") : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? "Reinstall" : "Keep")))))));
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[2] + 3, (ypos + 2) * vspacing - 6, 
		      ((*Cache)[I].InstBroken()? "Broken" : ((*Cache)[I].  NewInstall()? "Install" : ((*Cache)[I].  Upgrade()?  "Upgrade" : ((*Cache)[I].  Downgrade()?  "Delete" : ((*Cache) [I].  Install()?  "Install" : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? "Purge" : "Remove") : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? "Reinstall" : "Keep")))))),
		      ((*Cache)[I].InstBroken()? 6 : ((*Cache)[I].  NewInstall()? 7 : ((*Cache)[I].  Upgrade()?  7 : ((*Cache)[I].  Downgrade()?  6 : ((*Cache) [I].  Install()?  7 : ( (*Cache) [I].  Delete ()? ( ( (*Cache) [I].  iFlags & pkgDepCache:: Purge) ? 5 : 6) : ((*Cache)[I].iFlags & pkgDepCache::ReInstall) ? 9 : 4)))))));

//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[3] + 3, (ypos + 2) * vspacing - 6,
//			(V.end()? "" : V.VerStr()));
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[3] + 3, (ypos + 2) * vspacing - 6,
		      (V.end()? "" : V.VerStr()),
		      (V.end()? 0 : strlen(V.VerStr())));
//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[4] + 3, (ypos + 2) * vspacing - 6,
//			(InstV.end()? "" : InstV.VerStr()));
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[4] + 3, (ypos + 2) * vspacing - 6,
		      (InstV.end()? "" : InstV.VerStr()),
		      (InstV.end()? 0 : strlen(InstV.VerStr())));
//old	gdk_draw_string(bpixmap, treefont, gc, columnoffsets[5] + 3, (ypos + 2) * vspacing - 6,
//	   (V.end() ? "" : Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str()));
	gdk_draw_text(bpixmap, treefont, gc, columnoffsets[5] + 3, (ypos + 2) * vspacing - 6,
		      (V.end() ? "" : Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str()),
		      (V.end() ? 0 : strlen(Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str())));

	PackageTree::Item *q = p;
	int X = p->increment * GTKUI_PKG_INDENT;
	while (q->parent && X > 0)
	{
		X -= GTKUI_PKG_INDENT;

		if (q->parent->next)
			gdk_draw_line(bpixmap, gc,
				 X + 7, (ypos + 1) * vspacing, // x1, y1 //
				 X + 7, ((ypos + 2) * vspacing) - 1); // x2, y2 //

		q = q->parent;
	}
}
*/
/*old
void GtkUI::PkgTreeWidget::Drawline(::PackageTree::Item * p, int ypos, bool prelight)
{
	SelectState state = Normal;

	if (p == NULL) {
		g_print("package passed to Drawline is NULL\n");
		return;
	}

	if (prelight)
		state = Prelight;
	else if (p == screen.cs)
		state = Selected;
	else if (p->IsMatched())
		state = Matched;

	if (p->IsDepend() && p->IsExpanded())
		DrawPackage(p, state, ypos);

	switch (p->Type)
	{
	case ::PackageTree::Item::Div_State:
	case ::PackageTree::Item::Div_Sect:
	case ::PackageTree::Item::Div_Pri:
	case ::PackageTree::Item::Div_Custom:
		DrawHeader(p, state, ypos);
		break;
	case ::PackageTree::Item::Pkg:
		DrawPackage(p, state, ypos);
		break;
	case ::PackageTree::Item::Dep:
		DrawDepend(p, state, ypos);
		break;
	default:		// shouldn't happen //
		NOTREACHED("Unknown package type");
		break;
	}
	
}
*/
/*old
void GtkUI::PkgTreeWidget::MoveCursor(int delta, bool prelight)
{
	long current = screen._cursor - screen._boundstart;
	long newcursor = current + delta;
	::PackageTree::Iterator prevcursor = screen.cs;

	if (delta == 0)
		return;		// well that was easy....

	//g_print("Delta is %d\n", delta);

	if (delta < 0)
	{
		while (delta < 0)
		{
			screen._cursor--;
			screen.cs--;
			delta++;
		}
	}
	else
	{
		while (delta > 0)
		{
			screen._cursor++;
			screen.cs++;
			delta--;
		}
	}

	Drawline(prevcursor, current, false);
	Drawline(screen.cs, newcursor, prelight);

	// tell gtk to update the two lines we updated //
	GdkRectangle update_rect;
	update_rect.x = 0;
	update_rect.y = (current + 1) * vspacing;
	update_rect.width = theTree->allocation.width;
	update_rect.height = vspacing;
//old	gtk_widget_draw(theTree, &update_rect);
	gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, update_rect.width, update_rect.height);

	update_rect.x = 0;
	update_rect.y = (newcursor + 1) * vspacing;
	update_rect.width = theTree->allocation.width;
	update_rect.height = vspacing;
//old	gtk_widget_draw(theTree, &update_rect);
	gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, update_rect.width, update_rect.height);

	gtk_adjustment_set_value(GTK_ADJUSTMENT(screen.content_adj), screen._cursor);
}
*/
void GtkUI::PkgTreeWidget::DependToggle()
{
	DefaultKeys::depend_toggle(&screen);
//old	UpdateAdjustment();
	QueueRedraw();
}

GtkWidget *GtkUI::PkgTreeWidget::MakeContextMenu(::PackageTree::Item * p)
{
    GtkItemFactoryEntry items[] = {
	  { NULL,				NULL,	NULL,									0,	"<Title>" },
      { "/sep",				NULL,	NULL,									0,	"<Separator>" },
	  { _("/Install"),		NULL,	GtkItemFactoryCallback(MarkInstall),	0,	"<Item>" },
      { _("/Keep"),			NULL,	GtkItemFactoryCallback(MarkKeep),		0,	"<Item>" },
	  { _("/Purge"),		NULL,	GtkItemFactoryCallback(MarkPurge),		0,	"<Item>" },
      { _("/Reinstall"),	NULL,	GtkItemFactoryCallback(MarkReinstall),	0,	"<Item>" },
	  { _("/Remove"),		NULL,	GtkItemFactoryCallback(MarkRemove),		0,	"<Item>" },
      { _("/Upgrade"),		NULL,	GtkItemFactoryCallback(MarkInstall),	0,	"<Item>" },
	};

	GtkItemFactory *item_factory;
	char buff[64];
  
	/* TODO: Need to make this not leak like a sieve ... */
	pkgCache::VerIterator InstV;
	InstV = (*Cache)[p->TargetPkg].InstVerIter(*Cache);
	GtkWidget *menu = gtk_menu_new();

//old	GtkWidget *pkgname = gtk_menu_item_new_with_label(p->TargetPkg.Name());
	sprintf(buff, "/%s", p->TargetPkg.Name());
	items[0].path = buff;

	item_factory = gtk_item_factory_new (GTK_TYPE_MENU, "<main>",
                                        NULL);
	gtk_item_factory_create_items(item_factory, 2, items, gpointer (this));
/*old	gtk_menu_append(GTK_MENU(menu), pkgname);
	gtk_widget_set_sensitive(pkgname, FALSE);
	gtk_widget_show(pkgname);
	GtkWidget *sepline = gtk_menu_item_new();
	gtk_menu_append(GTK_MENU(menu), sepline);
	gtk_widget_show(sepline);

	GtkWidget *item;
*/

	// marked for install or delete, can keep
	if ((*Cache)[p->TargetPkg].Install() || (*Cache)[p->TargetPkg].Delete())
	{
/*old		item = gtk_menu_item_new_with_label("Keep");
		gtk_menu_append(GTK_MENU(menu), item);
*/		gtk_item_factory_create_item(item_factory, &items[3], gpointer (this), 1);
/*old		gtk_signal_connect(GTK_OBJECT(item), "activate", GTK_SIGNAL_FUNC(MarkKeep),
				   (gpointer) this);
		g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(MarkKeep),
				 (gpointer) this);
		gtk_widget_show(item);
*/	}

	if (InstV.end() == false)
	{
		if ((*Cache)[p->TargetPkg].Upgrade() == false
		    && (*Cache)[p->TargetPkg].Status == 1)
		{
/*old			item = gtk_menu_item_new_with_label("Upgrade");
			gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[7], gpointer (this), 1);
/*old			gtk_signal_connect(GTK_OBJECT(item), "activate",
					   GTK_SIGNAL_FUNC(MarkInstall), (gpointer) this);
			g_signal_connect(G_OBJECT(item), "activate",
					 G_CALLBACK(MarkInstall), (gpointer) this);
			gtk_widget_show(item);
*/		}

		if ((*Cache)[p->TargetPkg].Delete() == false
		    && (*Cache)[p->TargetPkg].NewInstall() == false)
		{
			if (((*Cache)[p->TargetPkg].iFlags & pkgDepCache::ReInstall) == 0)
			{
/*old				item = gtk_menu_item_new_with_label("Reinstall");
				gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[5], gpointer (this), 1);
/*old				gtk_signal_connect(GTK_OBJECT(item), "activate",
					   GTK_SIGNAL_FUNC(MarkReinstall), (gpointer) this);
				g_signal_connect(G_OBJECT(item), "activate",
						 G_CALLBACK(MarkReinstall), (gpointer) this);
				gtk_widget_show(item);
*/			}
			else
			{
/*old				item = gtk_menu_item_new_with_label("Keep");
				gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[3], gpointer (this), 1);
/*old				gtk_signal_connect(GTK_OBJECT(item), "activate",
					GTK_SIGNAL_FUNC(MarkKeep), (gpointer)this);
				g_signal_connect(G_OBJECT(item), "activate",
						 G_CALLBACK(MarkKeep), (gpointer)this);
				gtk_widget_show(item);
*/			}
/*			item = gtk_menu_item_new_with_label("Remove");
			gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[6], gpointer (this), 1);
/*old			gtk_signal_connect(GTK_OBJECT(item), "activate",
					   GTK_SIGNAL_FUNC(MarkRemove), (gpointer) this);
			g_signal_connect(G_OBJECT(item), "activate",
					 G_CALLBACK(MarkRemove), (gpointer) this);
			gtk_widget_show(item);
			item = gtk_menu_item_new_with_label("Purge");
			gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[4], gpointer (this), 1);
/*old			gtk_signal_connect(GTK_OBJECT(item), "activate",
					   GTK_SIGNAL_FUNC(MarkPurge), (gpointer) this);
			g_signal_connect(G_OBJECT(item), "activate",
					 G_CALLBACK(MarkPurge), (gpointer) this);
			gtk_widget_show(item);
*/		}
		else if ((*Cache)[p->TargetPkg].Delete() == true
			 && !((*Cache)[p->TargetPkg].iFlags & pkgDepCache::Purge))
		{
/*old			item = gtk_menu_item_new_with_label("Purge");
			gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[4], gpointer (this), 1);
/*old			gtk_signal_connect(GTK_OBJECT(item), "activate",
					   GTK_SIGNAL_FUNC(MarkPurge), (gpointer) this);
			g_signal_connect(G_OBJECT(item), "activate",
					 G_CALLBACK(MarkPurge), (gpointer) this);
			gtk_widget_show(item);
*/		}
	}
	else if ((*Cache)[p->TargetPkg].Delete() == false)
	{
/*old		item = gtk_menu_item_new_with_label("Install");
		gtk_menu_append(GTK_MENU(menu), item);
*/			gtk_item_factory_create_item(item_factory, &items[2], gpointer (this), 1);
/*old		gtk_signal_connect(GTK_OBJECT(item), "activate", GTK_SIGNAL_FUNC(MarkInstall),
				   (gpointer) this);
		g_signal_connect(G_OBJECT(item), "activate", G_CALLBACK(MarkInstall), (gpointer) this);
		gtk_widget_show(item);
*/	}

	menu = gtk_item_factory_get_widget(item_factory, "<main>");

	return menu;
}

void GtkUI::PkgTreeWidget::QueueRedraw()
{
	if (redrawqueued == false) {
		idleid = gtk_idle_add(ProcessRedraw, this);
		redrawqueued = true;
	}
}

gint GtkUI::PkgTreeWidget::ProcessRedraw(gpointer data)
{
	GtkUI::PkgTreeWidget *tree = (GtkUI::PkgTreeWidget *) data;

	tree->Redraw(true);
	tree->redrawqueued = false;

	return FALSE;
}

void GtkUI::PkgTreeWidget::Rescan (GtkTreePath *path)
{
	GtkTreePath *next = gtk_tree_path_copy (path), *down = gtk_tree_path_copy (path);
	GtkTreeModel *treemodel = gtk_tree_view_get_model (GTK_TREE_VIEW (tree));
	GtkTreeIter iter;
	::PackageTree::Item *T;
	
	if (gtk_tree_model_get_iter (treemodel, &iter, path))
	{
	    gtk_tree_model_get (treemodel, &iter, Item_Col, &T, -1);
	    
	    if (T != NULL)
	    {
		GtkTreeIter iterchild;
		::PackageTree::Item *Q;
		
		if (gtk_tree_model_iter_children (treemodel, &iterchild, &iter))
		{
		    gtk_tree_model_get (treemodel, &iterchild, Item_Col, &Q, -1);
		
		    if (T->IsExpanded() && !Q) 
		    {
				ExpandRow (T, &iter);
				gtk_tree_view_expand_row (GTK_TREE_VIEW (tree), path, FALSE);
		    }
		    if (!T->IsExpanded() && Q) CollapseRow (T, &iter);
		}
	    }
	}

	gtk_tree_path_down (down);
	if (gtk_tree_model_get_iter (treemodel, &iter, down))
	    Rescan (down);
	gtk_tree_path_free (down);

	gtk_tree_path_next (next);
	if (gtk_tree_model_get_iter (treemodel, &iter, next))
    	    Rescan (next);
	gtk_tree_path_free (next);
}

void GtkUI::PkgTreeWidget::Redraw(bool immediate)
{
	inscan = TRUE;

	if (!rescanpath)
	{
	    gtk_tree_store_clear (GTK_TREE_STORE (gtk_tree_view_get_model (GTK_TREE_VIEW (tree))));
	    
	    for (::PackageTree::Iterator T(*screen.Packages); !T.Invalid(); T = T->next) 
		InsertRow (T, this, NULL);
		
		rescanpath = strdup ("0");
	}

	GtkTreePath *path = gtk_tree_path_new_from_string (rescanpath);
	
	Rescan (path);
	gtk_tree_selection_select_path (gtk_tree_view_get_selection (GTK_TREE_VIEW (tree)), path);
	
	screen.UpdateStatus();
	
	g_free (rescanpath);
	rescanpath = NULL;
	inscan = FALSE;
}


/*
	// blank out the pixmap
	gdk_draw_rectangle(bpixmap, theTree->style->white_gc, TRUE, 0, 0,
			   theTree->allocation.width, theTree->allocation.height);

	DrawHeading();

	unsigned int i = 0;
	::PackageTree::Iterator T(screen.bs);
	
	for (; !T.Invalid(); i++, T++)
	{
		Drawline(T, i);
		if (T == screen.be)
			break;
	}

	//printf("Drew %d packages\n", i);
	if (resizingcolumn > 0) {
		gdk_draw_line(bpixmap, theTree->style->black_gc,
			columnoffsets[resizingcolumn], 0,
			columnoffsets[resizingcolumn], theTree->allocation.height);
	}

	// Tell it to redraw the whole widget 
	if (immediate) {
		
GdkRectangle update_rect;
		update_rect.x = 0;
		update_rect.y = 0;
		update_rect.width = theTree->allocation.width;
		update_rect.height = theTree->allocation.height;

//old		gtk_widget_draw(theTree, &update_rect);
		gtk_widget_queue_draw_area(theTree, update_rect.x, update_rect.y, update_rect.width, update_rect.height);
	}

	// Had to remove... for some reason this broke things
	// with more than one window... returning FALSE from the 
	//	 ProcessRedraw function has the same effect..and works! :) 
	// if (redrawqueued) gtk_idle_remove(idleid);
}
*/
