/* $Id: pkgtreewidget.h,v 1.5 2001/03/24 08:08:32 ltd Exp $ */
#ifndef _gtkui_pkgtree_H
#define _gtkui_pkgtree_H

#include "gtkui.h"

#include <list/pkgtree.h>

// old #define GTKUI_PKGTREE_COLUMNS 6

class GtkUI::PkgTreeWidget 
{
	friend class GtkUI::Screen;
	friend class GtkUI::SortUI;

protected:
/*old	enum SelectState {
		Normal,		// not selected //
		Prelight,	// mouse over //
		Selected,	// selected //
		Matched		// matched on a search //
	};
*/
	enum
	{
	    Icon_Col,
	    Name_Col,
	    Is_Col,
	    Will_Col
	};
	
	static GdkPixmap *package_pixmap[4];
	static GdkPixmap *divider_pixmap[4];
	static GdkPixmap *depends_pixmap[4];
	static GdkPixmap *conflicts_pixmap[4];
	static GdkPixmap *replaces_pixmap[4];
	static GdkPixmap *recommends_pixmap[4];
	static GdkPixmap *suggests_pixmap[4];
	static GdkPixmap *expanded_pixmap[4];
	static GdkPixmap *contracted_pixmap[4];
/*old	static GdkPixmap *expanded_term_pixmap[4];
	static GdkPixmap *contracted_term_pixmap[4];
	static GdkPixmap *tree_nochild_term_pixmap[4];
	static GdkPixmap *tree_nochild_pixmap[4];
*/
	/* parent widget */
	GtkUI::Screen &screen;

//old	GdkGC *normal_gc, *prelight_gc, *selected_gc, *matched_gc;
	GdkColor normal_c, prelight_c, selected_c, matched_c;
//old	GdkPixmap *bpixmap; /* Backing pixmap */
	GdkFont *treefont;
//old	GtkAdjustment *adjustment;
//	GtkTreePath *rescanpath;
	gchar *rescanpath;

//old	GtkWidget *theTree;
	GtkWidget *tree;
	GtkTreeStore *treestore;
	
//old	int vspacing;
	bool redrawqueued;
	bool inscan;
	bool colchange;
	guint idleid;

//old	static gchar *titles[];
	gint Item_Col, Color_Col, N_Col;
//old	gint columnoffsets[GTKUI_PKGTREE_COLUMNS + 1];
//old	float realcoloffsets[GTKUI_PKGTREE_COLUMNS + 1];
//old	gint resizingcolumn;

//old	void SetVAdjustment(GtkAdjustment *a) { adjustment = a; }
//old	GtkAdjustment *GetVAdjustment() { return adjustment; }

//old	void SetupGCs();
	void SetupCs();

//old	void ColumnResize(gint x);
//old	void UpdateAdjustment();
//old	void ScrollEvent(GtkAdjustment *);
	
//old	void DrawHeading();

//old	void BlankLine(SelectState, gint);
//old	void DrawHeader(::PackageTree::Item *, SelectState, gint);
//old	void DrawPackage(::PackageTree::Item *, SelectState, gint);
//old	void DrawDepend(::PackageTree::Item *, SelectState, gint);
//old	void Drawline(::PackageTree::Item *, int, bool = false);
	void ExpandRow(::PackageTree::Item *, GtkTreeIter *);
	void CollapseRow(::PackageTree::Item *, GtkTreeIter *);
	void InsertRow(::PackageTree::Item *, GtkUI::PkgTreeWidget *, GtkTreeIter *);
	void InsertHeader(::PackageTree::Item *, GtkUI::PkgTreeWidget *, GtkTreeIter *);
	void InsertPackage(::PackageTree::Item *, GtkUI::PkgTreeWidget *, GtkTreeIter *);
//old	void InsertDepend(::PackageTree::Item *, GtkUI::PkgTreeWidget *, GtkTreeIter *);
	void SeekToItem(::PackageTree::Item *, GtkTreePath *);
	
//old	void PrintPackage(::PackageTree::Item *);
//old	void MoveCursor(int, bool = false);
	void DependToggle();

	GtkWidget *MakeContextMenu(::PackageTree::Item *);

	static gint ProcessRedraw(gpointer);
	
	// event handlers
//old	static gint Resize(GtkWidget *, GdkEventConfigure *, gpointer);
//old	static gint Expose(GtkWidget *, GdkEventExpose *, gpointer);
//old	static void Realize(GtkWidget *, gpointer);
	static gboolean ButtonPress(GtkWidget *, GdkEventButton *, gpointer);
//old	static gboolean ButtonRelease(GtkWidget *, GdkEventButton *, gpointer);
	static gboolean MotionNotify(GtkWidget *, GdkEventMotion *, gpointer);
	static gboolean LeaveNotify(GtkWidget *, GdkEventCrossing *, gpointer);
	static gboolean DragColumn(GtkTreeView *, GtkTreeViewColumn *, GtkTreeViewColumn *, GtkTreeViewColumn *, gpointer);
	static void RowExpanded (GtkTreeView *, GtkTreeIter *, GtkTreePath *, gpointer);
	static void RowCollapsed (GtkTreeView *, GtkTreeIter *, GtkTreePath *, gpointer);
	static void RowActivated (GtkTreeView *, GtkTreePath *, GtkTreeViewColumn *, gpointer);
	static void RowChanged (GtkTreeSelection *, gpointer);
	static void ColumnsChanged (GtkTreeView *, gpointer);
	
	// context menu callbacks
/*old	static void MarkInstall(GtkMenuItem *, gpointer);
	static void MarkReinstall(GtkMenuItem *, gpointer);
	static void MarkUpgrade(GtkMenuItem *, gpointer);
	static void MarkRemove(GtkMenuItem *, gpointer);
	static void MarkPurge(GtkMenuItem *, gpointer);
	static void MarkHold(GtkMenuItem *, gpointer);
	static void MarkKeep(GtkMenuItem *, gpointer);
*/	static void MarkSection(gpointer, guint, GtkWidget *);
	static void MarkInstall(gpointer, guint, GtkWidget *);
	static void MarkReinstall(gpointer, guint, GtkWidget *);
	static void MarkUpgrade(gpointer, guint, GtkWidget *);
	static void MarkRemove(gpointer, guint, GtkWidget *);
	static void MarkPurge(gpointer, guint, GtkWidget *);
	static void MarkHold(gpointer, guint, GtkWidget *);
	static void MarkKeep(gpointer, guint, GtkWidget *);
	static void MarkAll(gpointer , GtkTreePath *);
	
	static void FilterSection(gpointer, guint, GtkWidget *);
	
	
public:
	PkgTreeWidget(GtkUI::Screen &);
	~PkgTreeWidget();

	// Have to do this--
//old	int DoPrelight(int y_ref);
	void DoPrelight(GtkTreePath *);
	void RemovePrelight();

//old	GtkWidget *GetTree() { return theTree; }
	GtkWidget *GetTree() { return tree; }
	void ResetPath() { rescanpath = NULL; }

	void QueueRedraw();
	void Redraw(bool immediate = true);
	void Rescan(GtkTreePath *);
	void AlignCols();

//old	int LinesInView();
};

#endif
