/* $Id: sortcol.cc,v 1.9 2003/01/27 14:56:21 ltd Exp $ */
//old #include <std.h>
#include "sortcol.h"
#include "pkgtreewidget.h"
#include "screen.h"

void GtkUI::SortCol::DragAndDrop (GtkWidget *dstwidget, GdkDragContext *dc, gint x, gint y, GtkSelectionData *selection_data, guint info, guint t, gpointer data)
{
	GtkTreePath *path = NULL;
	GtkTreeModel *model;
        GtkTreeSelection *select;
	GtkTreeViewDropPosition pos;
	GtkTreeIter dstiter, srciter;
	
	GtkWidget *srcwidget = gtk_drag_get_source_widget (dc);
	GtkTreeModel *srcmodel = gtk_tree_view_get_model (GTK_TREE_VIEW (srcwidget));
	GtkTreeModel *dstmodel = gtk_tree_view_get_model (GTK_TREE_VIEW (dstwidget));
	        
	if (gtk_tree_view_get_dest_row_at_pos (GTK_TREE_VIEW (dstwidget), x, y, &path, &pos))
	    if (gtk_tree_model_get_iter (dstmodel, &dstiter, path))
	    {
		GtkTreeIter iter;
		gchar *name;
		gint num;
		
		gtk_tree_model_get (dstmodel, &dstiter, Num_Col, &num, -1);
		    								 
		if (num == ColOrderList::PkgName ||
		    num == ColOrderList::Is ||
		    num == ColOrderList::Will)
			return;
	    
		select = gtk_tree_view_get_selection (GTK_TREE_VIEW (srcwidget));
		gtk_tree_selection_get_selected (select, &model, &srciter);
		gtk_tree_model_get (srcmodel, &srciter,
						    Name_Col, &name,
						    Num_Col, &num,
				  			-1);
		    								 
		if (num == ColOrderList::PkgName ||
		    num == ColOrderList::Is ||
		    num == ColOrderList::Will)
			return;
	
	
		    switch (pos)
		    {
			case GTK_TREE_VIEW_DROP_BEFORE:
			case GTK_TREE_VIEW_DROP_INTO_OR_BEFORE:
			    gtk_list_store_insert_before (GTK_LIST_STORE (dstmodel), &iter, &dstiter);
			    break;
			    
			case GTK_TREE_VIEW_DROP_AFTER:
			case GTK_TREE_VIEW_DROP_INTO_OR_AFTER:
			    gtk_list_store_insert_after (GTK_LIST_STORE (dstmodel), &iter, &dstiter);
			    break;
			    
			default:
			    break;
		    }
		    gtk_list_store_set (GTK_LIST_STORE (dstmodel), &iter,
					Name_Col, name,
					Num_Col, num,
					-1);
					
		    
		    gtk_list_store_remove (GTK_LIST_STORE (srcmodel), &srciter);
	    }
}

GtkUI::SortCol::SortCol(GtkUI::Screen &_screen)
	: screen(_screen)//, window(0), srcrow(-1), dstrow(-1)
{
	gchar *title = _("Column");
	gint ncol;

	GdkColor normal_c, unchange_c;
	normal_c.red = normal_c.green = normal_c.blue = 0xffff;
	unchange_c.red = unchange_c.green = unchange_c.blue = 0xdfff;
	
	GtkTreeSelection *select;
	GtkTreeIter iter;
	GtkCellRenderer *renderer;
	GtkTreeViewColumn *column;
	GtkTargetEntry SrcEntry;
	SrcEntry.flags = GTK_TARGET_SAME_APP;


	srcliststore = gtk_list_store_new(N_Col - 1, 
					  G_TYPE_STRING,
					  G_TYPE_INT);
					  
	// Add the columns to the source list
	for (int i = 1; i < screen.Packages->Columns->TotalLength(); i++)
		if (!screen.Packages->Columns->Exists(ColOrderList::column_t (i)))
		{
			gtk_list_store_append(srcliststore, &iter);
			gtk_list_store_set(srcliststore, &iter, 
			    		   Name_Col, screen.Packages->Columns->Name(ColOrderList::column_t (i)),
						   Num_Col, i,
				           -1);
		}
		
	srclist = gtk_tree_view_new_with_model (GTK_TREE_MODEL(srcliststore));
	gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (srclist), &SrcEntry, 1, GDK_ACTION_MOVE);
	gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (srclist), GDK_BUTTON1_MASK, &SrcEntry, 1, GDK_ACTION_MOVE);
	g_signal_connect(GTK_OBJECT (srclist), "drag_data_received", G_CALLBACK(DragAndDrop), (gpointer)this);
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(srclist));
	gtk_tree_selection_set_mode (select, GTK_SELECTION_SINGLE);

	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (title, renderer, "text", Name_Col, NULL);
	gtk_tree_view_column_set_clickable (column, FALSE);	
	gtk_tree_view_column_set_sort_column_id (column, 0);
	gtk_tree_view_column_set_min_width (column, 150);
		
	gtk_tree_view_append_column (GTK_TREE_VIEW (srclist), column);

	dstliststore = gtk_list_store_new(N_Col,
					  G_TYPE_STRING,
					  G_TYPE_INT,
					  GDK_TYPE_COLOR);
	

	// Add already installed columns to the destination list
	for (ColOrderList::ColIterator S = screen.Packages->Columns->ListBegin(); S.end() == false; S++)
	{
		ncol = S.column();
	
		gtk_list_store_append(dstliststore, &iter);
		gtk_list_store_set(dstliststore, &iter,
			           Name_Col, screen.Packages->Columns->Name(ColOrderList::column_t (ncol)),
					   Num_Col, ncol,
					   Color_Col, &normal_c,
			           -1);
				   
		if (ncol == ColOrderList::PkgName ||
		    ncol == ColOrderList::Is ||
		    ncol == ColOrderList::Will)
			gtk_list_store_set(dstliststore, &iter, Color_Col, &unchange_c, -1);
	}
	
	dstlist = gtk_tree_view_new_with_model (GTK_TREE_MODEL(dstliststore));
	gtk_tree_view_enable_model_drag_dest (GTK_TREE_VIEW (dstlist), &SrcEntry, 1, GDK_ACTION_MOVE);
	gtk_tree_view_enable_model_drag_source (GTK_TREE_VIEW (dstlist), GDK_BUTTON1_MASK, &SrcEntry, 1, GDK_ACTION_MOVE);
	g_signal_connect(GTK_OBJECT(dstlist), "drag_data_received", G_CALLBACK(DragAndDrop), (gpointer)this);
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(dstlist));
	
	renderer = gtk_cell_renderer_text_new ();
	column = gtk_tree_view_column_new_with_attributes (title, renderer,
							   "text", Name_Col,
							   NULL);
							   
	if (GTK_MAJOR_VERSION == 2 && GTK_MINOR_VERSION)							   
			gtk_tree_view_column_add_attribute (column, renderer,
												"cell-background-gdk", Color_Col);
								   
	gtk_tree_view_column_set_min_width (column, 150);
	
	gtk_tree_view_append_column (GTK_TREE_VIEW (dstlist), column);

	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title(GTK_WINDOW(window), _("Set Sort Methods"));
	gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER_ON_PARENT);
	gtk_window_set_modal(GTK_WINDOW(window), TRUE);

	GtkWidget *vbox = gtk_vbox_new(FALSE, 7);
	gtk_container_add(GTK_CONTAINER(window), vbox);
	gtk_container_set_border_width(GTK_CONTAINER(vbox), 20);

	GtkWidget *hbox = gtk_hbox_new(FALSE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox, TRUE, TRUE, 0);

	gtk_box_pack_start(GTK_BOX(hbox), srclist, TRUE, TRUE, 0);

	GtkWidget *vbox2 = gtk_vbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(hbox), vbox2, FALSE, FALSE, 10);
	
	GtkWidget *btnadd = gtk_button_new_with_label("->");
	g_signal_connect(G_OBJECT(btnadd), "clicked", G_CALLBACK(AddMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnadd, FALSE, FALSE, 0);
	
	GtkWidget *btnremove = gtk_button_new_with_label("<-");
	g_signal_connect(G_OBJECT(btnremove), "clicked", G_CALLBACK(RemoveMethod), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnremove, FALSE, FALSE, 0);
	
	GtkWidget *btnmoveup = gtk_button_new_with_label(_("Move Up"));
	g_signal_connect(G_OBJECT(btnmoveup), "clicked", G_CALLBACK(MoveUp), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmoveup, FALSE, FALSE, 0);
	
	GtkWidget *btnmovedown = gtk_button_new_with_label(_("Move Down"));
	g_signal_connect(G_OBJECT(btnmovedown), "clicked", G_CALLBACK(MoveDown), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(vbox2), btnmovedown, FALSE, FALSE, 0);


	gtk_box_pack_start(GTK_BOX(hbox), dstlist, TRUE, TRUE, 0);

	GtkWidget *hbox2 = gtk_hbox_new(TRUE, 0);
	gtk_box_pack_start(GTK_BOX(vbox), hbox2, FALSE, FALSE, 0);
	gtk_container_set_border_width(GTK_CONTAINER(hbox2), 8);

	GtkWidget *btnapply = gtk_button_new_with_label(_("Apply"));
	g_signal_connect(GTK_OBJECT(btnapply), "clicked", G_CALLBACK(Apply), (gpointer)this);
	gtk_box_pack_start(GTK_BOX(hbox2), btnapply, TRUE, TRUE, 15);

	GtkWidget *btncancel = gtk_button_new_with_label(_("Cancel"));
	g_signal_connect(G_OBJECT(btncancel), "clicked", G_CALLBACK(Cancel), (gpointer)this);
		
	gtk_box_pack_end(GTK_BOX(hbox2), btncancel, TRUE, TRUE, 15);

}

GtkUI::SortCol::~SortCol()
{
	if (window)
		gtk_widget_destroy(window);
	window = 0;
}

void GtkUI::SortCol::Show()
{
	gtk_widget_show_all(window);
	// enter local event loop
	gtk_main();
}

void GtkUI::SortCol::AddMethod(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter, dstiter;
	GtkTreeModel *model;
	GtkTreeSelection *select;
	
	gchar *name;
	gint num;

	
	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;

	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->srclist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
        {
	    gtk_tree_model_get (model, &srciter,
						   Name_Col, &name,
						   Num_Col, &num,
						   -1);
						   
	    gtk_list_store_insert_before (ui->dstliststore, &dstiter, NULL);
	    gtk_list_store_set(ui->dstliststore, &dstiter,
						   Name_Col, name,
						   Num_Col, num,
						   -1);
	    
	    gtk_tree_selection_get_selected (select, &model, &srciter);
	    gtk_list_store_remove (ui->srcliststore, &srciter);

	    select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));
	    gtk_tree_selection_select_iter (select, &dstiter);
        }
}

void GtkUI::SortCol::RemoveMethod(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter, dstiter;
	GtkTreeModel *model;
	GtkTreeSelection *select;
	
	gchar *name;
	gint num;
	
	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;
	
	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &dstiter))
        {
	    gint num;
	
	    gtk_tree_model_get (model, &dstiter, Num_Col, &num, -1);
	    
	    if (num == ColOrderList::PkgName ||
		num == ColOrderList::Is ||
		num == ColOrderList::Will)
		    return;
	
	    gtk_tree_model_get (model, &dstiter,
						    Name_Col, &name,
						    Num_Col, &num,
						    -1);
							
	    gtk_list_store_insert_after (ui->srcliststore, &srciter, NULL);
	    gtk_list_store_set(ui->srcliststore, &srciter,
						   Name_Col, name,
						   Num_Col, num,
						   -1);
	    
	    gtk_list_store_remove (ui->dstliststore, &dstiter);
        }
}

void GtkUI::SortCol::MoveDown(GtkWidget *widget, gpointer data)
{
        GtkTreeIter srciter;
	GtkTreeModel *model;
	GtkTreeSelection *select;
	
	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;

	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
        {
	    GtkTreeIter dstiter;
	    
	    gint num;
	    gboolean inv;
	    gchar* method;

	    gtk_tree_model_get (model, &srciter,
			       Name_Col, &method,
		    	       Num_Col, &num,
			       -1);
			       
	    if (num == ColOrderList::PkgName ||
		num == ColOrderList::Is ||
		num == ColOrderList::Will)
		    return;
		    
	    if (gtk_tree_model_iter_next (model, &srciter))
	    {
	    
		gtk_list_store_insert_after (ui->dstliststore, &dstiter, &srciter);
		gtk_list_store_set(ui->dstliststore, &dstiter,
				   Name_Col, method,
			           Num_Col, num,
				   -1);
				   
	    
		gtk_tree_selection_get_selected (select, &model, &srciter);
		gtk_list_store_remove (ui->dstliststore, &srciter);
		
		gtk_tree_selection_select_iter (select, &dstiter);		
	    }
	    
/*	    gint num;
	    GtkTreeIter *dstiter;

	    gtk_tree_model_get (model, &srciter, Num_Col, &num, -1);
	    
	    if (num == ColOrderList::PkgName ||
		num == ColOrderList::Is ||
		num == ColOrderList::Will)
		    return;
	
	    dstiter = gtk_tree_iter_copy (&srciter);
	    
	    if (gtk_tree_model_iter_next (model, &srciter))
		gtk_list_store_swap (ui->dstliststore, dstiter, &srciter);
		
	    gtk_tree_iter_free (dstiter);*/
        }
}

void GtkUI::SortCol::MoveUp(GtkWidget *widget, gpointer data)
{
	GtkTreeIter srciter;
	GtkTreeModel *model;
	GtkTreeSelection *select;
	
	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;

	select = gtk_tree_view_get_selection (GTK_TREE_VIEW(ui->dstlist));

	if (gtk_tree_selection_get_selected (select, &model, &srciter))
	{
	    GtkTreePath *path = gtk_tree_model_get_path (model, &srciter);
	    
/*	    if (gtk_tree_path_prev (path))
    	    {
		gint num;
		GtkTreeIter dstiter;
		
		gtk_tree_model_get_iter (model, &dstiter, path);
		gtk_tree_model_get (model, &dstiter, Num_Col, &num, -1);
	    
		if (num != ColOrderList::Will) 		
			gtk_list_store_swap (ui->dstliststore, &dstiter, &srciter);
    	    }*/
	    gint num;
	    gboolean inv;
	    gchar* method;

	    gtk_tree_model_get (model, &srciter,
							Name_Col, &method,
					        Num_Col, &num,
							-1);
				
	    if (gtk_tree_path_prev (path))
        {
			GtkTreeIter dstiter;
		
			gtk_tree_model_get_iter (model, &srciter, path);
		    gtk_tree_model_get (model, &srciter, Num_Col, &num, -1);
		    if (num == ColOrderList::Will) return;
			
	    	gtk_list_store_insert_before (ui->dstliststore, &dstiter, &srciter);
			gtk_list_store_set(ui->dstliststore, &dstiter,
							   Name_Col, method,
			    		       Num_Col, num,
							   -1);
		
			gtk_tree_selection_get_selected (select, &model, &srciter);
			gtk_list_store_remove (ui->dstliststore, &srciter);
		
			gtk_tree_selection_select_iter (select, &dstiter);
	    }
	}    
}

void GtkUI::SortCol::Apply(GtkWidget *, gpointer data)
{
	GtkTreeIter iter;

	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;
	gint num;

	ui->screen.Packages->Columns->Flush();
	
	
	if (gtk_tree_model_get_iter_first (GTK_TREE_MODEL(ui->dstliststore), &iter))
	    do{
			gtk_tree_model_get (GTK_TREE_MODEL(ui->dstliststore), &iter,
							    Num_Col, &num,
			 				    -1);

			ui->screen.Packages->Columns->Push(ColOrderList::column_t (num));
	    }while (gtk_tree_model_iter_next (GTK_TREE_MODEL(ui->dstliststore), &iter));

	gtk_main_quit();
	gtk_widget_hide(ui->window);

	ui->screen.pkgtree->AlignCols();
}

void GtkUI::SortCol::Cancel(GtkWidget *, gpointer data)
{
	GtkUI::SortCol *ui = (GtkUI::SortCol *)data;
	gtk_main_quit();
	gtk_widget_hide(ui->window);
}
