/* $Id: screen.h,v 1.2 2000/11/17 14:56:21 ltd Exp $ */
#ifndef _screen_H
#define _screen_H

#include <list/pkgtree.h>
#include <func/keys.h>

class Screen
{
	public:
		enum Menu {
			M_Functions = 0, M_Movement = 1, M_Toggles = 2, M_Modifiers = 3, M_Filters = 4, M_Sorting = 5, M_Columns = 6
		};

		int ID;

		enum ScrMode { Terse, Verbose };
		enum ScrInit { PkgInit, noPkgInit };
		enum ScrFunc { PkgList, InstallConf };

		ScrMode mode;
		ScrFunc func;

		// cursor, bound start, bound end
		PackageTree::Iterator cs, bs, be;

		long _cursor, _boundstart, _boundend;
		long screenlength;
		unsigned int scroll;

		KeyHandler    *kdriver;
		PackageTree   *Packages;

		virtual void BoundsReset() = 0;
		virtual void InvalidateIterators();
		virtual void ClearMain() {};

		virtual void Redraw() { };
		virtual void RedrawTree() { };
		virtual void RedrawRow(int row, PackageTree::Item *) {};
		virtual void Update() { };
		virtual void UpdateDescription(void) {};

		virtual void RefreshCurrent() { };
		virtual void DrawNextScreen();
		virtual void DrawPrevScreen();
		virtual void SeekNextMatched() { };
		virtual bool IsDescWindowShown() { return false; };
		virtual void DescWindowShow() { };
		virtual void DescWindowHide() { };
		virtual void ScrollDescUp() { };
		virtual void ScrollDescDown() { };
		virtual void DividerNext() { };
		virtual void DividerPrev() { };

		virtual void UpdateStatus(void) { };

		virtual void PageUp();
		virtual void PageDown();
		virtual void ScrollUp() {};
		virtual void ScrollDown() {};
		virtual void ArrowUp();
		virtual void ArrowDown();
		virtual void ArrowLeft();
		virtual void ArrowRight();
		virtual void SeekStart();
		virtual void SeekEnd();

		virtual void SearchEntry(char **, unsigned long *) { };
		virtual void FilterSelect(char **, unsigned long *) { };
		virtual void SearchHelp() { };

		virtual void SortSelectMethod() { };

		virtual void ColumnSelectMethod() { };

		virtual void ActivateMenu(Menu) { };

		virtual void HelpDialog() { };

		Screen(ScrInit Op = PkgInit, ScrFunc Func = PkgList);
		virtual ~Screen();

		Screen *next, *prev;
};

#endif
