/* $Id: filters.cc,v 1.15 2000/12/13 05:46:17 ltd Exp $ */
//old #include <std.h>
#include <stdio.h>
//old #include <regex.h>

#include "pkgtree.h"
#include "screens.h"
#include <interface/edeityui.h>
#include "filters.h"

FilterList::FilterList(PackageTree *_Owner) : Owner(_Owner)
{
	Head = Tail = NULL;
	nodecount = 0;
}

//old Filter *FilterList::Push(const char *text, Filter::Target targ)
Filter *FilterList::Push(const char *text, unsigned long targ)
{	
	if (text == NULL)
		return NULL;

	if (*text == 0)
		return NULL;

	nodecount += 1;

	if (Head == NULL && Tail == NULL)
	{
		Head = Tail = new Filter(text, targ);
		Tail->next = NULL;
	}
	else
	{
		Tail->next = new Filter(text, targ);
		Tail->next->next = NULL;
		Tail = Tail->next;
	}

	return Tail;
}

void FilterList::Pop(void)
{
	Filter *p;

	nodecount -= 1;

	if (Head == Tail)
	{
		delete Head;
		Head = Tail = NULL;
	}
	else
	{
		for (p = Head; p->next != Tail; p = p->next);
		p->next = p->next->next;
		delete Tail;
		Tail = p;
	}
}

bool FilterList::SimulateApply(void)
{
	Filter *p;
	long filtercount=0;
	long didfilter=0;
	long parsedpkgs=0;

	for (p = Head; p != NULL; p = p->next)
		p->Count = 0;

/*	for (pkgCache::PkgIterator I = (*Cache)->PkgBegin(); I.end() == false; I++)
	{
		if (I.VersionList().end() == true)
			continue;

		didfilter=0;
		parsedpkgs++;

		for (p = Head; p != NULL; p = p->next)
		{
			if (p->PkgFiltered(I))
				didfilter++;
			else
				p->Count++;
		}

		if (didfilter == nodecount)
			filtercount++;
	}
	
	if (filtercount == 0 || filtercount == parsedpkgs)
		return false;
*/
	for (pkgCache::PkgIterator I = (*Cache)->PkgBegin(); I.end() == false; I++)
	{
		if (I.VersionList().end() == true)
			continue;

		parsedpkgs++;

		if (IsPkgFiltered(I))
			didfilter++;
	}

	if (didfilter == 0 || didfilter == parsedpkgs)
		return false;

	return true;
}

bool FilterList::IsPkgFiltered(pkgCache::PkgIterator I)
{
	bool isfiltered = false;

	for (Filter *F = Head; F != NULL; F = F->next)
//old		if (F->PkgFiltered(I)) return true;
		if (F->targets & Cmp_Or)
			if (F->PkgFiltered(I)) isfiltered = true;

	if (!isfiltered) return false;

	for (Filter *F = Head; F != NULL; F = F->next)
		if (F->targets & Cmp_And)
			if (F->PkgFiltered(I)) isfiltered = false;

//old	return false;
	return isfiltered;
}

void FilterList::Audit(void)
{
	while (nodecount > 0)
		Pop();
}

void FilterList::Display(void)
{
/*	struct Node *p;

	EDeityUI::Dialog *myFilters = CaptUI->CreateDialog();

	myFilters->set_type(EDeityUI::Dialog::List_Columned);

	EDeityUI::Dialog::Column colid[3];
	EDeityUI::Dialog::Row row;

	colid[0] = myFilters->add_column("Id");
	colid[1] = myFilters->add_column("Regex");
	colid[2] = myFilters->add_column("Count");

	for (p = Head; p != NULL; p = p->next)
	{
		row = myFilters.add_row();
		myFilters.add_item(row, colid[0], p->FilterID);
		myFilters.add_item(row, colid[1], p->filtercount);
		myFilters.add_item(row, colid[2], p->String);
		//sprintf(lbuf, " $2#Id: $7#%03ld $!| $2#Matches: $7#%04ld $4 $!| $2#Regex: $7#%s ", p->FilterID, p->filtercount, p->String);
	}

	myFilters->Run();

	CaptUI->RefreshCurrent();*/
}

/** class Filter **/
#define ___REGFILT(s) if (search_string (s, Text, (unsigned long) targets)) WillFilter |= true;
/*
#define ___REGFILT(s) if (polarity == positive) \
{ \
	if (regexec(&preg, s, 0, NULL, 0) != 0) \
		WillFilter |= true; \
} else \
{ \
	if (regexec(&preg, s, 0, NULL, 0) == 0) \
		WillFilter |= true; \
}
*/
bool Filter::PkgFiltered(pkgCache::PkgIterator I)
{
	bool WillFilter = false;
	pkgCache::VerIterator V = (*Cache)[I].CandidateVerIter(*Cache);
	pkgCache::VerIterator InstV = (*Cache)[I].InstVerIter(*Cache);

	if (targets & Pkg_Name)
		___REGFILT(I.Name());
	if (targets & Pkg_Section)
		if (I.Section())
			___REGFILT(I.Section());

	if (V.end() == false)
	{
		if (targets & Pkg_AvailVer)
			___REGFILT(V.VerStr());
		if (targets & Pkg_Priority)
			___REGFILT(V.PriorityType());
		if (targets & Pkg_ShortDesc)
			___REGFILT(Cache->GetPkgRecs().Lookup(V.FileList()).ShortDesc().c_str());
		if (targets & Pkg_LongDesc)
			___REGFILT(Cache->GetPkgRecs().Lookup(V.FileList()).LongDesc().c_str());
			
		if (targets & Pkg_Maintainer)
			___REGFILT(Cache->GetPkgRecs().Lookup(V.FileList()).Maintainer().c_str());
		if (targets & Pkg_FileName)
			___REGFILT(Cache->GetPkgRecs().Lookup(V.FileList()).FileName().c_str());
	}
	if (InstV.end() == false)
		if (targets & Pkg_InstlVer)
			___REGFILT(InstV.VerStr());

	return WillFilter;
}

//old Filter::Filter(const char *string, Target &targ)
Filter::Filter(const char *string, unsigned long targ)
{
	Text = strdup(string);
	ID = 1;
	Count = 0;
	polarity = positive;
	targets = targ;
//old	regcomp(&preg, string, REG_EXTENDED | REG_ICASE);
}

Filter::Filter()
{
	Text = NULL;
	ID = 1;
	Count = 0;
	polarity = positive;
//old	targets = (Target) 0;
	targets = 0;
}

Filter::~Filter()
{
	free(Text);
//old	regfree(&preg);
}

/** end class Filter */

/*
void filter_revoke_all(Screen *screen)
{
	if (screen->Packages->Filters->Length() == 0)
		return;

	screen->Packages->Filters->Audit();
	screen->Packages->reinitialize();

	screen->BoundsReset();
	screen->Redraw();
}

void filter_display_all(Screen *screen)
{
	if (screen->Packages->Filters->Length() == 0)
		return;

	screen->Packages->Filters->Display();

	screen->Redraw();
}

void filter_change_view(Screen *screen)
{
	if (screen->Packages->Filters->Length() == 0)
		return;

	screen->Packages->reinitialize();

	screen->BoundsReset();
	screen->Redraw();
}

void filter_add_single(Screen *screen)
{
	char *buf;
	Filter::Target targ;

	if (CaptUI->FilterSelect(&buf, &targ) == false)
		return;

	screen->Packages->Filters->Push(buf, targ);

	free(buf);

	if (screen->Packages->Filters->SimulateApply() == false)
	{
		CaptUI->ShowDialog(_("Filter Error"),
			_("\n"
			" The effect of your list of filters either: \n"
			"\n"
			" (i)  filters every package \n"
			" (ii) filters no packages \n"
			"\n"
			" Try and refine or expand your regular expression \n"));

		screen->Packages->Filters->Pop();

		screen->RefreshCurrent();

		return;
	}
	screen->Packages->apply_filters();
	screen->BoundsReset();

	screen->Redraw();
}
*/
