/* $Id: filters.h,v 1.8 2000/12/13 05:46:17 ltd Exp $ */
#ifndef _filter_H
#define _filter_H

#include <parsers/strutl.h>

#include <apt-pkg/cacheiterators.h>

//old #include <regex.h>

class PackageTree;
class Screen;
class Filter;
class FilterList;

class Filter
{
public:
	friend class FilterList;
	
	enum Polarity
	{
		negative=0, 
		positive=1
	};
	
	int Count;
	bool PkgFiltered(pkgCache::PkgIterator I);
//	inline void setpolarity(Polarity &p) { polarity = p; };
//	inline void addtarget(Target &targ) { int(targets) |= targ; };
	
	Filter();
//old	Filter(const char *, Target &);
	Filter(const char *, unsigned long);
	~Filter();
	
private:
	int ID;
	char *Text;
	Polarity polarity;
//old	Target 	targets;
	unsigned long targets;
//old	regex_t preg;
	Filter *next;
};

class FilterList
{	
protected:
	PackageTree *Owner;
	Filter *Head, *Tail;
	long nodecount;
public:
	// length of the list
	inline int Length() { return nodecount; };
	// List functions
//old	Filter *Push(const char *, Filter::Target);
	Filter *Push(const char *, unsigned long);
	void Pop();
	void Revoke(long Identifier);
	void Audit();
	bool IsPkgFiltered(pkgCache::PkgIterator);
	// Application operators
	void RedoLists(void);
	bool SimulateApply();
	// UI Helper Fuction
	void Display();
	FilterList(PackageTree *);
};

//old void filter_add_single(Screen *);
//old void filter_revoke_all(Screen *);
//old void filter_display_all(Screen *);
//old void filter_change_view(Screen *);

#endif

