/* $Id: pkgtreeitem.cc,v 1.2 2000/11/17 14:56:21 ltd Exp $ */
#include "pkgtree.h"
#include <fstream.h>


const char * PackageTree::Item::Size()
{
	int decpt, sign;

	return fcvt (Version()->Size, 0, &decpt, &sign);
}

const char * PackageTree::Item::Instsize()
{
	int decpt, sign;

	return fcvt (Version()->InstalledSize, 0, &decpt, &sign);
}

const char * PackageTree::Item::FileNames()
{
    static string filelist;
    string s;

    filelist.clear();

    string f = "/var/lib/dpkg/info/" + string(Name()) + ".list";
    if(FileExists(f)) {
	ifstream in(f.c_str());
	if (!in != 0) 
	    return "";
	while (in.eof() == false)	    {
		getline(in, s);
		filelist += s+"\n";
	}

	in >> filelist;
	return filelist.c_str();
    }
    filelist = _("The list of installed files is only available for installed packages");

    return filelist.c_str();
}

const char * PackageTree::Item::Information()
{
	static string info;
	
	info.clear ();
	
	info += "Package: "; info += Name(); info += "\n";
	info += "Priority: "; info += Priority(); info += "\n";
	info += "Section: "; info += Section(); info += "\n";
	info += "Installed-Size: "; info += Instsize(); info += "\n";
	info += "Maintainer: "; info += Maintainer(); info += "\n";
	info += "Source: "; info += SourcePkg(); info += "\n";
	info += "Architecture: "; info += Architecture(); info += "\n";
	info += "Source: "; info += SourcePkg(); info += "\n";
	
	return info.c_str ();
}
