
#include "pkgtree.h"

PackageTree::Item *PackageTree::Iterator::GetNext(PackageTree::Item *root)
{
	PackageTree::Item *w = root;
	if (w->child)
		if (w->IsExpanded())
			return w->child;
	do
	{
		if (w->next)
			return w->next;
		w = w->parent;
	}
	while (w);
	return NULL;
}

PackageTree::Item *PackageTree::Iterator::GetPrev(PackageTree::Item *root)
{
	PackageTree::Item *w = root;
	if (w->prev)
	{
		w = w->prev;
		while (w->child)
		{
			if (!w->IsExpanded())
				break;
			w = w->child;
			while (w->next)
				w = w->next;
		}
		return w;
	}
	else if (w->parent)
		return w->parent;
	else
		return NULL;
}

PackageTree::Item *PackageTree::Iterator::GetNextLinear(PackageTree::Item *root)
{
	PackageTree::Item *w = root;

	if (w->child)
		return w->child;
	do
	{
		if (w->next)
			return w->next;
		w = w->parent;
	}
	while (w);
	return NULL;
}

PackageTree::Item *PackageTree::Iterator::GetPrevLinear(PackageTree::Item *root)
{
	PackageTree::Item *w = root;
	if (w->prev)
	{
		w = w->prev;
		while (w->child)
		{
			w = w->child;
			while (w->next)
				w = w->next;
		}
		return w;
	}
	else if (w->parent)
		return w->parent;
	else
		return NULL;
}

PackageTree::Item *PackageTree::Iterator::MovePrev()
{
	where = GetPrev(where);
	return where;
}

PackageTree::Item *PackageTree::Iterator::MoveNext()
{
	where = GetNext(where);
	return where;
}

PackageTree::Item *PackageTree::Iterator::MovePrevLinear()
{
	where = GetPrevLinear(where);
	return where;
}

PackageTree::Item *PackageTree::Iterator::MoveNextLinear()
{
	where = GetNextLinear(where);
	return where;
}

PackageTree::Item *PackageTree::Iterator::operator +(int n)
{
	PackageTree::Item *x;
	int i;
	for (i = 0, x = where; x != 0 && i < n; x = GetNext(x), i++);
	return x;
}

PackageTree::Item *PackageTree::Iterator::operator -(int n)
{
	PackageTree::Item *x;
	int i;
	for (i = 0, x = where; x != 0 && i < n; x = GetPrev(x), i++);
	return x;
}

