
#ifndef _pkgtreeiterator_H
#define _pkgtreeiterator_H

class PackageTree;

class PackageTree::Iterator
{
private:
	PackageTree::Item *where;

public:
	// Look as if we are a PackageTree::Item
	inline operator PackageTree::Item & () { return *where; };
	inline operator PackageTree::Item * () { return where; };
	inline PackageTree::Item *operator -> () { return where; };

	inline void operator =(PackageTree::Iterator & B) { where = B.where; };
	inline void operator =(PackageTree::Item * B) { where = B; };
	
	void operator ++(int) { MoveNext(); };
	inline void operator ++() { operator ++(0); };
	void operator --(int) { MovePrev(); };
	inline void operator --() { operator --(0); };

	PackageTree::Item * operator +(int);
	PackageTree::Item * operator -(int);

	inline bool operator ==(PackageTree::Iterator & B) { return where == B.where; };
	inline bool operator !=(PackageTree::Iterator & B) { return where != B.where; };

	inline PackageTree::Item *prev() { return GetPrev(where); };
	inline PackageTree::Item *next() { return GetNext(where); };

	inline bool Invalid() { return where == 0; };

	// With expanded flag
	PackageTree::Item *GetNext(PackageTree::Item *);
	PackageTree::Item *GetPrev(PackageTree::Item *);
	PackageTree::Item *MovePrev();
	PackageTree::Item *MoveNext();

	// Without expanded flag
	PackageTree::Item *GetNextLinear(PackageTree::Item *);
	PackageTree::Item *GetPrevLinear(PackageTree::Item *);
	PackageTree::Item *MovePrevLinear();
	PackageTree::Item *MoveNextLinear();

	Iterator(PackageTree &Owner) { where = Owner.root; };
	Iterator(PackageTree::Item *head) { where = head; };
	Iterator() { where = 0; };
};

#endif // pkgtreeiterator_H
