/* $Id: screens.cc,v 1.16 2000/11/17 14:56:21 ltd Exp $ */
#include <std.h>
#include <list/filters.h>
#include <interface/edeityui.h>
#include <interface/screen.h>

// Begin "ScreenList" class functions

ScreenList::ScreenList()
{
	_head = _current = NULL;
	ScreenCount = 0;
}

ScreenList::~ScreenList()
{
	Screen *x, *y;
	for (x = _head; x != NULL; x = y)
	{
		y = x->next;
		remove(x);
	}
}

Screen *ScreenList::add(Screen::ScrInit Op, Screen::ScrFunc Func)
{
	Screen *p;
	
	if (_current == NULL)
	{
		_current = CaptUI->CreateScreen(Op, Func);
		_head = _current;
	}
	else
	{
		p = _current->next;
		_current->next = CaptUI->CreateScreen(Op, Func);
		_current->next->next = p;
		_current->next->prev = _current;
		_current = _current->next;
	}

	++ScreenCount;

	return _current;
}

void ScreenList::remove(Screen *s)
{
	Screen *x, *y;

	x = s->next;
	y = s->prev;

	delete s;

	if (x != NULL)
		x->prev = y;
	if (y != NULL)
		y->next = x;

	--ScreenCount;
}

void ScreenList::AlignAllBounds()
{
	for(Screen *S = _head; S != NULL; S = S->next)
		S->BoundsReset();
}

