/* $Id: screens.h,v 1.14 2001/05/15 08:32:58 ltd Exp $ */
#ifndef _SCREEN_LIST_H
#define _SCREEN_LIST_H

#include <interface/screen.h>

class ScreenList
{
	public:
		friend class Screen;

		void AlignAllBounds();
		Screen *add(Screen::ScrInit Op = Screen::PkgInit, Screen::ScrFunc Func = Screen::PkgList);
		void remove(Screen *);

		// List Accessors
		inline Screen *Head() { return _head; };
		inline Screen *Current() { return _current; }; // <--- VERY EVIL

		// Sanity has been checked --Pat
		void SetCurrent(Screen *s) { _current = s; };

		inline void MoveNext() { if (_current) _current = _current->next; }
		inline void MovePrev() { if (_current) _current = _current->prev; }

		inline Screen *ListStart() { return _head; };

		inline int length() { return ScreenCount; };

		ScreenList();
		~ScreenList();

	protected:
		int ScreenCount;
		Screen *_head, *_current;
};

#endif
