
#ifndef _sources_H
#define _sources_H

// Inspired by stormpkg, but a from-scratch implementation

#include <string>

class SourcesList {
public:
	enum RecType { 
		Deb = 1 << 0, 
		DebSrc = 1 << 1, 
		Disabled = 1 << 2,
		Comment = 1 << 3
	};

	struct SourceRecord {
		unsigned char Type;
		string URI;
		string Dist;
		string *Sections;
		unsigned short NumSections;
		string Comment;

		SourceRecord *prev, *next;

		bool SetType(string);
		bool SetURI(string);

		SourceRecord() : Type(0), Sections(0), NumSections(0), prev(0), next(0) {};
		~SourceRecord() { if (Sections) delete[] Sections; };
		SourceRecord &operator=(const SourceRecord &);
	};

private:
	SourceRecord *head, *tail;
	void AddNode(SourceRecord &);

public:
	SourceRecord *AddSource(RecType Type, string URI, string Dist, string *Sections, unsigned short count);
	void RemoveSource(SourceRecord *&);
	bool ReadSources();
	bool UpdateSources();

	inline SourceRecord *Head() { return head; }

	SourcesList() : head(0), tail(0) {};
	~SourcesList();
};

//old ostream &operator <<(ostream &, const SourcesList::SourceRecord &);

#endif
