/* $Id: strutl.cc,v 1.9 2001/06/22 14:59:17 ltd Exp $ */

#include <std.h>
//old #include <cstdarg>
//old #include <regex.h>
#include "strutl.h"

/*
 * Remember to free this memory
 */
char *period_string(const char *string, unsigned count)
{
	char *Newstr = new char[count + 1];

	memcpy(Newstr, string, count);
	Newstr[count] = 0;

	return Newstr;
}		

void strlower(char * str)
{
	char *p;
	for (p=str; *p != '\0'; p++) *p = tolower(*p);
}

char *sane_strtok(char *s, const char *delim)
{
	static char *_s;
	char *p, *x;

	if (s != NULL)
		_s = s;

	if (_s == NULL)
		return NULL;

	if ((p = strstr(_s, delim)) == NULL)
	{
		p = _s;
		_s = NULL;
		return p;
	}
	x = _s;
	*p = 0;
	_s = ++p;
	return x;
}

/*
 * Assuming dest has enough memory to hold len bytes of src
 */
void sane_strntrnc(char *dest, const char *src, unsigned int len)
{
	if (strlen(src) < len)
	{
		memcpy(dest, src, strlen(src));
		dest[strlen(src)] = 0;
	}
	else
	{
		memcpy(dest, src, len);
		dest[len] = 0;
	}
}

/* 
 * returns a pointer to a static buffer with a copy of the origstr, with any
 * color codes removed. The caller should not free the returned string!
 */
 
char *stripcolorcodes(const char *origstr)
{
	static char retbuf[1024];
	const char *p = origstr;
	unsigned int i = 0;

	while (i < sizeof retbuf) {
		if (*p == '$' && *(p+1) != 0 && *(p+2) == '#') {
			p += 3;
			continue;
		}
		if (*p == '$' && *(p+1) == '!') {
			p += 2;
			continue;
		}
		retbuf[i] = *p;

		if (*p == 0) break;
		p++;
		i++;
	}

	return retbuf;
}

/*

int d_asprintf(char **buf, const char *fmt, ...)
{
	va_list va;
	int b_size = 0;
	int d;
	char c, *s;
	
	va_start(va, fmt);

	while (*fmt) 
	{
		if (*fmt == '%') 
		{
			switch (*++fmt)
			{
			case 's':
				s = va_arg(va, char *);
				*buf = realloc(*buf, b_size + strlen(s));
				memcpy(*buf + b_size, s, strlen(s));
				b_size += strlen(s);
				break;
			case 'd':
			case 'i':
				break;
			case 'c':
				c = (char) va_arg(va, int); 
				*buf = realloc(*buf, ++b_size);
				*(*buf + b_size - 1) = c;
				break;
			}
		}
		else
		{
			*buf = realloc(*buf, ++b_size)
			*(*buf + b_size - 1) = *fmt;
		}
	}

	*buf = realloc(*buf, ++b_size);
	*(*buf + b_size - 1) = 0;

	va_end(va);
}
*/

//old int search_string(const char *haystack, char *needle, unsigned long options, regex_t * rectx)
int search_string(const char *haystack, char *needle, unsigned long options)
{
    int ret;
    char *hay = (char *) malloc (1024), *instr;

#define RET(x) {free(hay); return(x); }

   if (options & Cmp_Regex/*SEARCH_REGEX*/) 
   {
	regex_t rectx;
	int reflags = REG_EXTENDED | REG_NOSUB;

	if (options & Cmp_Case /*SEARCH_CASE*/)
		reflags |= REG_ICASE;

	regcomp(&rectx, needle, reflags);
	ret = (int)!regexec(&rectx, haystack, 0, NULL, 0);
	
	regfree(&rectx);

//old	return (int)!regexec(rectx, haystack, 0, NULL, 0);
       RET (ret)
   } 
   else if (options & Cmp_Case /*SEARCH_CASE*/) 
   {
//old  char * hay = strdup(haystack);
       strcpy(hay, haystack);

       // needle must already be lower-case
       strlower(needle);
       strlower(hay);
//old  ret = (int)strstr(hay, needle); 

//old  free(hay);
//old  return ret;
   } 
   else 
   {
       strcpy(hay, haystack);
//old  return (int)strstr(haystack, needle);
   }   
   
    if (options & (Cmp_Eq /*SEARCH_EQUAL*/ | Cmp_NEq /*SEARCH_NOTEQUAL*/ | Cmp_Less /*SEARCH_LESS*/ | Cmp_Great /*SEARCH_GREATER*/))
    {
		ret = strcmp (hay, needle);
	
		if ((options & Cmp_Eq /*SEARCH_EQUAL*/) && (ret == 0)) RET (true)
		if ((options & Cmp_NEq /*SEARCH_NOTEQUAL*/)  && (ret != 0)) RET (true)
	
		if ((options & Cmp_Less /*SEARCH_LESS*/) && (ret < 0)) RET (true)
		if ((options & Cmp_Great /*SEARCH_GREATER*/) && (ret >0)) RET (true)
		
		RET (false)
    }
    
    instr = strstr (hay, needle);
    
    if ((options & Cmp_Cont /*SEARCH_CONT*/) && instr) RET (true)
   	if ((options & Cmp_NCont /*SEARCH_NOTCONT*/)  && !instr) RET (true)

    RET (false)
}

int get_line (FILE *stream, char* s)
{ 
	    int i = 0;
	    char c = 0;


        for (c = fgetc (stream); !((c == EOF) || (iscntrl (c))); c = fgetc (stream)) s[i++] = c;
	s[i] = 0;
	
	if (c == EOF) return EOF;
	
    return EXIT_SUCCESS;
}  
